#if HIGHCTIDH_PORTABLE == 1
#include "fiat_p511.h"
/* Autogenerated: './src/ExtractionOCaml/word_by_word_montgomery' --internal-static --lang C -o fiat_p511.c p511 64 5326738796327623094747867617954605554069371494832722337612446642054009560026576537626892113026381253624626941643949444792662881241621373288942880288065659 */
/* curve description: p511 */
/* machine_wordsize = 64 (from "64") */
/* requested operations: (all) */
/* m = 0x65b48e8f740f89bffc8ab0d15e3e4c4ab42d083aedc88c425afbfcc69322c9cda7aac6c567f35507516730cc1f0b4f25c2721bf457aca8351b81b90533c6c87b (from "5326738796327623094747867617954605554069371494832722337612446642054009560026576537626892113026381253624626941643949444792662881241621373288942880288065659") */
/*                                                                    */
/* NOTE: In addition to the bounds specified above each function, all */
/*   functions synthesized for this Montgomery arithmetic require the */
/*   input to be strictly less than the prime modulus (m), and also   */
/*   require the input to be in the unique saturated representation.  */
/*   All functions also ensure that these two properties are true of  */
/*   return values.                                                   */
/*  */
/* Computed values: */
/*   eval z = z[0] + (z[1] << 64) + (z[2] << 128) + (z[3] << 192) + (z[4] << 256) + (z[5] << 0x140) + (z[6] << 0x180) + (z[7] << 0x1c0) */
/*   bytes_eval z = z[0] + (z[1] << 8) + (z[2] << 16) + (z[3] << 24) + (z[4] << 32) + (z[5] << 40) + (z[6] << 48) + (z[7] << 56) + (z[8] << 64) + (z[9] << 72) + (z[10] << 80) + (z[11] << 88) + (z[12] << 96) + (z[13] << 104) + (z[14] << 112) + (z[15] << 120) + (z[16] << 128) + (z[17] << 136) + (z[18] << 144) + (z[19] << 152) + (z[20] << 160) + (z[21] << 168) + (z[22] << 176) + (z[23] << 184) + (z[24] << 192) + (z[25] << 200) + (z[26] << 208) + (z[27] << 216) + (z[28] << 224) + (z[29] << 232) + (z[30] << 240) + (z[31] << 248) + (z[32] << 256) + (z[33] << 0x108) + (z[34] << 0x110) + (z[35] << 0x118) + (z[36] << 0x120) + (z[37] << 0x128) + (z[38] << 0x130) + (z[39] << 0x138) + (z[40] << 0x140) + (z[41] << 0x148) + (z[42] << 0x150) + (z[43] << 0x158) + (z[44] << 0x160) + (z[45] << 0x168) + (z[46] << 0x170) + (z[47] << 0x178) + (z[48] << 0x180) + (z[49] << 0x188) + (z[50] << 0x190) + (z[51] << 0x198) + (z[52] << 0x1a0) + (z[53] << 0x1a8) + (z[54] << 0x1b0) + (z[55] << 0x1b8) + (z[56] << 0x1c0) + (z[57] << 0x1c8) + (z[58] << 0x1d0) + (z[59] << 0x1d8) + (z[60] << 0x1e0) + (z[61] << 0x1e8) + (z[62] << 0x1f0) + (z[63] << 0x1f8) */
/*   twos_complement_eval z = let x1 := z[0] + (z[1] << 64) + (z[2] << 128) + (z[3] << 192) + (z[4] << 256) + (z[5] << 0x140) + (z[6] << 0x180) + (z[7] << 0x1c0) in */
/*                            if x1 & (2^512-1) < 2^511 then x1 & (2^512-1) else (x1 & (2^512-1)) - 2^512 */


/* The type fiat_p511_montgomery_domain_field_element is a field element in the Montgomery domain. */
/* Bounds: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]] */
typedef uint64_t fiat_p511_montgomery_domain_field_element[8];

/* The type fiat_p511_non_montgomery_domain_field_element is a field element NOT in the Montgomery domain. */
/* Bounds: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]] */
typedef uint64_t fiat_p511_non_montgomery_domain_field_element[8];

#if (-1 & 3) != 3
#error "This code only works on a two's complement system"
#endif


/*
 * The function fiat_p511_addcarryx_u64 is an addition with carry.
 *
 * Postconditions:
 *   out1 = (arg1 + arg2 + arg3) mod 2^64
 *   out2 = ⌊(arg1 + arg2 + arg3) / 2^64⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 *   out2: [0x0 ~> 0x1]
 */

/*
 * The function fiat_p511_subborrowx_u64 is a subtraction with borrow.
 *
 * Postconditions:
 *   out1 = (-arg1 + arg2 + -arg3) mod 2^64
 *   out2 = -⌊(-arg1 + arg2 + -arg3) / 2^64⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 *   out2: [0x0 ~> 0x1]
 */


/*
 * The function fiat_p511_mulx_u64 is a multiplication, returning the full double-width result.
 *
 * Postconditions:
 *   out1 = (arg1 * arg2) mod 2^64
 *   out2 = ⌊arg1 * arg2 / 2^64⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0xffffffffffffffff]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 *   out2: [0x0 ~> 0xffffffffffffffff]
 */


/*
 * The function fiat_p511_cmovznz_u64 is a single-word conditional move.
 *
 * Postconditions:
 *   out1 = (if arg1 = 0 then arg2 else arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 */
static inline void fiat_p511_cmovznz_u64(uint64_t* out1, const fiat_p511_uint1 arg1, const uint64_t arg2, const uint64_t arg3) __attribute__((always_inline));
static inline void fiat_p511_cmovznz_u64(uint64_t* out1, const fiat_p511_uint1 arg1, const uint64_t arg2, const uint64_t arg3) {
	const uint64_t x2 = (fiat_p511_int1)(0x0 - (!(!arg1)));
	*out1 = ((x2 & arg3) | ((~x2) & arg2));
}

/*
 * The function fiat_p511_mul multiplies two field elements in the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg2)) mod m
 *   0 ≤ eval out1 < m
 *
 */
void fiat_p511_mul(fiat_p511_montgomery_domain_field_element out1, const fiat_p511_montgomery_domain_field_element arg1, const fiat_p511_montgomery_domain_field_element arg2) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  uint64_t x10;
  uint64_t x23;
  uint64_t x24;
  uint64_t x25;
  uint64_t x27;
  uint64_t x29;
  uint64_t x31;
  uint64_t x33;
  uint64_t x35;
  uint64_t x37;
  fiat_p511_uint1 x38;
  uint64_t x39;
  uint64_t x41;
  uint64_t x43;
  uint64_t x45;
  uint64_t x47;
  uint64_t x49;
  uint64_t x51;
  uint64_t x53;
  uint64_t x55;
  uint64_t x56;
  uint64_t x57;
  uint64_t x58;
  uint64_t x60;
  uint64_t x62;
  uint64_t x64;
  uint64_t x66;
  uint64_t x68;
  uint64_t x70;
  fiat_p511_uint1 x71;
  uint64_t x72;
  uint64_t x73;
  uint64_t x75;
  uint64_t x77;
  uint64_t x79;
  uint64_t x81;
  uint64_t x83;
  uint64_t x85;
  uint64_t x87;
  uint64_t x89;
  fiat_p511_uint1 x90;
  uint64_t x92;
  uint64_t x102;
  uint64_t x103;
  uint64_t x104;
  uint64_t x105;
  uint64_t x106;
  uint64_t x107;
  fiat_p511_uint1 x108;
  uint64_t x109;
  fiat_p511_uint1 x110;
  uint64_t x111;
  fiat_p511_uint1 x112;
  uint64_t x113;
  fiat_p511_uint1 x114;
  uint64_t x115;
  fiat_p511_uint1 x116;
  uint64_t x117;
  fiat_p511_uint1 x118;
  uint64_t x119;
  fiat_p511_uint1 x120;
  uint64_t x121;
  uint64_t x122;
  fiat_p511_uint1 x123;
  uint64_t x124;
  fiat_p511_uint1 x125;
  uint64_t x126;
  fiat_p511_uint1 x127;
  uint64_t x128;
  fiat_p511_uint1 x129;
  uint64_t x130;
  fiat_p511_uint1 x131;
  uint64_t x132;
  fiat_p511_uint1 x133;
  uint64_t x134;
  fiat_p511_uint1 x135;
  uint64_t x136;
  fiat_p511_uint1 x137;
  uint64_t x138;
  fiat_p511_uint1 x139;
  uint64_t x140;
  uint64_t x141;
  uint64_t x142;
  uint64_t x143;
  uint64_t x144;
  uint64_t x145;
  uint64_t x146;
  uint64_t x147;
  uint64_t x148;
  uint64_t x149;
  uint64_t x150;
  uint64_t x151;
  uint64_t x152;
  uint64_t x153;
  uint64_t x154;
  uint64_t x155;
  uint64_t x156;
  uint64_t x157;
  uint64_t x158;
  fiat_p511_uint1 x159;
  uint64_t x160;
  fiat_p511_uint1 x161;
  uint64_t x162;
  fiat_p511_uint1 x163;
  uint64_t x164;
  fiat_p511_uint1 x165;
  uint64_t x166;
  fiat_p511_uint1 x167;
  uint64_t x168;
  fiat_p511_uint1 x169;
  uint64_t x170;
  fiat_p511_uint1 x171;
  uint64_t x172;
  uint64_t x173;
  fiat_p511_uint1 x174;
  uint64_t x175;
  fiat_p511_uint1 x176;
  uint64_t x177;
  fiat_p511_uint1 x178;
  uint64_t x179;
  fiat_p511_uint1 x180;
  uint64_t x181;
  fiat_p511_uint1 x182;
  uint64_t x183;
  fiat_p511_uint1 x184;
  uint64_t x185;
  fiat_p511_uint1 x186;
  uint64_t x187;
  fiat_p511_uint1 x188;
  uint64_t x189;
  fiat_p511_uint1 x190;
  uint64_t x191;
  uint64_t x192;
  uint64_t x193;
  uint64_t x194;
  uint64_t x195;
  uint64_t x196;
  uint64_t x197;
  uint64_t x198;
  uint64_t x199;
  uint64_t x200;
  uint64_t x201;
  uint64_t x202;
  uint64_t x203;
  uint64_t x204;
  uint64_t x205;
  uint64_t x206;
  uint64_t x207;
  uint64_t x208;
  fiat_p511_uint1 x209;
  uint64_t x210;
  fiat_p511_uint1 x211;
  uint64_t x212;
  fiat_p511_uint1 x213;
  uint64_t x214;
  fiat_p511_uint1 x215;
  uint64_t x216;
  fiat_p511_uint1 x217;
  uint64_t x218;
  fiat_p511_uint1 x219;
  uint64_t x220;
  fiat_p511_uint1 x221;
  uint64_t x223;
  uint64_t x225;
  uint64_t x227;
  uint64_t x229;
  uint64_t x231;
  fiat_p511_uint1 x232;
  uint64_t x233;
  uint64_t x235;
  fiat_p511_uint1 x236;
  uint64_t x237;
  fiat_p511_uint1 x238;
  uint64_t x239;
  fiat_p511_uint1 x240;
  uint64_t x241;
  uint64_t x242;
  uint64_t x243;
  uint64_t x244;
  uint64_t x245;
  uint64_t x246;
  uint64_t x247;
  uint64_t x248;
  uint64_t x249;
  uint64_t x250;
  uint64_t x251;
  uint64_t x252;
  uint64_t x253;
  uint64_t x254;
  uint64_t x255;
  uint64_t x256;
  uint64_t x257;
  uint64_t x258;
  uint64_t x259;
  fiat_p511_uint1 x260;
  uint64_t x261;
  fiat_p511_uint1 x262;
  uint64_t x263;
  fiat_p511_uint1 x264;
  uint64_t x265;
  fiat_p511_uint1 x266;
  uint64_t x267;
  fiat_p511_uint1 x268;
  uint64_t x269;
  fiat_p511_uint1 x270;
  uint64_t x271;
  fiat_p511_uint1 x272;
  uint64_t x273;
  uint64_t x274;
  fiat_p511_uint1 x275;
  uint64_t x276;
  fiat_p511_uint1 x277;
  uint64_t x278;
  fiat_p511_uint1 x279;
  uint64_t x280;
  fiat_p511_uint1 x281;
  uint64_t x282;
  fiat_p511_uint1 x283;
  uint64_t x284;
  fiat_p511_uint1 x285;
  uint64_t x286;
  fiat_p511_uint1 x287;
  uint64_t x288;
  fiat_p511_uint1 x289;
  uint64_t x290;
  fiat_p511_uint1 x291;
  uint64_t x292;
  uint64_t x293;
  uint64_t x294;
  uint64_t x295;
  uint64_t x296;
  uint64_t x297;
  uint64_t x298;
  uint64_t x299;
  uint64_t x300;
  uint64_t x301;
  uint64_t x302;
  uint64_t x303;
  uint64_t x304;
  uint64_t x305;
  uint64_t x306;
  uint64_t x307;
  uint64_t x308;
  uint64_t x309;
  fiat_p511_uint1 x310;
  uint64_t x311;
  fiat_p511_uint1 x312;
  uint64_t x313;
  fiat_p511_uint1 x314;
  uint64_t x315;
  fiat_p511_uint1 x316;
  uint64_t x317;
  fiat_p511_uint1 x318;
  uint64_t x319;
  fiat_p511_uint1 x320;
  uint64_t x321;
  fiat_p511_uint1 x322;
  uint64_t x323;
  uint64_t x324;
  fiat_p511_uint1 x325;
  uint64_t x326;
  fiat_p511_uint1 x327;
  uint64_t x328;
  fiat_p511_uint1 x329;
  uint64_t x330;
  fiat_p511_uint1 x331;
  uint64_t x332;
  fiat_p511_uint1 x333;
  uint64_t x334;
  fiat_p511_uint1 x335;
  uint64_t x336;
  fiat_p511_uint1 x337;
  uint64_t x338;
  fiat_p511_uint1 x339;
  uint64_t x340;
  fiat_p511_uint1 x341;
  uint64_t x342;
  uint64_t x343;
  uint64_t x344;
  uint64_t x345;
  uint64_t x346;
  uint64_t x347;
  uint64_t x348;
  uint64_t x349;
  uint64_t x350;
  uint64_t x351;
  uint64_t x352;
  uint64_t x353;
  uint64_t x354;
  uint64_t x355;
  uint64_t x356;
  uint64_t x357;
  uint64_t x358;
  uint64_t x359;
  uint64_t x360;
  fiat_p511_uint1 x361;
  uint64_t x362;
  fiat_p511_uint1 x363;
  uint64_t x364;
  fiat_p511_uint1 x365;
  uint64_t x366;
  fiat_p511_uint1 x367;
  uint64_t x368;
  fiat_p511_uint1 x369;
  uint64_t x370;
  fiat_p511_uint1 x371;
  uint64_t x372;
  fiat_p511_uint1 x373;
  uint64_t x374;
  uint64_t x375;
  fiat_p511_uint1 x376;
  uint64_t x377;
  fiat_p511_uint1 x378;
  uint64_t x379;
  fiat_p511_uint1 x380;
  uint64_t x381;
  fiat_p511_uint1 x382;
  uint64_t x383;
  fiat_p511_uint1 x384;
  uint64_t x385;
  fiat_p511_uint1 x386;
  uint64_t x387;
  fiat_p511_uint1 x388;
  uint64_t x389;
  fiat_p511_uint1 x390;
  uint64_t x391;
  fiat_p511_uint1 x392;
  uint64_t x393;
  uint64_t x394;
  uint64_t x395;
  uint64_t x396;
  uint64_t x397;
  uint64_t x398;
  uint64_t x399;
  uint64_t x400;
  uint64_t x401;
  uint64_t x402;
  uint64_t x403;
  uint64_t x404;
  uint64_t x405;
  uint64_t x406;
  uint64_t x407;
  uint64_t x408;
  uint64_t x409;
  uint64_t x410;
  fiat_p511_uint1 x411;
  uint64_t x412;
  fiat_p511_uint1 x413;
  uint64_t x414;
  fiat_p511_uint1 x415;
  uint64_t x416;
  fiat_p511_uint1 x417;
  uint64_t x418;
  fiat_p511_uint1 x419;
  uint64_t x420;
  fiat_p511_uint1 x421;
  uint64_t x422;
  fiat_p511_uint1 x423;
  uint64_t x424;
  uint64_t x425;
  fiat_p511_uint1 x426;
  uint64_t x427;
  fiat_p511_uint1 x428;
  uint64_t x429;
  fiat_p511_uint1 x430;
  uint64_t x431;
  fiat_p511_uint1 x432;
  uint64_t x433;
  fiat_p511_uint1 x434;
  uint64_t x435;
  fiat_p511_uint1 x436;
  uint64_t x437;
  fiat_p511_uint1 x438;
  uint64_t x439;
  fiat_p511_uint1 x440;
  uint64_t x441;
  fiat_p511_uint1 x442;
  uint64_t x443;
  uint64_t x444;
  uint64_t x445;
  uint64_t x446;
  uint64_t x447;
  uint64_t x448;
  uint64_t x449;
  uint64_t x450;
  uint64_t x451;
  uint64_t x452;
  uint64_t x453;
  uint64_t x454;
  uint64_t x455;
  uint64_t x456;
  uint64_t x457;
  uint64_t x458;
  uint64_t x459;
  uint64_t x460;
  uint64_t x461;
  fiat_p511_uint1 x462;
  uint64_t x463;
  fiat_p511_uint1 x464;
  uint64_t x465;
  fiat_p511_uint1 x466;
  uint64_t x467;
  fiat_p511_uint1 x468;
  uint64_t x469;
  fiat_p511_uint1 x470;
  uint64_t x471;
  fiat_p511_uint1 x472;
  uint64_t x473;
  fiat_p511_uint1 x474;
  uint64_t x475;
  uint64_t x476;
  fiat_p511_uint1 x477;
  uint64_t x478;
  fiat_p511_uint1 x479;
  uint64_t x480;
  fiat_p511_uint1 x481;
  uint64_t x482;
  fiat_p511_uint1 x483;
  uint64_t x484;
  fiat_p511_uint1 x485;
  uint64_t x486;
  fiat_p511_uint1 x487;
  uint64_t x488;
  fiat_p511_uint1 x489;
  uint64_t x490;
  fiat_p511_uint1 x491;
  uint64_t x492;
  fiat_p511_uint1 x493;
  uint64_t x494;
  uint64_t x495;
  uint64_t x496;
  uint64_t x497;
  uint64_t x498;
  uint64_t x499;
  uint64_t x500;
  uint64_t x501;
  uint64_t x502;
  uint64_t x503;
  uint64_t x504;
  uint64_t x505;
  uint64_t x506;
  uint64_t x507;
  uint64_t x508;
  uint64_t x509;
  uint64_t x510;
  uint64_t x511;
  fiat_p511_uint1 x512;
  uint64_t x513;
  fiat_p511_uint1 x514;
  uint64_t x515;
  fiat_p511_uint1 x516;
  uint64_t x517;
  fiat_p511_uint1 x518;
  uint64_t x519;
  fiat_p511_uint1 x520;
  uint64_t x521;
  fiat_p511_uint1 x522;
  uint64_t x523;
  fiat_p511_uint1 x524;
  uint64_t x525;
  uint64_t x526;
  fiat_p511_uint1 x527;
  uint64_t x528;
  fiat_p511_uint1 x529;
  uint64_t x530;
  fiat_p511_uint1 x531;
  uint64_t x532;
  fiat_p511_uint1 x533;
  uint64_t x534;
  fiat_p511_uint1 x535;
  uint64_t x536;
  fiat_p511_uint1 x537;
  uint64_t x538;
  fiat_p511_uint1 x539;
  uint64_t x540;
  fiat_p511_uint1 x541;
  uint64_t x542;
  fiat_p511_uint1 x543;
  uint64_t x544;
  uint64_t x545;
  uint64_t x546;
  uint64_t x547;
  uint64_t x548;
  uint64_t x549;
  uint64_t x550;
  uint64_t x551;
  uint64_t x552;
  uint64_t x553;
  uint64_t x554;
  uint64_t x555;
  uint64_t x556;
  uint64_t x557;
  uint64_t x558;
  uint64_t x559;
  uint64_t x560;
  uint64_t x561;
  uint64_t x562;
  fiat_p511_uint1 x563;
  uint64_t x564;
  fiat_p511_uint1 x565;
  uint64_t x566;
  fiat_p511_uint1 x567;
  uint64_t x568;
  fiat_p511_uint1 x569;
  uint64_t x570;
  fiat_p511_uint1 x571;
  uint64_t x572;
  fiat_p511_uint1 x573;
  uint64_t x574;
  fiat_p511_uint1 x575;
  uint64_t x576;
  uint64_t x577;
  fiat_p511_uint1 x578;
  uint64_t x579;
  fiat_p511_uint1 x580;
  uint64_t x581;
  fiat_p511_uint1 x582;
  uint64_t x583;
  fiat_p511_uint1 x584;
  uint64_t x585;
  fiat_p511_uint1 x586;
  uint64_t x587;
  fiat_p511_uint1 x588;
  uint64_t x589;
  fiat_p511_uint1 x590;
  uint64_t x591;
  fiat_p511_uint1 x592;
  uint64_t x593;
  fiat_p511_uint1 x594;
  uint64_t x595;
  uint64_t x596;
  uint64_t x597;
  uint64_t x598;
  uint64_t x599;
  uint64_t x600;
  uint64_t x601;
  uint64_t x602;
  uint64_t x603;
  uint64_t x604;
  uint64_t x605;
  uint64_t x606;
  uint64_t x607;
  uint64_t x608;
  uint64_t x609;
  uint64_t x610;
  uint64_t x611;
  uint64_t x612;
  fiat_p511_uint1 x613;
  uint64_t x614;
  fiat_p511_uint1 x615;
  uint64_t x616;
  fiat_p511_uint1 x617;
  uint64_t x618;
  fiat_p511_uint1 x619;
  uint64_t x620;
  fiat_p511_uint1 x621;
  uint64_t x622;
  fiat_p511_uint1 x623;
  uint64_t x624;
  fiat_p511_uint1 x625;
  uint64_t x626;
  uint64_t x627;
  fiat_p511_uint1 x628;
  uint64_t x629;
  fiat_p511_uint1 x630;
  uint64_t x631;
  fiat_p511_uint1 x632;
  uint64_t x633;
  fiat_p511_uint1 x634;
  uint64_t x635;
  fiat_p511_uint1 x636;
  uint64_t x637;
  fiat_p511_uint1 x638;
  uint64_t x639;
  fiat_p511_uint1 x640;
  uint64_t x641;
  fiat_p511_uint1 x642;
  uint64_t x643;
  fiat_p511_uint1 x644;
  uint64_t x645;
  uint64_t x646;
  uint64_t x647;
  uint64_t x648;
  uint64_t x649;
  uint64_t x650;
  uint64_t x651;
  uint64_t x652;
  uint64_t x653;
  uint64_t x654;
  uint64_t x655;
  uint64_t x656;
  uint64_t x657;
  uint64_t x658;
  uint64_t x659;
  uint64_t x660;
  uint64_t x661;
  uint64_t x662;
  uint64_t x663;
  fiat_p511_uint1 x664;
  uint64_t x665;
  fiat_p511_uint1 x666;
  uint64_t x667;
  fiat_p511_uint1 x668;
  uint64_t x669;
  fiat_p511_uint1 x670;
  uint64_t x671;
  fiat_p511_uint1 x672;
  uint64_t x673;
  fiat_p511_uint1 x674;
  uint64_t x675;
  fiat_p511_uint1 x676;
  uint64_t x677;
  uint64_t x678;
  fiat_p511_uint1 x679;
  uint64_t x680;
  fiat_p511_uint1 x681;
  uint64_t x682;
  fiat_p511_uint1 x683;
  uint64_t x684;
  fiat_p511_uint1 x685;
  uint64_t x686;
  fiat_p511_uint1 x687;
  uint64_t x688;
  fiat_p511_uint1 x689;
  uint64_t x690;
  fiat_p511_uint1 x691;
  uint64_t x692;
  fiat_p511_uint1 x693;
  uint64_t x694;
  fiat_p511_uint1 x695;
  uint64_t x696;
  uint64_t x697;
  uint64_t x698;
  uint64_t x699;
  uint64_t x700;
  uint64_t x701;
  uint64_t x702;
  uint64_t x703;
  uint64_t x704;
  uint64_t x705;
  uint64_t x706;
  uint64_t x707;
  uint64_t x708;
  uint64_t x709;
  uint64_t x710;
  uint64_t x711;
  uint64_t x712;
  uint64_t x713;
  fiat_p511_uint1 x714;
  uint64_t x715;
  fiat_p511_uint1 x716;
  uint64_t x717;
  fiat_p511_uint1 x718;
  uint64_t x719;
  fiat_p511_uint1 x720;
  uint64_t x721;
  fiat_p511_uint1 x722;
  uint64_t x723;
  fiat_p511_uint1 x724;
  uint64_t x725;
  fiat_p511_uint1 x726;
  uint64_t x727;
  fiat_p511_uint1 x729;
  fiat_p511_uint1 x731;
  fiat_p511_uint1 x733;
  fiat_p511_uint1 x735;
  fiat_p511_uint1 x737;
  fiat_p511_uint1 x739;
  fiat_p511_uint1 x741;
  fiat_p511_uint1 x743;
  fiat_p511_uint1 x745;
  uint64_t x748;
  uint64_t x749;
  uint64_t x750;
  uint64_t x751;
  uint64_t x752;
  uint64_t x753;
  uint64_t x754;
  uint64_t x755;
  uint64_t x756;
  uint64_t x757;
  uint64_t x758;
  uint64_t x759;
  uint64_t x760;
  uint64_t x761;
  uint64_t x762;
  uint64_t x763;
  uint64_t x764;
  fiat_p511_uint1 x765;
  uint64_t x766;
  fiat_p511_uint1 x767;
  uint64_t x768;
  fiat_p511_uint1 x769;
  uint64_t x770;
  fiat_p511_uint1 x771;
  uint64_t x772;
  fiat_p511_uint1 x773;
  uint64_t x774;
  fiat_p511_uint1 x775;
  uint64_t x776;
  fiat_p511_uint1 x777;
  uint64_t x778;
  uint64_t x779;
  fiat_p511_uint1 x780;
  uint64_t x781;
  fiat_p511_uint1 x782;
  uint64_t x783;
  fiat_p511_uint1 x784;
  uint64_t x785;
  fiat_p511_uint1 x786;
  uint64_t x787;
  fiat_p511_uint1 x788;
  uint64_t x789;
  fiat_p511_uint1 x790;
  uint64_t x791;
  fiat_p511_uint1 x792;
  uint64_t x793;
  fiat_p511_uint1 x794;
  uint64_t x795;
  fiat_p511_uint1 x796;
  uint64_t x797;
  fiat_p511_uint1 x799;
  fiat_p511_uint1 x801;
  fiat_p511_uint1 x803;
  fiat_p511_uint1 x805;
  fiat_p511_uint1 x807;
  fiat_p511_uint1 x809;
  fiat_p511_uint1 x811;
  fiat_p511_uint1 x813;
  fiat_p511_uint1 x815;
  uint64_t x816;
  uint64_t x817;
  uint64_t x818;
  uint64_t x819;
  uint64_t x820;
  uint64_t x821;
  uint64_t x822;
  uint64_t x823;
  x1 = (arg1[1]);
  x2 = (arg1[2]);
  x3 = (arg1[3]);
  x4 = (arg1[4]);
  x5 = (arg1[5]);
  x6 = (arg1[6]);
  x7 = (arg1[7]);
  x8 = (arg1[0]);
  {
  uint64_t x9;
  uint64_t x11;
  uint64_t x12;
  uint64_t x13;
  uint64_t x14;
  uint64_t x15;
  uint64_t x16;
  uint64_t x17;
  uint64_t x18;
  uint64_t x19;
  uint64_t x20;
  uint64_t x21;
  uint64_t x22;
  fiat_p511_uint1 x26;
  fiat_p511_uint1 x28;
  fiat_p511_uint1 x30;
  fiat_p511_uint1 x32;
  fiat_p511_uint1 x34;
  fiat_p511_uint1 x36;

  fiat_p511_mulx_u64(&x9, &x10, x8, (arg2[7]));
  fiat_p511_mulx_u64(&x11, &x12, x8, (arg2[6]));
  fiat_p511_mulx_u64(&x13, &x14, x8, (arg2[5]));
  fiat_p511_mulx_u64(&x15, &x16, x8, (arg2[4]));
  fiat_p511_mulx_u64(&x17, &x18, x8, (arg2[3]));
  fiat_p511_mulx_u64(&x19, &x20, x8, (arg2[2]));
  fiat_p511_mulx_u64(&x21, &x22, x8, (arg2[1]));
  fiat_p511_mulx_u64(&x23, &x24, x8, (arg2[0]));
  fiat_p511_addcarryx_u64(&x25, &x26, 0x0, x24, x21);
  fiat_p511_addcarryx_u64(&x27, &x28, x26, x22, x19);
  fiat_p511_addcarryx_u64(&x29, &x30, x28, x20, x17);
  fiat_p511_addcarryx_u64(&x31, &x32, x30, x18, x15);
  fiat_p511_addcarryx_u64(&x33, &x34, x32, x16, x13);
  fiat_p511_addcarryx_u64(&x35, &x36, x34, x14, x11);
  fiat_p511_addcarryx_u64(&x37, &x38, x36, x12, x9);
  }
  x39 = (x38 + x10);
  {
  uint64_t x40;
  uint64_t x42;
  uint64_t x44;
  uint64_t x46;
  uint64_t x48;
  uint64_t x50;
  uint64_t x52;
  uint64_t x54;
  fiat_p511_uint1 x59;
  fiat_p511_uint1 x61;
  fiat_p511_uint1 x63;
  fiat_p511_uint1 x65;
  fiat_p511_uint1 x67;
  fiat_p511_uint1 x69;

  fiat_p511_mulx_u64(&x40, &x41, x23, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x42, &x43, x40, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x44, &x45, x40, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x46, &x47, x40, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x48, &x49, x40, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x50, &x51, x40, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x52, &x53, x40, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x54, &x55, x40, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x56, &x57, x40, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x58, &x59, 0x0, x57, x54);
  fiat_p511_addcarryx_u64(&x60, &x61, x59, x55, x52);
  fiat_p511_addcarryx_u64(&x62, &x63, x61, x53, x50);
  fiat_p511_addcarryx_u64(&x64, &x65, x63, x51, x48);
  fiat_p511_addcarryx_u64(&x66, &x67, x65, x49, x46);
  fiat_p511_addcarryx_u64(&x68, &x69, x67, x47, x44);
  fiat_p511_addcarryx_u64(&x70, &x71, x69, x45, x42);
  }
  x72 = (x71 + x43);
  {
  fiat_p511_uint1 x74;
  fiat_p511_uint1 x76;
  fiat_p511_uint1 x78;
  fiat_p511_uint1 x80;
  fiat_p511_uint1 x82;
  fiat_p511_uint1 x84;
  fiat_p511_uint1 x86;
  fiat_p511_uint1 x88;
  uint64_t x91;
  uint64_t x93;
  uint64_t x94;
  uint64_t x95;
  uint64_t x96;
  uint64_t x97;
  uint64_t x98;
  uint64_t x99;
  uint64_t x100;
  uint64_t x101;

  fiat_p511_addcarryx_u64(&x73, &x74, 0x0, x23, x56);
  fiat_p511_addcarryx_u64(&x75, &x76, x74, x25, x58);
  fiat_p511_addcarryx_u64(&x77, &x78, x76, x27, x60);
  fiat_p511_addcarryx_u64(&x79, &x80, x78, x29, x62);
  fiat_p511_addcarryx_u64(&x81, &x82, x80, x31, x64);
  fiat_p511_addcarryx_u64(&x83, &x84, x82, x33, x66);
  fiat_p511_addcarryx_u64(&x85, &x86, x84, x35, x68);
  fiat_p511_addcarryx_u64(&x87, &x88, x86, x37, x70);
  fiat_p511_addcarryx_u64(&x89, &x90, x88, x39, x72);
  fiat_p511_mulx_u64(&x91, &x92, x1, (arg2[7]));
  fiat_p511_mulx_u64(&x93, &x94, x1, (arg2[6]));
  fiat_p511_mulx_u64(&x95, &x96, x1, (arg2[5]));
  fiat_p511_mulx_u64(&x97, &x98, x1, (arg2[4]));
  fiat_p511_mulx_u64(&x99, &x100, x1, (arg2[3]));
  fiat_p511_mulx_u64(&x101, &x102, x1, (arg2[2]));
  fiat_p511_mulx_u64(&x103, &x104, x1, (arg2[1]));
  fiat_p511_mulx_u64(&x105, &x106, x1, (arg2[0]));
  fiat_p511_addcarryx_u64(&x107, &x108, 0x0, x106, x103);
  fiat_p511_addcarryx_u64(&x109, &x110, x108, x104, x101);
  fiat_p511_addcarryx_u64(&x111, &x112, x110, x102, x99);
  fiat_p511_addcarryx_u64(&x113, &x114, x112, x100, x97);
  fiat_p511_addcarryx_u64(&x115, &x116, x114, x98, x95);
  fiat_p511_addcarryx_u64(&x117, &x118, x116, x96, x93);
  fiat_p511_addcarryx_u64(&x119, &x120, x118, x94, x91);
  }
  x121 = (x120 + x92);
  fiat_p511_addcarryx_u64(&x122, &x123, 0x0, x75, x105);
  fiat_p511_addcarryx_u64(&x124, &x125, x123, x77, x107);
  fiat_p511_addcarryx_u64(&x126, &x127, x125, x79, x109);
  fiat_p511_addcarryx_u64(&x128, &x129, x127, x81, x111);
  fiat_p511_addcarryx_u64(&x130, &x131, x129, x83, x113);
  fiat_p511_addcarryx_u64(&x132, &x133, x131, x85, x115);
  fiat_p511_addcarryx_u64(&x134, &x135, x133, x87, x117);
  fiat_p511_addcarryx_u64(&x136, &x137, x135, x89, x119);
  fiat_p511_addcarryx_u64(&x138, &x139, x137, x90, x121);
  fiat_p511_mulx_u64(&x140, &x141, x122, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x142, &x143, x140, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x144, &x145, x140, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x146, &x147, x140, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x148, &x149, x140, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x150, &x151, x140, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x152, &x153, x140, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x154, &x155, x140, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x156, &x157, x140, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x158, &x159, 0x0, x157, x154);
  fiat_p511_addcarryx_u64(&x160, &x161, x159, x155, x152);
  fiat_p511_addcarryx_u64(&x162, &x163, x161, x153, x150);
  fiat_p511_addcarryx_u64(&x164, &x165, x163, x151, x148);
  fiat_p511_addcarryx_u64(&x166, &x167, x165, x149, x146);
  fiat_p511_addcarryx_u64(&x168, &x169, x167, x147, x144);
  fiat_p511_addcarryx_u64(&x170, &x171, x169, x145, x142);
  x172 = (x171 + x143);
  fiat_p511_addcarryx_u64(&x173, &x174, 0x0, x122, x156);
  fiat_p511_addcarryx_u64(&x175, &x176, x174, x124, x158);
  fiat_p511_addcarryx_u64(&x177, &x178, x176, x126, x160);
  fiat_p511_addcarryx_u64(&x179, &x180, x178, x128, x162);
  fiat_p511_addcarryx_u64(&x181, &x182, x180, x130, x164);
  fiat_p511_addcarryx_u64(&x183, &x184, x182, x132, x166);
  fiat_p511_addcarryx_u64(&x185, &x186, x184, x134, x168);
  fiat_p511_addcarryx_u64(&x187, &x188, x186, x136, x170);
  fiat_p511_addcarryx_u64(&x189, &x190, x188, x138, x172);
  x191 = ((uint64_t)x190 + x139);
  fiat_p511_mulx_u64(&x192, &x193, x2, (arg2[7]));
  fiat_p511_mulx_u64(&x194, &x195, x2, (arg2[6]));
  fiat_p511_mulx_u64(&x196, &x197, x2, (arg2[5]));
  fiat_p511_mulx_u64(&x198, &x199, x2, (arg2[4]));
  fiat_p511_mulx_u64(&x200, &x201, x2, (arg2[3]));
  fiat_p511_mulx_u64(&x202, &x203, x2, (arg2[2]));
  fiat_p511_mulx_u64(&x204, &x205, x2, (arg2[1]));
  fiat_p511_mulx_u64(&x206, &x207, x2, (arg2[0]));
  fiat_p511_addcarryx_u64(&x208, &x209, 0x0, x207, x204);
  fiat_p511_addcarryx_u64(&x210, &x211, x209, x205, x202);
  fiat_p511_addcarryx_u64(&x212, &x213, x211, x203, x200);
  fiat_p511_addcarryx_u64(&x214, &x215, x213, x201, x198);
  fiat_p511_addcarryx_u64(&x216, &x217, x215, x199, x196);
  fiat_p511_addcarryx_u64(&x218, &x219, x217, x197, x194);
  fiat_p511_addcarryx_u64(&x220, &x221, x219, x195, x192);
  {
  uint64_t x222;
  fiat_p511_uint1 x224;
  fiat_p511_uint1 x226;
  fiat_p511_uint1 x228;
  fiat_p511_uint1 x230;
  fiat_p511_uint1 x234;

  x222 = (x221 + x193);
  fiat_p511_addcarryx_u64(&x223, &x224, 0x0, x175, x206);
  fiat_p511_addcarryx_u64(&x225, &x226, x224, x177, x208);
  fiat_p511_addcarryx_u64(&x227, &x228, x226, x179, x210);
  fiat_p511_addcarryx_u64(&x229, &x230, x228, x181, x212);
  fiat_p511_addcarryx_u64(&x231, &x232, x230, x183, x214);
  fiat_p511_addcarryx_u64(&x233, &x234, x232, x185, x216);
  fiat_p511_addcarryx_u64(&x235, &x236, x234, x187, x218);
  fiat_p511_addcarryx_u64(&x237, &x238, x236, x189, x220);
  fiat_p511_addcarryx_u64(&x239, &x240, x238, x191, x222);
  }
  fiat_p511_mulx_u64(&x241, &x242, x223, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x243, &x244, x241, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x245, &x246, x241, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x247, &x248, x241, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x249, &x250, x241, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x251, &x252, x241, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x253, &x254, x241, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x255, &x256, x241, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x257, &x258, x241, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x259, &x260, 0x0, x258, x255);
  fiat_p511_addcarryx_u64(&x261, &x262, x260, x256, x253);
  fiat_p511_addcarryx_u64(&x263, &x264, x262, x254, x251);
  fiat_p511_addcarryx_u64(&x265, &x266, x264, x252, x249);
  fiat_p511_addcarryx_u64(&x267, &x268, x266, x250, x247);
  fiat_p511_addcarryx_u64(&x269, &x270, x268, x248, x245);
  fiat_p511_addcarryx_u64(&x271, &x272, x270, x246, x243);
  x273 = (x272 + x244);
  fiat_p511_addcarryx_u64(&x274, &x275, 0x0, x223, x257);
  fiat_p511_addcarryx_u64(&x276, &x277, x275, x225, x259);
  fiat_p511_addcarryx_u64(&x278, &x279, x277, x227, x261);
  fiat_p511_addcarryx_u64(&x280, &x281, x279, x229, x263);
  fiat_p511_addcarryx_u64(&x282, &x283, x281, x231, x265);
  fiat_p511_addcarryx_u64(&x284, &x285, x283, x233, x267);
  fiat_p511_addcarryx_u64(&x286, &x287, x285, x235, x269);
  fiat_p511_addcarryx_u64(&x288, &x289, x287, x237, x271);
  fiat_p511_addcarryx_u64(&x290, &x291, x289, x239, x273);
  x292 = ((uint64_t)x291 + x240);
  fiat_p511_mulx_u64(&x293, &x294, x3, (arg2[7]));
  fiat_p511_mulx_u64(&x295, &x296, x3, (arg2[6]));
  fiat_p511_mulx_u64(&x297, &x298, x3, (arg2[5]));
  fiat_p511_mulx_u64(&x299, &x300, x3, (arg2[4]));
  fiat_p511_mulx_u64(&x301, &x302, x3, (arg2[3]));
  fiat_p511_mulx_u64(&x303, &x304, x3, (arg2[2]));
  fiat_p511_mulx_u64(&x305, &x306, x3, (arg2[1]));
  fiat_p511_mulx_u64(&x307, &x308, x3, (arg2[0]));
  fiat_p511_addcarryx_u64(&x309, &x310, 0x0, x308, x305);
  fiat_p511_addcarryx_u64(&x311, &x312, x310, x306, x303);
  fiat_p511_addcarryx_u64(&x313, &x314, x312, x304, x301);
  fiat_p511_addcarryx_u64(&x315, &x316, x314, x302, x299);
  fiat_p511_addcarryx_u64(&x317, &x318, x316, x300, x297);
  fiat_p511_addcarryx_u64(&x319, &x320, x318, x298, x295);
  fiat_p511_addcarryx_u64(&x321, &x322, x320, x296, x293);
  x323 = (x322 + x294);
  fiat_p511_addcarryx_u64(&x324, &x325, 0x0, x276, x307);
  fiat_p511_addcarryx_u64(&x326, &x327, x325, x278, x309);
  fiat_p511_addcarryx_u64(&x328, &x329, x327, x280, x311);
  fiat_p511_addcarryx_u64(&x330, &x331, x329, x282, x313);
  fiat_p511_addcarryx_u64(&x332, &x333, x331, x284, x315);
  fiat_p511_addcarryx_u64(&x334, &x335, x333, x286, x317);
  fiat_p511_addcarryx_u64(&x336, &x337, x335, x288, x319);
  fiat_p511_addcarryx_u64(&x338, &x339, x337, x290, x321);
  fiat_p511_addcarryx_u64(&x340, &x341, x339, x292, x323);
  fiat_p511_mulx_u64(&x342, &x343, x324, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x344, &x345, x342, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x346, &x347, x342, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x348, &x349, x342, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x350, &x351, x342, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x352, &x353, x342, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x354, &x355, x342, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x356, &x357, x342, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x358, &x359, x342, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x360, &x361, 0x0, x359, x356);
  fiat_p511_addcarryx_u64(&x362, &x363, x361, x357, x354);
  fiat_p511_addcarryx_u64(&x364, &x365, x363, x355, x352);
  fiat_p511_addcarryx_u64(&x366, &x367, x365, x353, x350);
  fiat_p511_addcarryx_u64(&x368, &x369, x367, x351, x348);
  fiat_p511_addcarryx_u64(&x370, &x371, x369, x349, x346);
  fiat_p511_addcarryx_u64(&x372, &x373, x371, x347, x344);
  x374 = (x373 + x345);
  fiat_p511_addcarryx_u64(&x375, &x376, 0x0, x324, x358);
  fiat_p511_addcarryx_u64(&x377, &x378, x376, x326, x360);
  fiat_p511_addcarryx_u64(&x379, &x380, x378, x328, x362);
  fiat_p511_addcarryx_u64(&x381, &x382, x380, x330, x364);
  fiat_p511_addcarryx_u64(&x383, &x384, x382, x332, x366);
  fiat_p511_addcarryx_u64(&x385, &x386, x384, x334, x368);
  fiat_p511_addcarryx_u64(&x387, &x388, x386, x336, x370);
  fiat_p511_addcarryx_u64(&x389, &x390, x388, x338, x372);
  fiat_p511_addcarryx_u64(&x391, &x392, x390, x340, x374);
  x393 = ((uint64_t)x392 + x341);
  fiat_p511_mulx_u64(&x394, &x395, x4, (arg2[7]));
  fiat_p511_mulx_u64(&x396, &x397, x4, (arg2[6]));
  fiat_p511_mulx_u64(&x398, &x399, x4, (arg2[5]));
  fiat_p511_mulx_u64(&x400, &x401, x4, (arg2[4]));
  fiat_p511_mulx_u64(&x402, &x403, x4, (arg2[3]));
  fiat_p511_mulx_u64(&x404, &x405, x4, (arg2[2]));
  fiat_p511_mulx_u64(&x406, &x407, x4, (arg2[1]));
  fiat_p511_mulx_u64(&x408, &x409, x4, (arg2[0]));
  fiat_p511_addcarryx_u64(&x410, &x411, 0x0, x409, x406);
  fiat_p511_addcarryx_u64(&x412, &x413, x411, x407, x404);
  fiat_p511_addcarryx_u64(&x414, &x415, x413, x405, x402);
  fiat_p511_addcarryx_u64(&x416, &x417, x415, x403, x400);
  fiat_p511_addcarryx_u64(&x418, &x419, x417, x401, x398);
  fiat_p511_addcarryx_u64(&x420, &x421, x419, x399, x396);
  fiat_p511_addcarryx_u64(&x422, &x423, x421, x397, x394);
  x424 = (x423 + x395);
  fiat_p511_addcarryx_u64(&x425, &x426, 0x0, x377, x408);
  fiat_p511_addcarryx_u64(&x427, &x428, x426, x379, x410);
  fiat_p511_addcarryx_u64(&x429, &x430, x428, x381, x412);
  fiat_p511_addcarryx_u64(&x431, &x432, x430, x383, x414);
  fiat_p511_addcarryx_u64(&x433, &x434, x432, x385, x416);
  fiat_p511_addcarryx_u64(&x435, &x436, x434, x387, x418);
  fiat_p511_addcarryx_u64(&x437, &x438, x436, x389, x420);
  fiat_p511_addcarryx_u64(&x439, &x440, x438, x391, x422);
  fiat_p511_addcarryx_u64(&x441, &x442, x440, x393, x424);
  fiat_p511_mulx_u64(&x443, &x444, x425, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x445, &x446, x443, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x447, &x448, x443, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x449, &x450, x443, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x451, &x452, x443, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x453, &x454, x443, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x455, &x456, x443, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x457, &x458, x443, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x459, &x460, x443, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x461, &x462, 0x0, x460, x457);
  fiat_p511_addcarryx_u64(&x463, &x464, x462, x458, x455);
  fiat_p511_addcarryx_u64(&x465, &x466, x464, x456, x453);
  fiat_p511_addcarryx_u64(&x467, &x468, x466, x454, x451);
  fiat_p511_addcarryx_u64(&x469, &x470, x468, x452, x449);
  fiat_p511_addcarryx_u64(&x471, &x472, x470, x450, x447);
  fiat_p511_addcarryx_u64(&x473, &x474, x472, x448, x445);
  x475 = (x474 + x446);
  fiat_p511_addcarryx_u64(&x476, &x477, 0x0, x425, x459);
  fiat_p511_addcarryx_u64(&x478, &x479, x477, x427, x461);
  fiat_p511_addcarryx_u64(&x480, &x481, x479, x429, x463);
  fiat_p511_addcarryx_u64(&x482, &x483, x481, x431, x465);
  fiat_p511_addcarryx_u64(&x484, &x485, x483, x433, x467);
  fiat_p511_addcarryx_u64(&x486, &x487, x485, x435, x469);
  fiat_p511_addcarryx_u64(&x488, &x489, x487, x437, x471);
  fiat_p511_addcarryx_u64(&x490, &x491, x489, x439, x473);
  fiat_p511_addcarryx_u64(&x492, &x493, x491, x441, x475);
  x494 = ((uint64_t)x493 + x442);
  fiat_p511_mulx_u64(&x495, &x496, x5, (arg2[7]));
  fiat_p511_mulx_u64(&x497, &x498, x5, (arg2[6]));
  fiat_p511_mulx_u64(&x499, &x500, x5, (arg2[5]));
  fiat_p511_mulx_u64(&x501, &x502, x5, (arg2[4]));
  fiat_p511_mulx_u64(&x503, &x504, x5, (arg2[3]));
  fiat_p511_mulx_u64(&x505, &x506, x5, (arg2[2]));
  fiat_p511_mulx_u64(&x507, &x508, x5, (arg2[1]));
  fiat_p511_mulx_u64(&x509, &x510, x5, (arg2[0]));
  fiat_p511_addcarryx_u64(&x511, &x512, 0x0, x510, x507);
  fiat_p511_addcarryx_u64(&x513, &x514, x512, x508, x505);
  fiat_p511_addcarryx_u64(&x515, &x516, x514, x506, x503);
  fiat_p511_addcarryx_u64(&x517, &x518, x516, x504, x501);
  fiat_p511_addcarryx_u64(&x519, &x520, x518, x502, x499);
  fiat_p511_addcarryx_u64(&x521, &x522, x520, x500, x497);
  fiat_p511_addcarryx_u64(&x523, &x524, x522, x498, x495);
  x525 = (x524 + x496);
  fiat_p511_addcarryx_u64(&x526, &x527, 0x0, x478, x509);
  fiat_p511_addcarryx_u64(&x528, &x529, x527, x480, x511);
  fiat_p511_addcarryx_u64(&x530, &x531, x529, x482, x513);
  fiat_p511_addcarryx_u64(&x532, &x533, x531, x484, x515);
  fiat_p511_addcarryx_u64(&x534, &x535, x533, x486, x517);
  fiat_p511_addcarryx_u64(&x536, &x537, x535, x488, x519);
  fiat_p511_addcarryx_u64(&x538, &x539, x537, x490, x521);
  fiat_p511_addcarryx_u64(&x540, &x541, x539, x492, x523);
  fiat_p511_addcarryx_u64(&x542, &x543, x541, x494, x525);
  fiat_p511_mulx_u64(&x544, &x545, x526, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x546, &x547, x544, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x548, &x549, x544, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x550, &x551, x544, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x552, &x553, x544, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x554, &x555, x544, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x556, &x557, x544, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x558, &x559, x544, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x560, &x561, x544, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x562, &x563, 0x0, x561, x558);
  fiat_p511_addcarryx_u64(&x564, &x565, x563, x559, x556);
  fiat_p511_addcarryx_u64(&x566, &x567, x565, x557, x554);
  fiat_p511_addcarryx_u64(&x568, &x569, x567, x555, x552);
  fiat_p511_addcarryx_u64(&x570, &x571, x569, x553, x550);
  fiat_p511_addcarryx_u64(&x572, &x573, x571, x551, x548);
  fiat_p511_addcarryx_u64(&x574, &x575, x573, x549, x546);
  x576 = (x575 + x547);
  fiat_p511_addcarryx_u64(&x577, &x578, 0x0, x526, x560);
  fiat_p511_addcarryx_u64(&x579, &x580, x578, x528, x562);
  fiat_p511_addcarryx_u64(&x581, &x582, x580, x530, x564);
  fiat_p511_addcarryx_u64(&x583, &x584, x582, x532, x566);
  fiat_p511_addcarryx_u64(&x585, &x586, x584, x534, x568);
  fiat_p511_addcarryx_u64(&x587, &x588, x586, x536, x570);
  fiat_p511_addcarryx_u64(&x589, &x590, x588, x538, x572);
  fiat_p511_addcarryx_u64(&x591, &x592, x590, x540, x574);
  fiat_p511_addcarryx_u64(&x593, &x594, x592, x542, x576);
  x595 = ((uint64_t)x594 + x543);
  fiat_p511_mulx_u64(&x596, &x597, x6, (arg2[7]));
  fiat_p511_mulx_u64(&x598, &x599, x6, (arg2[6]));
  fiat_p511_mulx_u64(&x600, &x601, x6, (arg2[5]));
  fiat_p511_mulx_u64(&x602, &x603, x6, (arg2[4]));
  fiat_p511_mulx_u64(&x604, &x605, x6, (arg2[3]));
  fiat_p511_mulx_u64(&x606, &x607, x6, (arg2[2]));
  fiat_p511_mulx_u64(&x608, &x609, x6, (arg2[1]));
  fiat_p511_mulx_u64(&x610, &x611, x6, (arg2[0]));
  fiat_p511_addcarryx_u64(&x612, &x613, 0x0, x611, x608);
  fiat_p511_addcarryx_u64(&x614, &x615, x613, x609, x606);
  fiat_p511_addcarryx_u64(&x616, &x617, x615, x607, x604);
  fiat_p511_addcarryx_u64(&x618, &x619, x617, x605, x602);
  fiat_p511_addcarryx_u64(&x620, &x621, x619, x603, x600);
  fiat_p511_addcarryx_u64(&x622, &x623, x621, x601, x598);
  fiat_p511_addcarryx_u64(&x624, &x625, x623, x599, x596);
  x626 = (x625 + x597);
  fiat_p511_addcarryx_u64(&x627, &x628, 0x0, x579, x610);
  fiat_p511_addcarryx_u64(&x629, &x630, x628, x581, x612);
  fiat_p511_addcarryx_u64(&x631, &x632, x630, x583, x614);
  fiat_p511_addcarryx_u64(&x633, &x634, x632, x585, x616);
  fiat_p511_addcarryx_u64(&x635, &x636, x634, x587, x618);
  fiat_p511_addcarryx_u64(&x637, &x638, x636, x589, x620);
  fiat_p511_addcarryx_u64(&x639, &x640, x638, x591, x622);
  fiat_p511_addcarryx_u64(&x641, &x642, x640, x593, x624);
  fiat_p511_addcarryx_u64(&x643, &x644, x642, x595, x626);
  fiat_p511_mulx_u64(&x645, &x646, x627, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x647, &x648, x645, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x649, &x650, x645, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x651, &x652, x645, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x653, &x654, x645, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x655, &x656, x645, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x657, &x658, x645, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x659, &x660, x645, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x661, &x662, x645, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x663, &x664, 0x0, x662, x659);
  fiat_p511_addcarryx_u64(&x665, &x666, x664, x660, x657);
  fiat_p511_addcarryx_u64(&x667, &x668, x666, x658, x655);
  fiat_p511_addcarryx_u64(&x669, &x670, x668, x656, x653);
  fiat_p511_addcarryx_u64(&x671, &x672, x670, x654, x651);
  fiat_p511_addcarryx_u64(&x673, &x674, x672, x652, x649);
  fiat_p511_addcarryx_u64(&x675, &x676, x674, x650, x647);
  x677 = (x676 + x648);
  fiat_p511_addcarryx_u64(&x678, &x679, 0x0, x627, x661);
  fiat_p511_addcarryx_u64(&x680, &x681, x679, x629, x663);
  fiat_p511_addcarryx_u64(&x682, &x683, x681, x631, x665);
  fiat_p511_addcarryx_u64(&x684, &x685, x683, x633, x667);
  fiat_p511_addcarryx_u64(&x686, &x687, x685, x635, x669);
  fiat_p511_addcarryx_u64(&x688, &x689, x687, x637, x671);
  fiat_p511_addcarryx_u64(&x690, &x691, x689, x639, x673);
  fiat_p511_addcarryx_u64(&x692, &x693, x691, x641, x675);
  fiat_p511_addcarryx_u64(&x694, &x695, x693, x643, x677);
  x696 = ((uint64_t)x695 + x644);
  fiat_p511_mulx_u64(&x697, &x698, x7, (arg2[7]));
  fiat_p511_mulx_u64(&x699, &x700, x7, (arg2[6]));
  fiat_p511_mulx_u64(&x701, &x702, x7, (arg2[5]));
  fiat_p511_mulx_u64(&x703, &x704, x7, (arg2[4]));
  fiat_p511_mulx_u64(&x705, &x706, x7, (arg2[3]));
  fiat_p511_mulx_u64(&x707, &x708, x7, (arg2[2]));
  fiat_p511_mulx_u64(&x709, &x710, x7, (arg2[1]));
  fiat_p511_mulx_u64(&x711, &x712, x7, (arg2[0]));
  fiat_p511_addcarryx_u64(&x713, &x714, 0x0, x712, x709);
  fiat_p511_addcarryx_u64(&x715, &x716, x714, x710, x707);
  fiat_p511_addcarryx_u64(&x717, &x718, x716, x708, x705);
  fiat_p511_addcarryx_u64(&x719, &x720, x718, x706, x703);
  fiat_p511_addcarryx_u64(&x721, &x722, x720, x704, x701);
  fiat_p511_addcarryx_u64(&x723, &x724, x722, x702, x699);
  fiat_p511_addcarryx_u64(&x725, &x726, x724, x700, x697);
  x727 = (x726 + x698);
  {
  uint64_t x728;
  uint64_t x730;
  uint64_t x732;
  uint64_t x734;
  uint64_t x736;
  uint64_t x738;
  uint64_t x740;
  uint64_t x742;
  uint64_t x744;
  uint64_t x746;
  uint64_t x747;

  fiat_p511_addcarryx_u64(&x728, &x729, 0x0, x680, x711);
  fiat_p511_addcarryx_u64(&x730, &x731, x729, x682, x713);
  fiat_p511_addcarryx_u64(&x732, &x733, x731, x684, x715);
  fiat_p511_addcarryx_u64(&x734, &x735, x733, x686, x717);
  fiat_p511_addcarryx_u64(&x736, &x737, x735, x688, x719);
  fiat_p511_addcarryx_u64(&x738, &x739, x737, x690, x721);
  fiat_p511_addcarryx_u64(&x740, &x741, x739, x692, x723);
  fiat_p511_addcarryx_u64(&x742, &x743, x741, x694, x725);
  fiat_p511_addcarryx_u64(&x744, &x745, x743, x696, x727);
  fiat_p511_mulx_u64(&x746, &x747, x728, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x748, &x749, x746, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x750, &x751, x746, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x752, &x753, x746, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x754, &x755, x746, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x756, &x757, x746, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x758, &x759, x746, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x760, &x761, x746, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x762, &x763, x746, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x764, &x765, 0x0, x763, x760);
  fiat_p511_addcarryx_u64(&x766, &x767, x765, x761, x758);
  fiat_p511_addcarryx_u64(&x768, &x769, x767, x759, x756);
  fiat_p511_addcarryx_u64(&x770, &x771, x769, x757, x754);
  fiat_p511_addcarryx_u64(&x772, &x773, x771, x755, x752);
  fiat_p511_addcarryx_u64(&x774, &x775, x773, x753, x750);
  fiat_p511_addcarryx_u64(&x776, &x777, x775, x751, x748);

  x778 = (x777 + x749);
  fiat_p511_addcarryx_u64(&x779, &x780, 0x0, x728, x762);
  fiat_p511_addcarryx_u64(&x781, &x782, x780, x730, x764);
  fiat_p511_addcarryx_u64(&x783, &x784, x782, x732, x766);
  fiat_p511_addcarryx_u64(&x785, &x786, x784, x734, x768);
  fiat_p511_addcarryx_u64(&x787, &x788, x786, x736, x770);
  fiat_p511_addcarryx_u64(&x789, &x790, x788, x738, x772);
  fiat_p511_addcarryx_u64(&x791, &x792, x790, x740, x774);
  fiat_p511_addcarryx_u64(&x793, &x794, x792, x742, x776);
  fiat_p511_addcarryx_u64(&x795, &x796, x794, x744, x778);
  }
  x797 = ((uint64_t)x796 + x745);
  {
  uint64_t x798;
  uint64_t x800;
  uint64_t x802;
  uint64_t x804;
  uint64_t x806;
  uint64_t x808;
  uint64_t x810;
  uint64_t x812;
  uint64_t x814;

  fiat_p511_subborrowx_u64(&x798, &x799, 0x0, x781, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_subborrowx_u64(&x800, &x801, x799, x783, UINT64_C(0xc2721bf457aca835));
  fiat_p511_subborrowx_u64(&x802, &x803, x801, x785, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_subborrowx_u64(&x804, &x805, x803, x787, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_subborrowx_u64(&x806, &x807, x805, x789, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_subborrowx_u64(&x808, &x809, x807, x791, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_subborrowx_u64(&x810, &x811, x809, x793, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_subborrowx_u64(&x812, &x813, x811, x795, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_subborrowx_u64(&x814, &x815, x813, x797, 0x0);
  fiat_p511_cmovznz_u64(&x816, x815, x798, x781);
  fiat_p511_cmovznz_u64(&x817, x815, x800, x783);
  fiat_p511_cmovznz_u64(&x818, x815, x802, x785);
  fiat_p511_cmovznz_u64(&x819, x815, x804, x787);
  fiat_p511_cmovznz_u64(&x820, x815, x806, x789);
  fiat_p511_cmovznz_u64(&x821, x815, x808, x791);
  fiat_p511_cmovznz_u64(&x822, x815, x810, x793);
  fiat_p511_cmovznz_u64(&x823, x815, x812, x795);
  }
  out1[0] = x816;
  out1[1] = x817;
  out1[2] = x818;
  out1[3] = x819;
  out1[4] = x820;
  out1[5] = x821;
  out1[6] = x822;
  out1[7] = x823;
}

/*
 * The function fiat_p511_square squares a field element in the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg1)) mod m
 *   0 ≤ eval out1 < m
 *
 */
void fiat_p511_square(fiat_p511_montgomery_domain_field_element out1, const fiat_p511_montgomery_domain_field_element arg1) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  uint64_t x10;
  uint64_t x23;
  uint64_t x25;
  uint64_t x27;
  uint64_t x29;
  uint64_t x31;
  uint64_t x33;
  uint64_t x35;
  uint64_t x37;
  fiat_p511_uint1 x38;
  uint64_t x39;
  uint64_t x43;
  uint64_t x44;
  uint64_t x56;
  uint64_t x58;
  uint64_t x60;
  uint64_t x62;
  uint64_t x64;
  uint64_t x66;
  uint64_t x68;
  uint64_t x70;
  fiat_p511_uint1 x71;
  uint64_t x72;
  uint64_t x73;
  fiat_p511_uint1 x74;
  uint64_t x75;
  fiat_p511_uint1 x76;
  uint64_t x77;
  fiat_p511_uint1 x78;
  uint64_t x79;
  fiat_p511_uint1 x80;
  uint64_t x81;
  fiat_p511_uint1 x82;
  uint64_t x83;
  fiat_p511_uint1 x84;
  uint64_t x85;
  fiat_p511_uint1 x86;
  uint64_t x87;
  fiat_p511_uint1 x88;
  uint64_t x89;
  fiat_p511_uint1 x90;
  uint64_t x91;
  uint64_t x92;
  uint64_t x93;
  uint64_t x94;
  uint64_t x95;
  uint64_t x96;
  uint64_t x97;
  uint64_t x98;
  uint64_t x99;
  uint64_t x100;
  uint64_t x101;
  uint64_t x102;
  uint64_t x103;
  uint64_t x104;
  uint64_t x105;
  uint64_t x106;
  uint64_t x107;
  fiat_p511_uint1 x108;
  uint64_t x109;
  fiat_p511_uint1 x110;
  uint64_t x111;
  fiat_p511_uint1 x112;
  uint64_t x113;
  fiat_p511_uint1 x114;
  uint64_t x115;
  fiat_p511_uint1 x116;
  uint64_t x117;
  fiat_p511_uint1 x118;
  uint64_t x119;
  fiat_p511_uint1 x120;
  uint64_t x121;
  uint64_t x122;
  fiat_p511_uint1 x123;
  uint64_t x124;
  fiat_p511_uint1 x125;
  uint64_t x126;
  fiat_p511_uint1 x127;
  uint64_t x128;
  fiat_p511_uint1 x129;
  uint64_t x130;
  fiat_p511_uint1 x131;
  uint64_t x132;
  fiat_p511_uint1 x133;
  uint64_t x134;
  fiat_p511_uint1 x135;
  uint64_t x136;
  fiat_p511_uint1 x137;
  uint64_t x138;
  fiat_p511_uint1 x139;
  uint64_t x140;
  uint64_t x141;
  uint64_t x142;
  uint64_t x143;
  uint64_t x144;
  uint64_t x145;
  uint64_t x146;
  uint64_t x147;
  uint64_t x148;
  uint64_t x149;
  uint64_t x150;
  uint64_t x151;
  uint64_t x152;
  uint64_t x153;
  uint64_t x154;
  uint64_t x155;
  uint64_t x156;
  uint64_t x157;
  uint64_t x158;
  fiat_p511_uint1 x159;
  uint64_t x160;
  fiat_p511_uint1 x161;
  uint64_t x162;
  fiat_p511_uint1 x163;
  uint64_t x164;
  fiat_p511_uint1 x165;
  uint64_t x166;
  fiat_p511_uint1 x167;
  uint64_t x168;
  fiat_p511_uint1 x169;
  uint64_t x170;
  fiat_p511_uint1 x171;
  uint64_t x172;
  uint64_t x173;
  fiat_p511_uint1 x174;
  uint64_t x175;
  fiat_p511_uint1 x176;
  uint64_t x177;
  fiat_p511_uint1 x178;
  uint64_t x179;
  fiat_p511_uint1 x180;
  uint64_t x181;
  fiat_p511_uint1 x182;
  uint64_t x183;
  fiat_p511_uint1 x184;
  uint64_t x185;
  fiat_p511_uint1 x186;
  uint64_t x187;
  fiat_p511_uint1 x188;
  uint64_t x189;
  fiat_p511_uint1 x190;
  uint64_t x191;
  uint64_t x192;
  uint64_t x193;
  uint64_t x194;
  uint64_t x195;
  uint64_t x196;
  uint64_t x197;
  uint64_t x198;
  uint64_t x199;
  uint64_t x200;
  uint64_t x201;
  uint64_t x202;
  uint64_t x203;
  uint64_t x204;
  uint64_t x205;
  uint64_t x206;
  uint64_t x207;
  uint64_t x208;
  fiat_p511_uint1 x209;
  uint64_t x210;
  fiat_p511_uint1 x211;
  uint64_t x212;
  fiat_p511_uint1 x213;
  uint64_t x214;
  fiat_p511_uint1 x215;
  uint64_t x216;
  fiat_p511_uint1 x217;
  uint64_t x218;
  fiat_p511_uint1 x219;
  uint64_t x220;
  fiat_p511_uint1 x221;
  uint64_t x222;
  uint64_t x223;
  fiat_p511_uint1 x224;
  uint64_t x225;
  fiat_p511_uint1 x226;
  uint64_t x227;
  fiat_p511_uint1 x228;
  uint64_t x229;
  fiat_p511_uint1 x230;
  uint64_t x231;
  fiat_p511_uint1 x232;
  uint64_t x233;
  fiat_p511_uint1 x234;
  uint64_t x235;
  fiat_p511_uint1 x236;
  uint64_t x237;
  fiat_p511_uint1 x238;
  uint64_t x239;
  fiat_p511_uint1 x240;
  uint64_t x241;
  uint64_t x242;
  uint64_t x243;
  uint64_t x244;
  uint64_t x245;
  uint64_t x246;
  uint64_t x247;
  uint64_t x248;
  uint64_t x249;
  uint64_t x250;
  uint64_t x251;
  uint64_t x252;
  uint64_t x253;
  uint64_t x254;
  uint64_t x255;
  uint64_t x256;
  uint64_t x257;
  uint64_t x258;
  uint64_t x259;
  fiat_p511_uint1 x260;
  uint64_t x261;
  fiat_p511_uint1 x262;
  uint64_t x263;
  fiat_p511_uint1 x264;
  uint64_t x265;
  fiat_p511_uint1 x266;
  uint64_t x267;
  fiat_p511_uint1 x268;
  uint64_t x269;
  fiat_p511_uint1 x270;
  uint64_t x271;
  fiat_p511_uint1 x272;
  uint64_t x273;
  uint64_t x274;
  fiat_p511_uint1 x275;
  uint64_t x276;
  fiat_p511_uint1 x277;
  uint64_t x278;
  fiat_p511_uint1 x279;
  uint64_t x280;
  fiat_p511_uint1 x281;
  uint64_t x282;
  fiat_p511_uint1 x283;
  uint64_t x284;
  fiat_p511_uint1 x285;
  uint64_t x286;
  fiat_p511_uint1 x287;
  uint64_t x288;
  fiat_p511_uint1 x289;
  uint64_t x290;
  fiat_p511_uint1 x291;
  uint64_t x292;
  uint64_t x293;
  uint64_t x294;
  uint64_t x295;
  uint64_t x296;
  uint64_t x297;
  uint64_t x298;
  uint64_t x299;
  uint64_t x300;
  uint64_t x301;
  uint64_t x302;
  uint64_t x303;
  uint64_t x304;
  uint64_t x305;
  uint64_t x306;
  uint64_t x307;
  uint64_t x308;
  uint64_t x309;
  fiat_p511_uint1 x310;
  uint64_t x311;
  fiat_p511_uint1 x312;
  uint64_t x313;
  fiat_p511_uint1 x314;
  uint64_t x315;
  fiat_p511_uint1 x316;
  uint64_t x317;
  fiat_p511_uint1 x318;
  uint64_t x319;
  fiat_p511_uint1 x320;
  uint64_t x321;
  fiat_p511_uint1 x322;
  uint64_t x323;
  uint64_t x324;
  fiat_p511_uint1 x325;
  uint64_t x326;
  fiat_p511_uint1 x327;
  uint64_t x328;
  fiat_p511_uint1 x329;
  uint64_t x330;
  fiat_p511_uint1 x331;
  uint64_t x332;
  fiat_p511_uint1 x333;
  uint64_t x334;
  fiat_p511_uint1 x335;
  uint64_t x336;
  fiat_p511_uint1 x337;
  uint64_t x338;
  fiat_p511_uint1 x339;
  uint64_t x340;
  fiat_p511_uint1 x341;
  uint64_t x342;
  uint64_t x343;
  uint64_t x344;
  uint64_t x345;
  uint64_t x346;
  uint64_t x347;
  uint64_t x348;
  uint64_t x349;
  uint64_t x350;
  uint64_t x351;
  uint64_t x352;
  uint64_t x353;
  uint64_t x354;
  uint64_t x355;
  uint64_t x356;
  uint64_t x357;
  uint64_t x358;
  uint64_t x359;
  uint64_t x360;
  fiat_p511_uint1 x361;
  uint64_t x362;
  fiat_p511_uint1 x363;
  uint64_t x364;
  fiat_p511_uint1 x365;
  uint64_t x366;
  fiat_p511_uint1 x367;
  uint64_t x368;
  fiat_p511_uint1 x369;
  uint64_t x370;
  fiat_p511_uint1 x371;
  uint64_t x372;
  fiat_p511_uint1 x373;
  uint64_t x374;
  uint64_t x375;
  fiat_p511_uint1 x376;
  uint64_t x377;
  fiat_p511_uint1 x378;
  uint64_t x379;
  fiat_p511_uint1 x380;
  uint64_t x381;
  fiat_p511_uint1 x382;
  uint64_t x383;
  fiat_p511_uint1 x384;
  uint64_t x385;
  fiat_p511_uint1 x386;
  uint64_t x387;
  fiat_p511_uint1 x388;
  uint64_t x389;
  fiat_p511_uint1 x390;
  uint64_t x391;
  fiat_p511_uint1 x392;
  uint64_t x393;
  uint64_t x394;
  uint64_t x395;
  uint64_t x396;
  uint64_t x397;
  uint64_t x398;
  uint64_t x399;
  uint64_t x400;
  uint64_t x401;
  uint64_t x402;
  uint64_t x403;
  uint64_t x404;
  uint64_t x405;
  uint64_t x406;
  uint64_t x407;
  uint64_t x408;
  uint64_t x409;
  uint64_t x410;
  fiat_p511_uint1 x411;
  uint64_t x412;
  fiat_p511_uint1 x413;
  uint64_t x414;
  fiat_p511_uint1 x415;
  uint64_t x416;
  fiat_p511_uint1 x417;
  uint64_t x418;
  fiat_p511_uint1 x419;
  uint64_t x420;
  fiat_p511_uint1 x421;
  uint64_t x422;
  fiat_p511_uint1 x423;
  uint64_t x424;
  uint64_t x425;
  fiat_p511_uint1 x426;
  uint64_t x427;
  fiat_p511_uint1 x428;
  uint64_t x429;
  fiat_p511_uint1 x430;
  uint64_t x431;
  fiat_p511_uint1 x432;
  uint64_t x433;
  fiat_p511_uint1 x434;
  uint64_t x435;
  fiat_p511_uint1 x436;
  uint64_t x437;
  fiat_p511_uint1 x438;
  uint64_t x439;
  fiat_p511_uint1 x440;
  uint64_t x441;
  fiat_p511_uint1 x442;
  uint64_t x443;
  uint64_t x444;
  uint64_t x445;
  uint64_t x446;
  uint64_t x447;
  uint64_t x448;
  uint64_t x449;
  uint64_t x450;
  uint64_t x451;
  uint64_t x452;
  uint64_t x453;
  uint64_t x454;
  uint64_t x455;
  uint64_t x456;
  uint64_t x457;
  uint64_t x458;
  uint64_t x459;
  uint64_t x460;
  uint64_t x461;
  fiat_p511_uint1 x462;
  uint64_t x463;
  fiat_p511_uint1 x464;
  uint64_t x465;
  fiat_p511_uint1 x466;
  uint64_t x467;
  fiat_p511_uint1 x468;
  uint64_t x469;
  fiat_p511_uint1 x470;
  uint64_t x471;
  fiat_p511_uint1 x472;
  uint64_t x473;
  fiat_p511_uint1 x474;
  uint64_t x475;
  uint64_t x476;
  fiat_p511_uint1 x477;
  uint64_t x478;
  fiat_p511_uint1 x479;
  uint64_t x480;
  fiat_p511_uint1 x481;
  uint64_t x482;
  fiat_p511_uint1 x483;
  uint64_t x484;
  fiat_p511_uint1 x485;
  uint64_t x486;
  fiat_p511_uint1 x487;
  uint64_t x488;
  fiat_p511_uint1 x489;
  uint64_t x490;
  fiat_p511_uint1 x491;
  uint64_t x492;
  fiat_p511_uint1 x493;
  uint64_t x494;
  uint64_t x495;
  uint64_t x496;
  uint64_t x497;
  uint64_t x498;
  uint64_t x499;
  uint64_t x500;
  uint64_t x501;
  uint64_t x502;
  uint64_t x503;
  uint64_t x504;
  uint64_t x505;
  uint64_t x506;
  uint64_t x507;
  uint64_t x508;
  uint64_t x509;
  uint64_t x510;
  uint64_t x511;
  fiat_p511_uint1 x512;
  uint64_t x513;
  fiat_p511_uint1 x514;
  uint64_t x515;
  fiat_p511_uint1 x516;
  uint64_t x517;
  fiat_p511_uint1 x518;
  uint64_t x519;
  fiat_p511_uint1 x520;
  uint64_t x521;
  fiat_p511_uint1 x522;
  uint64_t x523;
  fiat_p511_uint1 x524;
  uint64_t x525;
  uint64_t x526;
  fiat_p511_uint1 x527;
  uint64_t x528;
  fiat_p511_uint1 x529;
  uint64_t x530;
  fiat_p511_uint1 x531;
  uint64_t x532;
  fiat_p511_uint1 x533;
  uint64_t x534;
  fiat_p511_uint1 x535;
  uint64_t x536;
  fiat_p511_uint1 x537;
  uint64_t x538;
  fiat_p511_uint1 x539;
  uint64_t x540;
  fiat_p511_uint1 x541;
  uint64_t x542;
  fiat_p511_uint1 x543;
  uint64_t x544;
  uint64_t x545;
  uint64_t x546;
  uint64_t x547;
  uint64_t x548;
  uint64_t x549;
  uint64_t x550;
  uint64_t x551;
  uint64_t x552;
  uint64_t x553;
  uint64_t x554;
  uint64_t x555;
  uint64_t x556;
  uint64_t x557;
  uint64_t x558;
  uint64_t x559;
  uint64_t x560;
  uint64_t x561;
  uint64_t x562;
  fiat_p511_uint1 x563;
  uint64_t x564;
  fiat_p511_uint1 x565;
  uint64_t x566;
  fiat_p511_uint1 x567;
  uint64_t x568;
  fiat_p511_uint1 x569;
  uint64_t x570;
  fiat_p511_uint1 x571;
  uint64_t x572;
  fiat_p511_uint1 x573;
  uint64_t x574;
  fiat_p511_uint1 x575;
  uint64_t x576;
  uint64_t x577;
  fiat_p511_uint1 x578;
  uint64_t x579;
  fiat_p511_uint1 x580;
  uint64_t x581;
  fiat_p511_uint1 x582;
  uint64_t x583;
  fiat_p511_uint1 x584;
  uint64_t x585;
  fiat_p511_uint1 x586;
  uint64_t x587;
  fiat_p511_uint1 x588;
  uint64_t x589;
  fiat_p511_uint1 x590;
  uint64_t x591;
  fiat_p511_uint1 x592;
  uint64_t x593;
  fiat_p511_uint1 x594;
  uint64_t x595;
  uint64_t x596;
  uint64_t x597;
  uint64_t x598;
  uint64_t x599;
  uint64_t x600;
  uint64_t x601;
  uint64_t x602;
  uint64_t x603;
  uint64_t x604;
  uint64_t x605;
  uint64_t x606;
  uint64_t x607;
  uint64_t x608;
  uint64_t x609;
  uint64_t x610;
  uint64_t x611;
  uint64_t x612;
  fiat_p511_uint1 x613;
  uint64_t x614;
  fiat_p511_uint1 x615;
  uint64_t x616;
  fiat_p511_uint1 x617;
  uint64_t x618;
  fiat_p511_uint1 x619;
  uint64_t x620;
  fiat_p511_uint1 x621;
  uint64_t x622;
  fiat_p511_uint1 x623;
  uint64_t x624;
  fiat_p511_uint1 x625;
  uint64_t x626;
  uint64_t x627;
  fiat_p511_uint1 x628;
  uint64_t x629;
  fiat_p511_uint1 x630;
  uint64_t x631;
  fiat_p511_uint1 x632;
  uint64_t x633;
  fiat_p511_uint1 x634;
  uint64_t x635;
  fiat_p511_uint1 x636;
  uint64_t x637;
  fiat_p511_uint1 x638;
  uint64_t x639;
  fiat_p511_uint1 x640;
  uint64_t x641;
  fiat_p511_uint1 x642;
  uint64_t x643;
  fiat_p511_uint1 x644;
  uint64_t x645;
  uint64_t x646;
  uint64_t x647;
  uint64_t x648;
  uint64_t x649;
  uint64_t x650;
  uint64_t x651;
  uint64_t x652;
  uint64_t x653;
  uint64_t x654;
  uint64_t x655;
  uint64_t x656;
  uint64_t x657;
  uint64_t x658;
  uint64_t x659;
  uint64_t x660;
  uint64_t x661;
  uint64_t x662;
  uint64_t x663;
  fiat_p511_uint1 x664;
  uint64_t x665;
  fiat_p511_uint1 x666;
  uint64_t x667;
  fiat_p511_uint1 x668;
  uint64_t x669;
  fiat_p511_uint1 x670;
  uint64_t x671;
  fiat_p511_uint1 x672;
  uint64_t x673;
  fiat_p511_uint1 x674;
  uint64_t x675;
  fiat_p511_uint1 x676;
  uint64_t x678;
  fiat_p511_uint1 x679;
  uint64_t x680;
  fiat_p511_uint1 x681;
  uint64_t x682;
  fiat_p511_uint1 x683;
  uint64_t x684;
  fiat_p511_uint1 x685;
  uint64_t x686;
  fiat_p511_uint1 x687;
  uint64_t x688;
  fiat_p511_uint1 x689;
  uint64_t x690;
  fiat_p511_uint1 x691;
  uint64_t x692;
  fiat_p511_uint1 x693;
  uint64_t x694;
  fiat_p511_uint1 x695;
  uint64_t x697;
  uint64_t x698;
  uint64_t x699;
  uint64_t x700;
  uint64_t x701;
  uint64_t x702;
  uint64_t x703;
  uint64_t x704;
  uint64_t x705;
  uint64_t x706;
  uint64_t x707;
  uint64_t x708;
  uint64_t x709;
  uint64_t x710;
  uint64_t x711;
  uint64_t x712;
  uint64_t x713;
  fiat_p511_uint1 x714;
  uint64_t x715;
  fiat_p511_uint1 x716;
  uint64_t x717;
  fiat_p511_uint1 x718;
  uint64_t x719;
  fiat_p511_uint1 x720;
  uint64_t x721;
  fiat_p511_uint1 x722;
  uint64_t x723;
  fiat_p511_uint1 x724;
  uint64_t x725;
  fiat_p511_uint1 x726;
  uint64_t x727;
  uint64_t x728;
  fiat_p511_uint1 x729;
  uint64_t x730;
  fiat_p511_uint1 x731;
  uint64_t x732;
  fiat_p511_uint1 x733;
  uint64_t x734;
  fiat_p511_uint1 x735;
  uint64_t x736;
  fiat_p511_uint1 x737;
  uint64_t x738;
  fiat_p511_uint1 x739;
  uint64_t x740;
  fiat_p511_uint1 x741;
  uint64_t x742;
  fiat_p511_uint1 x743;
  uint64_t x744;
  fiat_p511_uint1 x745;
  uint64_t x746;
  uint64_t x747;
  uint64_t x748;
  uint64_t x749;
  uint64_t x750;
  uint64_t x751;
  uint64_t x752;
  uint64_t x753;
  uint64_t x754;
  uint64_t x755;
  uint64_t x756;
  uint64_t x757;
  uint64_t x758;
  uint64_t x759;
  uint64_t x760;
  uint64_t x761;
  uint64_t x762;
  uint64_t x763;
  uint64_t x764;
  fiat_p511_uint1 x765;
  uint64_t x766;
  fiat_p511_uint1 x767;
  uint64_t x768;
  fiat_p511_uint1 x769;
  uint64_t x770;
  fiat_p511_uint1 x771;
  uint64_t x772;
  fiat_p511_uint1 x773;
  uint64_t x774;
  fiat_p511_uint1 x775;
  uint64_t x776;
  fiat_p511_uint1 x777;
  uint64_t x778;
  uint64_t x779;
  fiat_p511_uint1 x780;
  uint64_t x781;
  fiat_p511_uint1 x782;
  uint64_t x783;
  fiat_p511_uint1 x784;
  uint64_t x785;
  fiat_p511_uint1 x786;
  uint64_t x787;
  fiat_p511_uint1 x788;
  uint64_t x789;
  fiat_p511_uint1 x790;
  uint64_t x791;
  fiat_p511_uint1 x792;
  uint64_t x793;
  fiat_p511_uint1 x794;
  uint64_t x795;
  fiat_p511_uint1 x796;
  uint64_t x797;
  uint64_t x798;
  fiat_p511_uint1 x799;
  uint64_t x800;
  fiat_p511_uint1 x801;
  uint64_t x802;
  fiat_p511_uint1 x803;
  uint64_t x804;
  fiat_p511_uint1 x805;
  uint64_t x806;
  fiat_p511_uint1 x807;
  uint64_t x808;
  fiat_p511_uint1 x809;
  uint64_t x810;
  fiat_p511_uint1 x811;
  uint64_t x812;
  fiat_p511_uint1 x813;
  uint64_t x814;
  fiat_p511_uint1 x815;
  uint64_t x816;
  uint64_t x817;
  uint64_t x818;
  uint64_t x819;
  uint64_t x820;
  uint64_t x821;
  uint64_t x822;
  uint64_t x823;
  x1 = (arg1[1]);
  x2 = (arg1[2]);
  x3 = (arg1[3]);
  x4 = (arg1[4]);
  x5 = (arg1[5]);
  x6 = (arg1[6]);
  x7 = (arg1[7]);
  x8 = (arg1[0]);
  {
  uint64_t x9;
  uint64_t x11;
  uint64_t x12;
  uint64_t x13;
  uint64_t x14;
  uint64_t x15;
  uint64_t x16;
  uint64_t x17;
  uint64_t x18;
  uint64_t x19;
  uint64_t x20;
  uint64_t x21;
  uint64_t x22;
  uint64_t x24;
  fiat_p511_uint1 x26;
  fiat_p511_uint1 x28;
  fiat_p511_uint1 x30;
  fiat_p511_uint1 x32;
  fiat_p511_uint1 x34;
  fiat_p511_uint1 x36;

  fiat_p511_mulx_u64(&x9, &x10, x8, (arg1[7]));
  fiat_p511_mulx_u64(&x11, &x12, x8, (arg1[6]));
  fiat_p511_mulx_u64(&x13, &x14, x8, (arg1[5]));
  fiat_p511_mulx_u64(&x15, &x16, x8, (arg1[4]));
  fiat_p511_mulx_u64(&x17, &x18, x8, (arg1[3]));
  fiat_p511_mulx_u64(&x19, &x20, x8, (arg1[2]));
  fiat_p511_mulx_u64(&x21, &x22, x8, (arg1[1]));
  fiat_p511_mulx_u64(&x23, &x24, x8, (arg1[0]));
  fiat_p511_addcarryx_u64(&x25, &x26, 0x0, x24, x21);
  fiat_p511_addcarryx_u64(&x27, &x28, x26, x22, x19);
  fiat_p511_addcarryx_u64(&x29, &x30, x28, x20, x17);
  fiat_p511_addcarryx_u64(&x31, &x32, x30, x18, x15);
  fiat_p511_addcarryx_u64(&x33, &x34, x32, x16, x13);
  fiat_p511_addcarryx_u64(&x35, &x36, x34, x14, x11);
  fiat_p511_addcarryx_u64(&x37, &x38, x36, x12, x9);
  }
  x39 = (x38 + x10);
  {
  uint64_t x40;
  uint64_t x41;
  uint64_t x42;
  uint64_t x45;
  uint64_t x46;
  uint64_t x47;
  uint64_t x48;
  uint64_t x49;
  uint64_t x50;
  uint64_t x51;
  uint64_t x52;
  uint64_t x53;
  uint64_t x54;
  uint64_t x55;
  uint64_t x57;
  fiat_p511_uint1 x59;
  fiat_p511_uint1 x61;
  fiat_p511_uint1 x63;
  fiat_p511_uint1 x65;
  fiat_p511_uint1 x67;
  fiat_p511_uint1 x69;

  fiat_p511_mulx_u64(&x40, &x41, x23, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x42, &x43, x40, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x44, &x45, x40, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x46, &x47, x40, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x48, &x49, x40, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x50, &x51, x40, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x52, &x53, x40, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x54, &x55, x40, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x56, &x57, x40, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x58, &x59, 0x0, x57, x54);
  fiat_p511_addcarryx_u64(&x60, &x61, x59, x55, x52);
  fiat_p511_addcarryx_u64(&x62, &x63, x61, x53, x50);
  fiat_p511_addcarryx_u64(&x64, &x65, x63, x51, x48);
  fiat_p511_addcarryx_u64(&x66, &x67, x65, x49, x46);
  fiat_p511_addcarryx_u64(&x68, &x69, x67, x47, x44);
  fiat_p511_addcarryx_u64(&x70, &x71, x69, x45, x42);
  }
  x72 = (x71 + x43);
  {
  fiat_p511_addcarryx_u64(&x73, &x74, 0x0, x23, x56);
  fiat_p511_addcarryx_u64(&x75, &x76, x74, x25, x58);
  fiat_p511_addcarryx_u64(&x77, &x78, x76, x27, x60);
  fiat_p511_addcarryx_u64(&x79, &x80, x78, x29, x62);
  fiat_p511_addcarryx_u64(&x81, &x82, x80, x31, x64);
  fiat_p511_addcarryx_u64(&x83, &x84, x82, x33, x66);
  fiat_p511_addcarryx_u64(&x85, &x86, x84, x35, x68);
  fiat_p511_addcarryx_u64(&x87, &x88, x86, x37, x70);
  fiat_p511_addcarryx_u64(&x89, &x90, x88, x39, x72);
  fiat_p511_mulx_u64(&x91, &x92, x1, (arg1[7]));
  fiat_p511_mulx_u64(&x93, &x94, x1, (arg1[6]));
  fiat_p511_mulx_u64(&x95, &x96, x1, (arg1[5]));
  fiat_p511_mulx_u64(&x97, &x98, x1, (arg1[4]));
  fiat_p511_mulx_u64(&x99, &x100, x1, (arg1[3]));
  fiat_p511_mulx_u64(&x101, &x102, x1, (arg1[2]));
  fiat_p511_mulx_u64(&x103, &x104, x1, (arg1[1]));
  fiat_p511_mulx_u64(&x105, &x106, x1, (arg1[0]));
  fiat_p511_addcarryx_u64(&x107, &x108, 0x0, x106, x103);
  fiat_p511_addcarryx_u64(&x109, &x110, x108, x104, x101);
  fiat_p511_addcarryx_u64(&x111, &x112, x110, x102, x99);
  fiat_p511_addcarryx_u64(&x113, &x114, x112, x100, x97);
  fiat_p511_addcarryx_u64(&x115, &x116, x114, x98, x95);
  fiat_p511_addcarryx_u64(&x117, &x118, x116, x96, x93);
  fiat_p511_addcarryx_u64(&x119, &x120, x118, x94, x91);
  }
  x121 = (x120 + x92);
  fiat_p511_addcarryx_u64(&x122, &x123, 0x0, x75, x105);
  fiat_p511_addcarryx_u64(&x124, &x125, x123, x77, x107);
  fiat_p511_addcarryx_u64(&x126, &x127, x125, x79, x109);
  fiat_p511_addcarryx_u64(&x128, &x129, x127, x81, x111);
  fiat_p511_addcarryx_u64(&x130, &x131, x129, x83, x113);
  fiat_p511_addcarryx_u64(&x132, &x133, x131, x85, x115);
  fiat_p511_addcarryx_u64(&x134, &x135, x133, x87, x117);
  fiat_p511_addcarryx_u64(&x136, &x137, x135, x89, x119);
  fiat_p511_addcarryx_u64(&x138, &x139, x137, x90, x121);
  fiat_p511_mulx_u64(&x140, &x141, x122, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x142, &x143, x140, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x144, &x145, x140, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x146, &x147, x140, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x148, &x149, x140, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x150, &x151, x140, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x152, &x153, x140, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x154, &x155, x140, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x156, &x157, x140, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x158, &x159, 0x0, x157, x154);
  fiat_p511_addcarryx_u64(&x160, &x161, x159, x155, x152);
  fiat_p511_addcarryx_u64(&x162, &x163, x161, x153, x150);
  fiat_p511_addcarryx_u64(&x164, &x165, x163, x151, x148);
  fiat_p511_addcarryx_u64(&x166, &x167, x165, x149, x146);
  fiat_p511_addcarryx_u64(&x168, &x169, x167, x147, x144);
  fiat_p511_addcarryx_u64(&x170, &x171, x169, x145, x142);
  x172 = (x171 + x143);
  fiat_p511_addcarryx_u64(&x173, &x174, 0x0, x122, x156);
  fiat_p511_addcarryx_u64(&x175, &x176, x174, x124, x158);
  fiat_p511_addcarryx_u64(&x177, &x178, x176, x126, x160);
  fiat_p511_addcarryx_u64(&x179, &x180, x178, x128, x162);
  fiat_p511_addcarryx_u64(&x181, &x182, x180, x130, x164);
  fiat_p511_addcarryx_u64(&x183, &x184, x182, x132, x166);
  fiat_p511_addcarryx_u64(&x185, &x186, x184, x134, x168);
  fiat_p511_addcarryx_u64(&x187, &x188, x186, x136, x170);
  fiat_p511_addcarryx_u64(&x189, &x190, x188, x138, x172);
  x191 = ((uint64_t)x190 + x139);
  fiat_p511_mulx_u64(&x192, &x193, x2, (arg1[7]));
  fiat_p511_mulx_u64(&x194, &x195, x2, (arg1[6]));
  fiat_p511_mulx_u64(&x196, &x197, x2, (arg1[5]));
  fiat_p511_mulx_u64(&x198, &x199, x2, (arg1[4]));
  fiat_p511_mulx_u64(&x200, &x201, x2, (arg1[3]));
  fiat_p511_mulx_u64(&x202, &x203, x2, (arg1[2]));
  fiat_p511_mulx_u64(&x204, &x205, x2, (arg1[1]));
  fiat_p511_mulx_u64(&x206, &x207, x2, (arg1[0]));
  fiat_p511_addcarryx_u64(&x208, &x209, 0x0, x207, x204);
  fiat_p511_addcarryx_u64(&x210, &x211, x209, x205, x202);
  fiat_p511_addcarryx_u64(&x212, &x213, x211, x203, x200);
  fiat_p511_addcarryx_u64(&x214, &x215, x213, x201, x198);
  fiat_p511_addcarryx_u64(&x216, &x217, x215, x199, x196);
  fiat_p511_addcarryx_u64(&x218, &x219, x217, x197, x194);
  fiat_p511_addcarryx_u64(&x220, &x221, x219, x195, x192);
  x222 = (x221 + x193);
  fiat_p511_addcarryx_u64(&x223, &x224, 0x0, x175, x206);
  fiat_p511_addcarryx_u64(&x225, &x226, x224, x177, x208);
  fiat_p511_addcarryx_u64(&x227, &x228, x226, x179, x210);
  fiat_p511_addcarryx_u64(&x229, &x230, x228, x181, x212);
  fiat_p511_addcarryx_u64(&x231, &x232, x230, x183, x214);
  fiat_p511_addcarryx_u64(&x233, &x234, x232, x185, x216);
  fiat_p511_addcarryx_u64(&x235, &x236, x234, x187, x218);
  fiat_p511_addcarryx_u64(&x237, &x238, x236, x189, x220);
  fiat_p511_addcarryx_u64(&x239, &x240, x238, x191, x222);
  fiat_p511_mulx_u64(&x241, &x242, x223, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x243, &x244, x241, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x245, &x246, x241, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x247, &x248, x241, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x249, &x250, x241, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x251, &x252, x241, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x253, &x254, x241, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x255, &x256, x241, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x257, &x258, x241, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x259, &x260, 0x0, x258, x255);
  fiat_p511_addcarryx_u64(&x261, &x262, x260, x256, x253);
  fiat_p511_addcarryx_u64(&x263, &x264, x262, x254, x251);
  fiat_p511_addcarryx_u64(&x265, &x266, x264, x252, x249);
  fiat_p511_addcarryx_u64(&x267, &x268, x266, x250, x247);
  fiat_p511_addcarryx_u64(&x269, &x270, x268, x248, x245);
  fiat_p511_addcarryx_u64(&x271, &x272, x270, x246, x243);
  x273 = (x272 + x244);
  fiat_p511_addcarryx_u64(&x274, &x275, 0x0, x223, x257);
  fiat_p511_addcarryx_u64(&x276, &x277, x275, x225, x259);
  fiat_p511_addcarryx_u64(&x278, &x279, x277, x227, x261);
  fiat_p511_addcarryx_u64(&x280, &x281, x279, x229, x263);
  fiat_p511_addcarryx_u64(&x282, &x283, x281, x231, x265);
  fiat_p511_addcarryx_u64(&x284, &x285, x283, x233, x267);
  fiat_p511_addcarryx_u64(&x286, &x287, x285, x235, x269);
  fiat_p511_addcarryx_u64(&x288, &x289, x287, x237, x271);
  fiat_p511_addcarryx_u64(&x290, &x291, x289, x239, x273);
  x292 = ((uint64_t)x291 + x240);
  fiat_p511_mulx_u64(&x293, &x294, x3, (arg1[7]));
  fiat_p511_mulx_u64(&x295, &x296, x3, (arg1[6]));
  fiat_p511_mulx_u64(&x297, &x298, x3, (arg1[5]));
  fiat_p511_mulx_u64(&x299, &x300, x3, (arg1[4]));
  fiat_p511_mulx_u64(&x301, &x302, x3, (arg1[3]));
  fiat_p511_mulx_u64(&x303, &x304, x3, (arg1[2]));
  fiat_p511_mulx_u64(&x305, &x306, x3, (arg1[1]));
  fiat_p511_mulx_u64(&x307, &x308, x3, (arg1[0]));
  fiat_p511_addcarryx_u64(&x309, &x310, 0x0, x308, x305);
  fiat_p511_addcarryx_u64(&x311, &x312, x310, x306, x303);
  fiat_p511_addcarryx_u64(&x313, &x314, x312, x304, x301);
  fiat_p511_addcarryx_u64(&x315, &x316, x314, x302, x299);
  fiat_p511_addcarryx_u64(&x317, &x318, x316, x300, x297);
  fiat_p511_addcarryx_u64(&x319, &x320, x318, x298, x295);
  fiat_p511_addcarryx_u64(&x321, &x322, x320, x296, x293);
  x323 = (x322 + x294);
  fiat_p511_addcarryx_u64(&x324, &x325, 0x0, x276, x307);
  fiat_p511_addcarryx_u64(&x326, &x327, x325, x278, x309);
  fiat_p511_addcarryx_u64(&x328, &x329, x327, x280, x311);
  fiat_p511_addcarryx_u64(&x330, &x331, x329, x282, x313);
  fiat_p511_addcarryx_u64(&x332, &x333, x331, x284, x315);
  fiat_p511_addcarryx_u64(&x334, &x335, x333, x286, x317);
  fiat_p511_addcarryx_u64(&x336, &x337, x335, x288, x319);
  fiat_p511_addcarryx_u64(&x338, &x339, x337, x290, x321);
  fiat_p511_addcarryx_u64(&x340, &x341, x339, x292, x323);
  fiat_p511_mulx_u64(&x342, &x343, x324, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x344, &x345, x342, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x346, &x347, x342, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x348, &x349, x342, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x350, &x351, x342, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x352, &x353, x342, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x354, &x355, x342, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x356, &x357, x342, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x358, &x359, x342, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x360, &x361, 0x0, x359, x356);
  fiat_p511_addcarryx_u64(&x362, &x363, x361, x357, x354);
  fiat_p511_addcarryx_u64(&x364, &x365, x363, x355, x352);
  fiat_p511_addcarryx_u64(&x366, &x367, x365, x353, x350);
  fiat_p511_addcarryx_u64(&x368, &x369, x367, x351, x348);
  fiat_p511_addcarryx_u64(&x370, &x371, x369, x349, x346);
  fiat_p511_addcarryx_u64(&x372, &x373, x371, x347, x344);
  x374 = (x373 + x345);
  fiat_p511_addcarryx_u64(&x375, &x376, 0x0, x324, x358);
  fiat_p511_addcarryx_u64(&x377, &x378, x376, x326, x360);
  fiat_p511_addcarryx_u64(&x379, &x380, x378, x328, x362);
  fiat_p511_addcarryx_u64(&x381, &x382, x380, x330, x364);
  fiat_p511_addcarryx_u64(&x383, &x384, x382, x332, x366);
  fiat_p511_addcarryx_u64(&x385, &x386, x384, x334, x368);
  fiat_p511_addcarryx_u64(&x387, &x388, x386, x336, x370);
  fiat_p511_addcarryx_u64(&x389, &x390, x388, x338, x372);
  fiat_p511_addcarryx_u64(&x391, &x392, x390, x340, x374);
  x393 = ((uint64_t)x392 + x341);
  fiat_p511_mulx_u64(&x394, &x395, x4, (arg1[7]));
  fiat_p511_mulx_u64(&x396, &x397, x4, (arg1[6]));
  fiat_p511_mulx_u64(&x398, &x399, x4, (arg1[5]));
  fiat_p511_mulx_u64(&x400, &x401, x4, (arg1[4]));
  fiat_p511_mulx_u64(&x402, &x403, x4, (arg1[3]));
  fiat_p511_mulx_u64(&x404, &x405, x4, (arg1[2]));
  fiat_p511_mulx_u64(&x406, &x407, x4, (arg1[1]));
  fiat_p511_mulx_u64(&x408, &x409, x4, (arg1[0]));
  fiat_p511_addcarryx_u64(&x410, &x411, 0x0, x409, x406);
  fiat_p511_addcarryx_u64(&x412, &x413, x411, x407, x404);
  fiat_p511_addcarryx_u64(&x414, &x415, x413, x405, x402);
  fiat_p511_addcarryx_u64(&x416, &x417, x415, x403, x400);
  fiat_p511_addcarryx_u64(&x418, &x419, x417, x401, x398);
  fiat_p511_addcarryx_u64(&x420, &x421, x419, x399, x396);
  fiat_p511_addcarryx_u64(&x422, &x423, x421, x397, x394);
  x424 = (x423 + x395);
  fiat_p511_addcarryx_u64(&x425, &x426, 0x0, x377, x408);
  fiat_p511_addcarryx_u64(&x427, &x428, x426, x379, x410);
  fiat_p511_addcarryx_u64(&x429, &x430, x428, x381, x412);
  fiat_p511_addcarryx_u64(&x431, &x432, x430, x383, x414);
  fiat_p511_addcarryx_u64(&x433, &x434, x432, x385, x416);
  fiat_p511_addcarryx_u64(&x435, &x436, x434, x387, x418);
  fiat_p511_addcarryx_u64(&x437, &x438, x436, x389, x420);
  fiat_p511_addcarryx_u64(&x439, &x440, x438, x391, x422);
  fiat_p511_addcarryx_u64(&x441, &x442, x440, x393, x424);
  fiat_p511_mulx_u64(&x443, &x444, x425, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x445, &x446, x443, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x447, &x448, x443, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x449, &x450, x443, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x451, &x452, x443, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x453, &x454, x443, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x455, &x456, x443, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x457, &x458, x443, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x459, &x460, x443, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x461, &x462, 0x0, x460, x457);
  fiat_p511_addcarryx_u64(&x463, &x464, x462, x458, x455);
  fiat_p511_addcarryx_u64(&x465, &x466, x464, x456, x453);
  fiat_p511_addcarryx_u64(&x467, &x468, x466, x454, x451);
  fiat_p511_addcarryx_u64(&x469, &x470, x468, x452, x449);
  fiat_p511_addcarryx_u64(&x471, &x472, x470, x450, x447);
  fiat_p511_addcarryx_u64(&x473, &x474, x472, x448, x445);
  x475 = (x474 + x446);
  fiat_p511_addcarryx_u64(&x476, &x477, 0x0, x425, x459);
  fiat_p511_addcarryx_u64(&x478, &x479, x477, x427, x461);
  fiat_p511_addcarryx_u64(&x480, &x481, x479, x429, x463);
  fiat_p511_addcarryx_u64(&x482, &x483, x481, x431, x465);
  fiat_p511_addcarryx_u64(&x484, &x485, x483, x433, x467);
  fiat_p511_addcarryx_u64(&x486, &x487, x485, x435, x469);
  fiat_p511_addcarryx_u64(&x488, &x489, x487, x437, x471);
  fiat_p511_addcarryx_u64(&x490, &x491, x489, x439, x473);
  fiat_p511_addcarryx_u64(&x492, &x493, x491, x441, x475);
  x494 = ((uint64_t)x493 + x442);
  fiat_p511_mulx_u64(&x495, &x496, x5, (arg1[7]));
  fiat_p511_mulx_u64(&x497, &x498, x5, (arg1[6]));
  fiat_p511_mulx_u64(&x499, &x500, x5, (arg1[5]));
  fiat_p511_mulx_u64(&x501, &x502, x5, (arg1[4]));
  fiat_p511_mulx_u64(&x503, &x504, x5, (arg1[3]));
  fiat_p511_mulx_u64(&x505, &x506, x5, (arg1[2]));
  fiat_p511_mulx_u64(&x507, &x508, x5, (arg1[1]));
  fiat_p511_mulx_u64(&x509, &x510, x5, (arg1[0]));
  fiat_p511_addcarryx_u64(&x511, &x512, 0x0, x510, x507);
  fiat_p511_addcarryx_u64(&x513, &x514, x512, x508, x505);
  fiat_p511_addcarryx_u64(&x515, &x516, x514, x506, x503);
  fiat_p511_addcarryx_u64(&x517, &x518, x516, x504, x501);
  fiat_p511_addcarryx_u64(&x519, &x520, x518, x502, x499);
  fiat_p511_addcarryx_u64(&x521, &x522, x520, x500, x497);
  fiat_p511_addcarryx_u64(&x523, &x524, x522, x498, x495);
  x525 = (x524 + x496);
  fiat_p511_addcarryx_u64(&x526, &x527, 0x0, x478, x509);
  fiat_p511_addcarryx_u64(&x528, &x529, x527, x480, x511);
  fiat_p511_addcarryx_u64(&x530, &x531, x529, x482, x513);
  fiat_p511_addcarryx_u64(&x532, &x533, x531, x484, x515);
  fiat_p511_addcarryx_u64(&x534, &x535, x533, x486, x517);
  fiat_p511_addcarryx_u64(&x536, &x537, x535, x488, x519);
  fiat_p511_addcarryx_u64(&x538, &x539, x537, x490, x521);
  fiat_p511_addcarryx_u64(&x540, &x541, x539, x492, x523);
  fiat_p511_addcarryx_u64(&x542, &x543, x541, x494, x525);
  fiat_p511_mulx_u64(&x544, &x545, x526, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x546, &x547, x544, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x548, &x549, x544, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x550, &x551, x544, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x552, &x553, x544, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x554, &x555, x544, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x556, &x557, x544, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x558, &x559, x544, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x560, &x561, x544, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x562, &x563, 0x0, x561, x558);
  fiat_p511_addcarryx_u64(&x564, &x565, x563, x559, x556);
  fiat_p511_addcarryx_u64(&x566, &x567, x565, x557, x554);
  fiat_p511_addcarryx_u64(&x568, &x569, x567, x555, x552);
  fiat_p511_addcarryx_u64(&x570, &x571, x569, x553, x550);
  fiat_p511_addcarryx_u64(&x572, &x573, x571, x551, x548);
  fiat_p511_addcarryx_u64(&x574, &x575, x573, x549, x546);
  x576 = (x575 + x547);
  fiat_p511_addcarryx_u64(&x577, &x578, 0x0, x526, x560);
  fiat_p511_addcarryx_u64(&x579, &x580, x578, x528, x562);
  fiat_p511_addcarryx_u64(&x581, &x582, x580, x530, x564);
  fiat_p511_addcarryx_u64(&x583, &x584, x582, x532, x566);
  fiat_p511_addcarryx_u64(&x585, &x586, x584, x534, x568);
  fiat_p511_addcarryx_u64(&x587, &x588, x586, x536, x570);
  fiat_p511_addcarryx_u64(&x589, &x590, x588, x538, x572);
  fiat_p511_addcarryx_u64(&x591, &x592, x590, x540, x574);
  fiat_p511_addcarryx_u64(&x593, &x594, x592, x542, x576);
  x595 = ((uint64_t)x594 + x543);
  fiat_p511_mulx_u64(&x596, &x597, x6, (arg1[7]));
  fiat_p511_mulx_u64(&x598, &x599, x6, (arg1[6]));
  fiat_p511_mulx_u64(&x600, &x601, x6, (arg1[5]));
  fiat_p511_mulx_u64(&x602, &x603, x6, (arg1[4]));
  fiat_p511_mulx_u64(&x604, &x605, x6, (arg1[3]));
  fiat_p511_mulx_u64(&x606, &x607, x6, (arg1[2]));
  fiat_p511_mulx_u64(&x608, &x609, x6, (arg1[1]));
  fiat_p511_mulx_u64(&x610, &x611, x6, (arg1[0]));
  fiat_p511_addcarryx_u64(&x612, &x613, 0x0, x611, x608);
  fiat_p511_addcarryx_u64(&x614, &x615, x613, x609, x606);
  fiat_p511_addcarryx_u64(&x616, &x617, x615, x607, x604);
  fiat_p511_addcarryx_u64(&x618, &x619, x617, x605, x602);
  fiat_p511_addcarryx_u64(&x620, &x621, x619, x603, x600);
  fiat_p511_addcarryx_u64(&x622, &x623, x621, x601, x598);
  fiat_p511_addcarryx_u64(&x624, &x625, x623, x599, x596);
  x626 = (x625 + x597);
  fiat_p511_addcarryx_u64(&x627, &x628, 0x0, x579, x610);
  fiat_p511_addcarryx_u64(&x629, &x630, x628, x581, x612);
  fiat_p511_addcarryx_u64(&x631, &x632, x630, x583, x614);
  fiat_p511_addcarryx_u64(&x633, &x634, x632, x585, x616);
  fiat_p511_addcarryx_u64(&x635, &x636, x634, x587, x618);
  fiat_p511_addcarryx_u64(&x637, &x638, x636, x589, x620);
  fiat_p511_addcarryx_u64(&x639, &x640, x638, x591, x622);
  fiat_p511_addcarryx_u64(&x641, &x642, x640, x593, x624);
  fiat_p511_addcarryx_u64(&x643, &x644, x642, x595, x626);
  fiat_p511_mulx_u64(&x645, &x646, x627, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x647, &x648, x645, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x649, &x650, x645, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x651, &x652, x645, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x653, &x654, x645, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x655, &x656, x645, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x657, &x658, x645, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x659, &x660, x645, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x661, &x662, x645, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x663, &x664, 0x0, x662, x659);
  fiat_p511_addcarryx_u64(&x665, &x666, x664, x660, x657);
  fiat_p511_addcarryx_u64(&x667, &x668, x666, x658, x655);
  fiat_p511_addcarryx_u64(&x669, &x670, x668, x656, x653);
  fiat_p511_addcarryx_u64(&x671, &x672, x670, x654, x651);
  fiat_p511_addcarryx_u64(&x673, &x674, x672, x652, x649);
  fiat_p511_addcarryx_u64(&x675, &x676, x674, x650, x647);
  const uint64_t x677 = (x676 + x648);
  fiat_p511_addcarryx_u64(&x678, &x679, 0x0, x627, x661);
  fiat_p511_addcarryx_u64(&x680, &x681, x679, x629, x663);
  fiat_p511_addcarryx_u64(&x682, &x683, x681, x631, x665);
  fiat_p511_addcarryx_u64(&x684, &x685, x683, x633, x667);
  fiat_p511_addcarryx_u64(&x686, &x687, x685, x635, x669);
  fiat_p511_addcarryx_u64(&x688, &x689, x687, x637, x671);
  fiat_p511_addcarryx_u64(&x690, &x691, x689, x639, x673);
  fiat_p511_addcarryx_u64(&x692, &x693, x691, x641, x675);
  fiat_p511_addcarryx_u64(&x694, &x695, x693, x643, x677);
  const uint64_t x696 = ((uint64_t)x695 + x644);
  fiat_p511_mulx_u64(&x697, &x698, x7, (arg1[7]));
  fiat_p511_mulx_u64(&x699, &x700, x7, (arg1[6]));
  fiat_p511_mulx_u64(&x701, &x702, x7, (arg1[5]));
  fiat_p511_mulx_u64(&x703, &x704, x7, (arg1[4]));
  fiat_p511_mulx_u64(&x705, &x706, x7, (arg1[3]));
  fiat_p511_mulx_u64(&x707, &x708, x7, (arg1[2]));
  fiat_p511_mulx_u64(&x709, &x710, x7, (arg1[1]));
  fiat_p511_mulx_u64(&x711, &x712, x7, (arg1[0]));
  fiat_p511_addcarryx_u64(&x713, &x714, 0x0, x712, x709);
  fiat_p511_addcarryx_u64(&x715, &x716, x714, x710, x707);
  fiat_p511_addcarryx_u64(&x717, &x718, x716, x708, x705);
  fiat_p511_addcarryx_u64(&x719, &x720, x718, x706, x703);
  fiat_p511_addcarryx_u64(&x721, &x722, x720, x704, x701);
  fiat_p511_addcarryx_u64(&x723, &x724, x722, x702, x699);
  fiat_p511_addcarryx_u64(&x725, &x726, x724, x700, x697);
  x727 = (x726 + x698);
  fiat_p511_addcarryx_u64(&x728, &x729, 0x0, x680, x711);
  fiat_p511_addcarryx_u64(&x730, &x731, x729, x682, x713);
  fiat_p511_addcarryx_u64(&x732, &x733, x731, x684, x715);
  fiat_p511_addcarryx_u64(&x734, &x735, x733, x686, x717);
  fiat_p511_addcarryx_u64(&x736, &x737, x735, x688, x719);
  fiat_p511_addcarryx_u64(&x738, &x739, x737, x690, x721);
  fiat_p511_addcarryx_u64(&x740, &x741, x739, x692, x723);
  fiat_p511_addcarryx_u64(&x742, &x743, x741, x694, x725);
  fiat_p511_addcarryx_u64(&x744, &x745, x743, x696, x727);
  fiat_p511_mulx_u64(&x746, &x747, x728, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x748, &x749, x746, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x750, &x751, x746, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x752, &x753, x746, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x754, &x755, x746, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x756, &x757, x746, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x758, &x759, x746, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x760, &x761, x746, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x762, &x763, x746, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x764, &x765, 0x0, x763, x760);
  fiat_p511_addcarryx_u64(&x766, &x767, x765, x761, x758);
  fiat_p511_addcarryx_u64(&x768, &x769, x767, x759, x756);
  fiat_p511_addcarryx_u64(&x770, &x771, x769, x757, x754);
  fiat_p511_addcarryx_u64(&x772, &x773, x771, x755, x752);
  fiat_p511_addcarryx_u64(&x774, &x775, x773, x753, x750);
  fiat_p511_addcarryx_u64(&x776, &x777, x775, x751, x748);
  x778 = (x777 + x749);
  fiat_p511_addcarryx_u64(&x779, &x780, 0x0, x728, x762);
  fiat_p511_addcarryx_u64(&x781, &x782, x780, x730, x764);
  fiat_p511_addcarryx_u64(&x783, &x784, x782, x732, x766);
  fiat_p511_addcarryx_u64(&x785, &x786, x784, x734, x768);
  fiat_p511_addcarryx_u64(&x787, &x788, x786, x736, x770);
  fiat_p511_addcarryx_u64(&x789, &x790, x788, x738, x772);
  fiat_p511_addcarryx_u64(&x791, &x792, x790, x740, x774);
  fiat_p511_addcarryx_u64(&x793, &x794, x792, x742, x776);
  fiat_p511_addcarryx_u64(&x795, &x796, x794, x744, x778);
  x797 = ((uint64_t)x796 + x745);
  fiat_p511_subborrowx_u64(&x798, &x799, 0x0, x781, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_subborrowx_u64(&x800, &x801, x799, x783, UINT64_C(0xc2721bf457aca835));
  fiat_p511_subborrowx_u64(&x802, &x803, x801, x785, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_subborrowx_u64(&x804, &x805, x803, x787, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_subborrowx_u64(&x806, &x807, x805, x789, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_subborrowx_u64(&x808, &x809, x807, x791, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_subborrowx_u64(&x810, &x811, x809, x793, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_subborrowx_u64(&x812, &x813, x811, x795, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_subborrowx_u64(&x814, &x815, x813, x797, 0x0);
  fiat_p511_cmovznz_u64(&x816, x815, x798, x781);
  fiat_p511_cmovznz_u64(&x817, x815, x800, x783);
  fiat_p511_cmovznz_u64(&x818, x815, x802, x785);
  fiat_p511_cmovznz_u64(&x819, x815, x804, x787);
  fiat_p511_cmovznz_u64(&x820, x815, x806, x789);
  fiat_p511_cmovznz_u64(&x821, x815, x808, x791);
  fiat_p511_cmovznz_u64(&x822, x815, x810, x793);
  fiat_p511_cmovznz_u64(&x823, x815, x812, x795);
  out1[0] = x816;
  out1[1] = x817;
  out1[2] = x818;
  out1[3] = x819;
  out1[4] = x820;
  out1[5] = x821;
  out1[6] = x822;
  out1[7] = x823;
}

/*
 * The function fiat_p511_add adds two field elements in the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) + eval (from_montgomery arg2)) mod m
 *   0 ≤ eval out1 < m
 *
 */
void fiat_p511_add(fiat_p511_montgomery_domain_field_element out1, const fiat_p511_montgomery_domain_field_element arg1, const fiat_p511_montgomery_domain_field_element arg2) {
  uint64_t x1;
  uint64_t x3;
  fiat_p511_uint1 x4;
  uint64_t x5;
  uint64_t x7;
  fiat_p511_uint1 x8;
  uint64_t x9;
  uint64_t x11;
  fiat_p511_uint1 x12;
  uint64_t x13;
  uint64_t x15;
  fiat_p511_uint1 x16;
  uint64_t x17;
  fiat_p511_uint1 x18;
  uint64_t x19;
  uint64_t x21;
  fiat_p511_uint1 x22;
  uint64_t x23;
  uint64_t x25;
  fiat_p511_uint1 x26;
  uint64_t x27;
  uint64_t x29;
  fiat_p511_uint1 x30;
  uint64_t x31;
  uint64_t x33;
  fiat_p511_uint1 x34;
  {
  fiat_p511_uint1 x2;
  fiat_p511_addcarryx_u64(&x1, &x2, 0x0, (arg1[0]), (arg2[0]));
  fiat_p511_addcarryx_u64(&x3, &x4, x2, (arg1[1]), (arg2[1]));
  }
  {
  fiat_p511_uint1 x6;
  fiat_p511_addcarryx_u64(&x5, &x6, x4, (arg1[2]), (arg2[2]));
  fiat_p511_addcarryx_u64(&x7, &x8, x6, (arg1[3]), (arg2[3]));
  }
  {
  fiat_p511_uint1 x10;
  fiat_p511_addcarryx_u64(&x9, &x10, x8, (arg1[4]), (arg2[4]));
  fiat_p511_addcarryx_u64(&x11, &x12, x10, (arg1[5]), (arg2[5]));
  }
  {
  fiat_p511_uint1 x14;
  fiat_p511_addcarryx_u64(&x13, &x14, x12, (arg1[6]), (arg2[6]));
  fiat_p511_addcarryx_u64(&x15, &x16, x14, (arg1[7]), (arg2[7]));
  }
  fiat_p511_subborrowx_u64(&x17, &x18, 0x0, x1, UINT64_C(0x1b81b90533c6c87b));
  {
  fiat_p511_uint1 x20;
  fiat_p511_subborrowx_u64(&x19, &x20, x18, x3, UINT64_C(0xc2721bf457aca835));
  fiat_p511_subborrowx_u64(&x21, &x22, x20, x5, UINT64_C(0x516730cc1f0b4f25));
  }
  {
  fiat_p511_uint1 x24;
  fiat_p511_subborrowx_u64(&x23, &x24, x22, x7, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_subborrowx_u64(&x25, &x26, x24, x9, UINT64_C(0x5afbfcc69322c9cd));
  }
  {
  fiat_p511_uint1 x28;
  fiat_p511_subborrowx_u64(&x27, &x28, x26, x11, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_subborrowx_u64(&x29, &x30, x28, x13, UINT64_C(0xfc8ab0d15e3e4c4a));
  }
  {
  fiat_p511_uint1 x32;
  fiat_p511_subborrowx_u64(&x31, &x32, x30, x15, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_subborrowx_u64(&x33, &x34, x32, x16, 0x0);
  }
  register const uint64_t x35 = x34;
  fiat_p511_cmovznz_u64(&out1[0], x35, x17, x1);
  fiat_p511_cmovznz_u64(&out1[1], x35, x19, x3);
  fiat_p511_cmovznz_u64(&out1[2], x35, x21, x5);
  fiat_p511_cmovznz_u64(&out1[3], x35, x23, x7);
  fiat_p511_cmovznz_u64(&out1[4], x35, x25, x9);
  fiat_p511_cmovznz_u64(&out1[5], x35, x27, x11);
  fiat_p511_cmovznz_u64(&out1[6], x35, x29, x13);
  fiat_p511_cmovznz_u64(&out1[7], x35, x31, x15);
}

/*
 * The function fiat_p511_sub subtracts two field elements in the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) - eval (from_montgomery arg2)) mod m
 *   0 ≤ eval out1 < m
 *
 */
void fiat_p511_sub(fiat_p511_montgomery_domain_field_element out1, const fiat_p511_montgomery_domain_field_element arg1, const fiat_p511_montgomery_domain_field_element arg2) {
  uint64_t x1;
  fiat_p511_uint1 x2;
  uint64_t x3;
  fiat_p511_uint1 x4;
  uint64_t x5;
  fiat_p511_uint1 x6;
  uint64_t x7;
  fiat_p511_uint1 x8;
  uint64_t x9;
  fiat_p511_uint1 x10;
  uint64_t x11;
  fiat_p511_uint1 x12;
  uint64_t x13;
  fiat_p511_uint1 x14;
  uint64_t x15;
  fiat_p511_uint1 x16;
  uint64_t x17;
  uint64_t x18;
  fiat_p511_uint1 x19;
  uint64_t x20;
  fiat_p511_uint1 x21;
  uint64_t x22;
  fiat_p511_uint1 x23;
  uint64_t x24;
  fiat_p511_uint1 x25;
  uint64_t x26;
  fiat_p511_uint1 x27;
  uint64_t x28;
  fiat_p511_uint1 x29;
  uint64_t x30;
  fiat_p511_uint1 x31;
  uint64_t x32;
  fiat_p511_uint1 x33;
  fiat_p511_subborrowx_u64(&x1, &x2, 0x0, (arg1[0]), (arg2[0]));
  fiat_p511_subborrowx_u64(&x3, &x4, x2, (arg1[1]), (arg2[1]));
  fiat_p511_subborrowx_u64(&x5, &x6, x4, (arg1[2]), (arg2[2]));
  fiat_p511_subborrowx_u64(&x7, &x8, x6, (arg1[3]), (arg2[3]));
  fiat_p511_subborrowx_u64(&x9, &x10, x8, (arg1[4]), (arg2[4]));
  fiat_p511_subborrowx_u64(&x11, &x12, x10, (arg1[5]), (arg2[5]));
  fiat_p511_subborrowx_u64(&x13, &x14, x12, (arg1[6]), (arg2[6]));
  fiat_p511_subborrowx_u64(&x15, &x16, x14, (arg1[7]), (arg2[7]));
  fiat_p511_cmovznz_u64(&x17, x16, 0x0, UINT64_C(0xffffffffffffffff));
  fiat_p511_addcarryx_u64(&x18, &x19, 0x0, x1, (x17 & UINT64_C(0x1b81b90533c6c87b)));
  fiat_p511_addcarryx_u64(&x20, &x21, x19, x3, (x17 & UINT64_C(0xc2721bf457aca835)));
  fiat_p511_addcarryx_u64(&x22, &x23, x21, x5, (x17 & UINT64_C(0x516730cc1f0b4f25)));
  fiat_p511_addcarryx_u64(&x24, &x25, x23, x7, (x17 & UINT64_C(0xa7aac6c567f35507)));
  fiat_p511_addcarryx_u64(&x26, &x27, x25, x9, (x17 & UINT64_C(0x5afbfcc69322c9cd)));
  fiat_p511_addcarryx_u64(&x28, &x29, x27, x11, (x17 & UINT64_C(0xb42d083aedc88c42)));
  fiat_p511_addcarryx_u64(&x30, &x31, x29, x13, (x17 & UINT64_C(0xfc8ab0d15e3e4c4a)));
  fiat_p511_addcarryx_u64(&x32, &x33, x31, x15, (x17 & UINT64_C(0x65b48e8f740f89bf)));
  out1[0] = x18;
  out1[1] = x20;
  out1[2] = x22;
  out1[3] = x24;
  out1[4] = x26;
  out1[5] = x28;
  out1[6] = x30;
  out1[7] = x32;
}

/*
 * The function fiat_p511_opp negates a field element in the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = -eval (from_montgomery arg1) mod m
 *   0 ≤ eval out1 < m
 *
 */
void fiat_p511_opp(fiat_p511_montgomery_domain_field_element out1, const fiat_p511_montgomery_domain_field_element arg1) {
  uint64_t x1;
  fiat_p511_uint1 x2;
  uint64_t x3;
  fiat_p511_uint1 x4;
  uint64_t x5;
  fiat_p511_uint1 x6;
  uint64_t x7;
  fiat_p511_uint1 x8;
  uint64_t x9;
  fiat_p511_uint1 x10;
  uint64_t x11;
  fiat_p511_uint1 x12;
  uint64_t x13;
  fiat_p511_uint1 x14;
  uint64_t x15;
  fiat_p511_uint1 x16;
  uint64_t x17;
  fiat_p511_uint1 x19;
  fiat_p511_uint1 x21;
  fiat_p511_uint1 x23;
  fiat_p511_uint1 x25;
  fiat_p511_uint1 x27;
  fiat_p511_uint1 x29;
  fiat_p511_uint1 x31;
  fiat_p511_uint1 x33;
  fiat_p511_subborrowx_u64(&x1, &x2, 0x0, 0x0, (arg1[0]));
  fiat_p511_subborrowx_u64(&x3, &x4, x2, 0x0, (arg1[1]));
  fiat_p511_subborrowx_u64(&x5, &x6, x4, 0x0, (arg1[2]));
  fiat_p511_subborrowx_u64(&x7, &x8, x6, 0x0, (arg1[3]));
  fiat_p511_subborrowx_u64(&x9, &x10, x8, 0x0, (arg1[4]));
  fiat_p511_subborrowx_u64(&x11, &x12, x10, 0x0, (arg1[5]));
  fiat_p511_subborrowx_u64(&x13, &x14, x12, 0x0, (arg1[6]));
  fiat_p511_subborrowx_u64(&x15, &x16, x14, 0x0, (arg1[7]));
  fiat_p511_cmovznz_u64(&x17, x16, 0x0, UINT64_C(0xffffffffffffffff));
  fiat_p511_addcarryx_u64(&out1[0], &x19, 0x0, x1, (x17 & UINT64_C(0x1b81b90533c6c87b)));
  fiat_p511_addcarryx_u64(&out1[1], &x21, x19, x3, (x17 & UINT64_C(0xc2721bf457aca835)));
  fiat_p511_addcarryx_u64(&out1[2], &x23, x21, x5, (x17 & UINT64_C(0x516730cc1f0b4f25)));
  fiat_p511_addcarryx_u64(&out1[3], &x25, x23, x7, (x17 & UINT64_C(0xa7aac6c567f35507)));
  fiat_p511_addcarryx_u64(&out1[4], &x27, x25, x9, (x17 & UINT64_C(0x5afbfcc69322c9cd)));
  fiat_p511_addcarryx_u64(&out1[5], &x29, x27, x11, (x17 & UINT64_C(0xb42d083aedc88c42)));
  fiat_p511_addcarryx_u64(&out1[6], &x31, x29, x13, (x17 & UINT64_C(0xfc8ab0d15e3e4c4a)));
  fiat_p511_addcarryx_u64(&out1[7], &x33, x31, x15, (x17 & UINT64_C(0x65b48e8f740f89bf)));
}

/*
 * The function fiat_p511_from_montgomery translates a field element out of the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval out1 mod m = (eval arg1 * ((2^64)⁻¹ mod m)^8) mod m
 *   0 ≤ eval out1 < m
 *
 */
void fiat_p511_from_montgomery(fiat_p511_non_montgomery_domain_field_element out1, const fiat_p511_montgomery_domain_field_element arg1) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  uint64_t x9;
  uint64_t x10;
  uint64_t x11;
  uint64_t x12;
  uint64_t x13;
  uint64_t x14;
  uint64_t x15;
  uint64_t x16;
  uint64_t x17;
  uint64_t x18;
  uint64_t x19;
  uint64_t x20;
  fiat_p511_uint1 x21;
  uint64_t x22;
  fiat_p511_uint1 x23;
  uint64_t x24;
  fiat_p511_uint1 x25;
  uint64_t x26;
  fiat_p511_uint1 x27;
  uint64_t x28;
  fiat_p511_uint1 x29;
  uint64_t x30;
  fiat_p511_uint1 x31;
  uint64_t x32;
  fiat_p511_uint1 x33;
  uint64_t x34;
  fiat_p511_uint1 x35;
  uint64_t x36;
  fiat_p511_uint1 x37;
  uint64_t x38;
  fiat_p511_uint1 x39;
  uint64_t x40;
  fiat_p511_uint1 x41;
  uint64_t x42;
  fiat_p511_uint1 x43;
  uint64_t x44;
  fiat_p511_uint1 x45;
  uint64_t x46;
  fiat_p511_uint1 x47;
  uint64_t x48;
  fiat_p511_uint1 x49;
  uint64_t x50;
  fiat_p511_uint1 x51;
  uint64_t x52;
  fiat_p511_uint1 x53;
  uint64_t x54;
  fiat_p511_uint1 x55;
  uint64_t x56;
  fiat_p511_uint1 x57;
  uint64_t x58;
  fiat_p511_uint1 x59;
  uint64_t x60;
  fiat_p511_uint1 x61;
  uint64_t x62;
  fiat_p511_uint1 x63;
  uint64_t x64;
  uint64_t x65;
  uint64_t x66;
  uint64_t x67;
  uint64_t x68;
  uint64_t x69;
  uint64_t x70;
  uint64_t x71;
  uint64_t x72;
  uint64_t x73;
  uint64_t x74;
  uint64_t x75;
  uint64_t x76;
  uint64_t x77;
  uint64_t x78;
  uint64_t x79;
  uint64_t x80;
  uint64_t x81;
  uint64_t x82;
  fiat_p511_uint1 x83;
  uint64_t x84;
  fiat_p511_uint1 x85;
  uint64_t x86;
  fiat_p511_uint1 x87;
  uint64_t x88;
  fiat_p511_uint1 x89;
  uint64_t x90;
  fiat_p511_uint1 x91;
  uint64_t x92;
  fiat_p511_uint1 x93;
  uint64_t x94;
  fiat_p511_uint1 x95;
  uint64_t x96;
  fiat_p511_uint1 x97;
  uint64_t x98;
  fiat_p511_uint1 x99;
  uint64_t x100;
  fiat_p511_uint1 x101;
  uint64_t x102;
  fiat_p511_uint1 x103;
  uint64_t x104;
  fiat_p511_uint1 x105;
  uint64_t x106;
  fiat_p511_uint1 x107;
  uint64_t x108;
  fiat_p511_uint1 x109;
  uint64_t x110;
  fiat_p511_uint1 x111;
  uint64_t x112;
  fiat_p511_uint1 x113;
  uint64_t x114;
  fiat_p511_uint1 x115;
  uint64_t x116;
  fiat_p511_uint1 x117;
  uint64_t x118;
  fiat_p511_uint1 x119;
  uint64_t x120;
  fiat_p511_uint1 x121;
  uint64_t x122;
  fiat_p511_uint1 x123;
  uint64_t x124;
  fiat_p511_uint1 x125;
  uint64_t x126;
  uint64_t x127;
  uint64_t x128;
  uint64_t x129;
  uint64_t x130;
  uint64_t x131;
  uint64_t x132;
  uint64_t x133;
  uint64_t x134;
  uint64_t x135;
  uint64_t x136;
  uint64_t x137;
  uint64_t x138;
  uint64_t x139;
  uint64_t x140;
  uint64_t x141;
  uint64_t x142;
  uint64_t x143;
  uint64_t x144;
  fiat_p511_uint1 x145;
  uint64_t x146;
  fiat_p511_uint1 x147;
  uint64_t x148;
  fiat_p511_uint1 x149;
  uint64_t x150;
  fiat_p511_uint1 x151;
  uint64_t x152;
  fiat_p511_uint1 x153;
  uint64_t x154;
  fiat_p511_uint1 x155;
  uint64_t x156;
  fiat_p511_uint1 x157;
  uint64_t x158;
  fiat_p511_uint1 x159;
  uint64_t x160;
  fiat_p511_uint1 x161;
  uint64_t x162;
  fiat_p511_uint1 x163;
  uint64_t x164;
  fiat_p511_uint1 x165;
  uint64_t x166;
  fiat_p511_uint1 x167;
  uint64_t x168;
  fiat_p511_uint1 x169;
  uint64_t x170;
  fiat_p511_uint1 x171;
  uint64_t x172;
  fiat_p511_uint1 x173;
  uint64_t x174;
  fiat_p511_uint1 x175;
  uint64_t x176;
  fiat_p511_uint1 x177;
  uint64_t x178;
  fiat_p511_uint1 x179;
  uint64_t x180;
  fiat_p511_uint1 x181;
  uint64_t x182;
  fiat_p511_uint1 x183;
  uint64_t x184;
  fiat_p511_uint1 x185;
  uint64_t x186;
  fiat_p511_uint1 x187;
  uint64_t x188;
  uint64_t x189;
  uint64_t x190;
  uint64_t x191;
  uint64_t x192;
  uint64_t x193;
  uint64_t x194;
  uint64_t x195;
  uint64_t x196;
  uint64_t x197;
  uint64_t x198;
  uint64_t x199;
  uint64_t x200;
  uint64_t x201;
  uint64_t x202;
  uint64_t x203;
  uint64_t x204;
  uint64_t x205;
  uint64_t x206;
  fiat_p511_uint1 x207;
  uint64_t x208;
  fiat_p511_uint1 x209;
  uint64_t x210;
  fiat_p511_uint1 x211;
  uint64_t x212;
  fiat_p511_uint1 x213;
  uint64_t x214;
  fiat_p511_uint1 x215;
  uint64_t x216;
  fiat_p511_uint1 x217;
  uint64_t x218;
  fiat_p511_uint1 x219;
  uint64_t x220;
  fiat_p511_uint1 x221;
  uint64_t x222;
  fiat_p511_uint1 x223;
  uint64_t x224;
  fiat_p511_uint1 x225;
  uint64_t x226;
  fiat_p511_uint1 x227;
  uint64_t x228;
  fiat_p511_uint1 x229;
  uint64_t x230;
  fiat_p511_uint1 x231;
  uint64_t x232;
  fiat_p511_uint1 x233;
  uint64_t x234;
  fiat_p511_uint1 x235;
  uint64_t x236;
  fiat_p511_uint1 x237;
  uint64_t x238;
  fiat_p511_uint1 x239;
  uint64_t x240;
  fiat_p511_uint1 x241;
  uint64_t x242;
  fiat_p511_uint1 x243;
  uint64_t x244;
  fiat_p511_uint1 x245;
  uint64_t x246;
  fiat_p511_uint1 x247;
  uint64_t x248;
  fiat_p511_uint1 x249;
  uint64_t x250;
  uint64_t x251;
  uint64_t x252;
  uint64_t x253;
  uint64_t x254;
  uint64_t x255;
  uint64_t x256;
  uint64_t x257;
  uint64_t x258;
  uint64_t x259;
  uint64_t x260;
  uint64_t x261;
  uint64_t x262;
  uint64_t x263;
  uint64_t x264;
  uint64_t x265;
  uint64_t x266;
  uint64_t x267;
  uint64_t x268;
  fiat_p511_uint1 x269;
  uint64_t x270;
  fiat_p511_uint1 x271;
  uint64_t x272;
  fiat_p511_uint1 x273;
  uint64_t x274;
  fiat_p511_uint1 x275;
  uint64_t x276;
  fiat_p511_uint1 x277;
  uint64_t x278;
  fiat_p511_uint1 x279;
  uint64_t x280;
  fiat_p511_uint1 x281;
  uint64_t x282;
  fiat_p511_uint1 x283;
  uint64_t x284;
  fiat_p511_uint1 x285;
  uint64_t x286;
  fiat_p511_uint1 x287;
  uint64_t x288;
  fiat_p511_uint1 x289;
  uint64_t x290;
  fiat_p511_uint1 x291;
  uint64_t x292;
  fiat_p511_uint1 x293;
  uint64_t x294;
  fiat_p511_uint1 x295;
  uint64_t x296;
  fiat_p511_uint1 x297;
  uint64_t x298;
  fiat_p511_uint1 x299;
  uint64_t x300;
  fiat_p511_uint1 x301;
  uint64_t x302;
  fiat_p511_uint1 x303;
  uint64_t x304;
  fiat_p511_uint1 x305;
  uint64_t x306;
  fiat_p511_uint1 x307;
  uint64_t x308;
  fiat_p511_uint1 x309;
  uint64_t x310;
  fiat_p511_uint1 x311;
  uint64_t x312;
  uint64_t x313;
  uint64_t x314;
  uint64_t x315;
  uint64_t x316;
  uint64_t x317;
  uint64_t x318;
  uint64_t x319;
  uint64_t x320;
  uint64_t x321;
  uint64_t x322;
  uint64_t x323;
  uint64_t x324;
  uint64_t x325;
  uint64_t x326;
  uint64_t x327;
  uint64_t x328;
  uint64_t x329;
  uint64_t x330;
  fiat_p511_uint1 x331;
  uint64_t x332;
  fiat_p511_uint1 x333;
  uint64_t x334;
  fiat_p511_uint1 x335;
  uint64_t x336;
  fiat_p511_uint1 x337;
  uint64_t x338;
  fiat_p511_uint1 x339;
  uint64_t x340;
  fiat_p511_uint1 x341;
  uint64_t x342;
  fiat_p511_uint1 x343;
  uint64_t x344;
  fiat_p511_uint1 x345;
  uint64_t x346;
  fiat_p511_uint1 x347;
  uint64_t x348;
  fiat_p511_uint1 x349;
  uint64_t x350;
  fiat_p511_uint1 x351;
  uint64_t x352;
  fiat_p511_uint1 x353;
  uint64_t x354;
  fiat_p511_uint1 x355;
  uint64_t x356;
  fiat_p511_uint1 x357;
  uint64_t x358;
  fiat_p511_uint1 x359;
  uint64_t x360;
  fiat_p511_uint1 x361;
  uint64_t x362;
  fiat_p511_uint1 x363;
  uint64_t x364;
  fiat_p511_uint1 x365;
  uint64_t x366;
  fiat_p511_uint1 x367;
  uint64_t x368;
  fiat_p511_uint1 x369;
  uint64_t x370;
  fiat_p511_uint1 x371;
  uint64_t x372;
  fiat_p511_uint1 x373;
  uint64_t x374;
  uint64_t x375;
  uint64_t x376;
  uint64_t x377;
  uint64_t x378;
  uint64_t x379;
  uint64_t x380;
  uint64_t x381;
  uint64_t x382;
  uint64_t x383;
  uint64_t x384;
  uint64_t x385;
  uint64_t x386;
  uint64_t x387;
  uint64_t x388;
  uint64_t x389;
  uint64_t x390;
  uint64_t x391;
  uint64_t x392;
  fiat_p511_uint1 x393;
  uint64_t x394;
  fiat_p511_uint1 x395;
  uint64_t x396;
  fiat_p511_uint1 x397;
  uint64_t x398;
  fiat_p511_uint1 x399;
  uint64_t x400;
  fiat_p511_uint1 x401;
  uint64_t x402;
  fiat_p511_uint1 x403;
  uint64_t x404;
  fiat_p511_uint1 x405;
  uint64_t x406;
  fiat_p511_uint1 x407;
  uint64_t x408;
  fiat_p511_uint1 x409;
  uint64_t x410;
  fiat_p511_uint1 x411;
  uint64_t x412;
  fiat_p511_uint1 x413;
  uint64_t x414;
  fiat_p511_uint1 x415;
  uint64_t x416;
  fiat_p511_uint1 x417;
  uint64_t x418;
  fiat_p511_uint1 x419;
  uint64_t x420;
  fiat_p511_uint1 x421;
  uint64_t x422;
  fiat_p511_uint1 x423;
  uint64_t x424;
  fiat_p511_uint1 x425;
  uint64_t x426;
  fiat_p511_uint1 x427;
  uint64_t x428;
  fiat_p511_uint1 x429;
  uint64_t x430;
  fiat_p511_uint1 x431;
  uint64_t x432;
  fiat_p511_uint1 x433;
  uint64_t x434;
  fiat_p511_uint1 x435;
  uint64_t x436;
  uint64_t x437;
  uint64_t x438;
  uint64_t x439;
  uint64_t x440;
  uint64_t x441;
  uint64_t x442;
  uint64_t x443;
  uint64_t x444;
  uint64_t x445;
  uint64_t x446;
  uint64_t x447;
  uint64_t x448;
  uint64_t x449;
  uint64_t x450;
  uint64_t x451;
  uint64_t x452;
  uint64_t x453;
  uint64_t x454;
  fiat_p511_uint1 x455;
  uint64_t x456;
  fiat_p511_uint1 x457;
  uint64_t x458;
  fiat_p511_uint1 x459;
  uint64_t x460;
  fiat_p511_uint1 x461;
  uint64_t x462;
  fiat_p511_uint1 x463;
  uint64_t x464;
  fiat_p511_uint1 x465;
  uint64_t x466;
  fiat_p511_uint1 x467;
  uint64_t x468;
  fiat_p511_uint1 x469;
  uint64_t x470;
  fiat_p511_uint1 x471;
  uint64_t x472;
  fiat_p511_uint1 x473;
  uint64_t x474;
  fiat_p511_uint1 x475;
  uint64_t x476;
  fiat_p511_uint1 x477;
  uint64_t x478;
  fiat_p511_uint1 x479;
  uint64_t x480;
  fiat_p511_uint1 x481;
  uint64_t x482;
  fiat_p511_uint1 x483;
  uint64_t x484;
  uint64_t x485;
  fiat_p511_uint1 x486;
  uint64_t x487;
  fiat_p511_uint1 x488;
  uint64_t x489;
  fiat_p511_uint1 x490;
  uint64_t x491;
  fiat_p511_uint1 x492;
  uint64_t x493;
  fiat_p511_uint1 x494;
  uint64_t x495;
  fiat_p511_uint1 x496;
  uint64_t x497;
  fiat_p511_uint1 x498;
  uint64_t x499;
  fiat_p511_uint1 x500;
  uint64_t x501;
  fiat_p511_uint1 x502;
  uint64_t x503;
  uint64_t x504;
  uint64_t x505;
  uint64_t x506;
  uint64_t x507;
  uint64_t x508;
  uint64_t x509;
  uint64_t x510;
  x1 = (arg1[0]);
  fiat_p511_mulx_u64(&x2, &x3, x1, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x4, &x5, x2, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x6, &x7, x2, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x8, &x9, x2, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x10, &x11, x2, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x12, &x13, x2, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x14, &x15, x2, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x16, &x17, x2, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x18, &x19, x2, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x20, &x21, 0x0, x19, x16);
  fiat_p511_addcarryx_u64(&x22, &x23, x21, x17, x14);
  fiat_p511_addcarryx_u64(&x24, &x25, x23, x15, x12);
  fiat_p511_addcarryx_u64(&x26, &x27, x25, x13, x10);
  fiat_p511_addcarryx_u64(&x28, &x29, x27, x11, x8);
  fiat_p511_addcarryx_u64(&x30, &x31, x29, x9, x6);
  fiat_p511_addcarryx_u64(&x32, &x33, x31, x7, x4);
  fiat_p511_addcarryx_u64(&x34, &x35, 0x0, x1, x18);
  fiat_p511_addcarryx_u64(&x36, &x37, x35, 0x0, x20);
  fiat_p511_addcarryx_u64(&x38, &x39, x37, 0x0, x22);
  fiat_p511_addcarryx_u64(&x40, &x41, x39, 0x0, x24);
  fiat_p511_addcarryx_u64(&x42, &x43, x41, 0x0, x26);
  fiat_p511_addcarryx_u64(&x44, &x45, x43, 0x0, x28);
  fiat_p511_addcarryx_u64(&x46, &x47, x45, 0x0, x30);
  fiat_p511_addcarryx_u64(&x48, &x49, x47, 0x0, x32);
  fiat_p511_addcarryx_u64(&x50, &x51, 0x0, x36, (arg1[1]));
  fiat_p511_addcarryx_u64(&x52, &x53, x51, x38, 0x0);
  fiat_p511_addcarryx_u64(&x54, &x55, x53, x40, 0x0);
  fiat_p511_addcarryx_u64(&x56, &x57, x55, x42, 0x0);
  fiat_p511_addcarryx_u64(&x58, &x59, x57, x44, 0x0);
  fiat_p511_addcarryx_u64(&x60, &x61, x59, x46, 0x0);
  fiat_p511_addcarryx_u64(&x62, &x63, x61, x48, 0x0);
  fiat_p511_mulx_u64(&x64, &x65, x50, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x66, &x67, x64, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x68, &x69, x64, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x70, &x71, x64, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x72, &x73, x64, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x74, &x75, x64, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x76, &x77, x64, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x78, &x79, x64, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x80, &x81, x64, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x82, &x83, 0x0, x81, x78);
  fiat_p511_addcarryx_u64(&x84, &x85, x83, x79, x76);
  fiat_p511_addcarryx_u64(&x86, &x87, x85, x77, x74);
  fiat_p511_addcarryx_u64(&x88, &x89, x87, x75, x72);
  fiat_p511_addcarryx_u64(&x90, &x91, x89, x73, x70);
  fiat_p511_addcarryx_u64(&x92, &x93, x91, x71, x68);
  fiat_p511_addcarryx_u64(&x94, &x95, x93, x69, x66);
  fiat_p511_addcarryx_u64(&x96, &x97, 0x0, x50, x80);
  fiat_p511_addcarryx_u64(&x98, &x99, x97, x52, x82);
  fiat_p511_addcarryx_u64(&x100, &x101, x99, x54, x84);
  fiat_p511_addcarryx_u64(&x102, &x103, x101, x56, x86);
  fiat_p511_addcarryx_u64(&x104, &x105, x103, x58, x88);
  fiat_p511_addcarryx_u64(&x106, &x107, x105, x60, x90);
  fiat_p511_addcarryx_u64(&x108, &x109, x107, x62, x92);
  fiat_p511_addcarryx_u64(&x110, &x111, x109, (x63 + (x49 + (x33 + x5))), x94);
  fiat_p511_addcarryx_u64(&x112, &x113, 0x0, x98, (arg1[2]));
  fiat_p511_addcarryx_u64(&x114, &x115, x113, x100, 0x0);
  fiat_p511_addcarryx_u64(&x116, &x117, x115, x102, 0x0);
  fiat_p511_addcarryx_u64(&x118, &x119, x117, x104, 0x0);
  fiat_p511_addcarryx_u64(&x120, &x121, x119, x106, 0x0);
  fiat_p511_addcarryx_u64(&x122, &x123, x121, x108, 0x0);
  fiat_p511_addcarryx_u64(&x124, &x125, x123, x110, 0x0);
  fiat_p511_mulx_u64(&x126, &x127, x112, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x128, &x129, x126, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x130, &x131, x126, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x132, &x133, x126, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x134, &x135, x126, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x136, &x137, x126, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x138, &x139, x126, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x140, &x141, x126, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x142, &x143, x126, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x144, &x145, 0x0, x143, x140);
  fiat_p511_addcarryx_u64(&x146, &x147, x145, x141, x138);
  fiat_p511_addcarryx_u64(&x148, &x149, x147, x139, x136);
  fiat_p511_addcarryx_u64(&x150, &x151, x149, x137, x134);
  fiat_p511_addcarryx_u64(&x152, &x153, x151, x135, x132);
  fiat_p511_addcarryx_u64(&x154, &x155, x153, x133, x130);
  fiat_p511_addcarryx_u64(&x156, &x157, x155, x131, x128);
  fiat_p511_addcarryx_u64(&x158, &x159, 0x0, x112, x142);
  fiat_p511_addcarryx_u64(&x160, &x161, x159, x114, x144);
  fiat_p511_addcarryx_u64(&x162, &x163, x161, x116, x146);
  fiat_p511_addcarryx_u64(&x164, &x165, x163, x118, x148);
  fiat_p511_addcarryx_u64(&x166, &x167, x165, x120, x150);
  fiat_p511_addcarryx_u64(&x168, &x169, x167, x122, x152);
  fiat_p511_addcarryx_u64(&x170, &x171, x169, x124, x154);
  fiat_p511_addcarryx_u64(&x172, &x173, x171, (x125 + (x111 + (x95 + x67))), x156);
  fiat_p511_addcarryx_u64(&x174, &x175, 0x0, x160, (arg1[3]));
  fiat_p511_addcarryx_u64(&x176, &x177, x175, x162, 0x0);
  fiat_p511_addcarryx_u64(&x178, &x179, x177, x164, 0x0);
  fiat_p511_addcarryx_u64(&x180, &x181, x179, x166, 0x0);
  fiat_p511_addcarryx_u64(&x182, &x183, x181, x168, 0x0);
  fiat_p511_addcarryx_u64(&x184, &x185, x183, x170, 0x0);
  fiat_p511_addcarryx_u64(&x186, &x187, x185, x172, 0x0);
  fiat_p511_mulx_u64(&x188, &x189, x174, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x190, &x191, x188, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x192, &x193, x188, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x194, &x195, x188, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x196, &x197, x188, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x198, &x199, x188, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x200, &x201, x188, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x202, &x203, x188, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x204, &x205, x188, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x206, &x207, 0x0, x205, x202);
  fiat_p511_addcarryx_u64(&x208, &x209, x207, x203, x200);
  fiat_p511_addcarryx_u64(&x210, &x211, x209, x201, x198);
  fiat_p511_addcarryx_u64(&x212, &x213, x211, x199, x196);
  fiat_p511_addcarryx_u64(&x214, &x215, x213, x197, x194);
  fiat_p511_addcarryx_u64(&x216, &x217, x215, x195, x192);
  fiat_p511_addcarryx_u64(&x218, &x219, x217, x193, x190);
  fiat_p511_addcarryx_u64(&x220, &x221, 0x0, x174, x204);
  fiat_p511_addcarryx_u64(&x222, &x223, x221, x176, x206);
  fiat_p511_addcarryx_u64(&x224, &x225, x223, x178, x208);
  fiat_p511_addcarryx_u64(&x226, &x227, x225, x180, x210);
  fiat_p511_addcarryx_u64(&x228, &x229, x227, x182, x212);
  fiat_p511_addcarryx_u64(&x230, &x231, x229, x184, x214);
  fiat_p511_addcarryx_u64(&x232, &x233, x231, x186, x216);
  fiat_p511_addcarryx_u64(&x234, &x235, x233, (x187 + (x173 + (x157 + x129))), x218);
  fiat_p511_addcarryx_u64(&x236, &x237, 0x0, x222, (arg1[4]));
  fiat_p511_addcarryx_u64(&x238, &x239, x237, x224, 0x0);
  fiat_p511_addcarryx_u64(&x240, &x241, x239, x226, 0x0);
  fiat_p511_addcarryx_u64(&x242, &x243, x241, x228, 0x0);
  fiat_p511_addcarryx_u64(&x244, &x245, x243, x230, 0x0);
  fiat_p511_addcarryx_u64(&x246, &x247, x245, x232, 0x0);
  fiat_p511_addcarryx_u64(&x248, &x249, x247, x234, 0x0);
  fiat_p511_mulx_u64(&x250, &x251, x236, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x252, &x253, x250, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x254, &x255, x250, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x256, &x257, x250, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x258, &x259, x250, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x260, &x261, x250, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x262, &x263, x250, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x264, &x265, x250, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x266, &x267, x250, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x268, &x269, 0x0, x267, x264);
  fiat_p511_addcarryx_u64(&x270, &x271, x269, x265, x262);
  fiat_p511_addcarryx_u64(&x272, &x273, x271, x263, x260);
  fiat_p511_addcarryx_u64(&x274, &x275, x273, x261, x258);
  fiat_p511_addcarryx_u64(&x276, &x277, x275, x259, x256);
  fiat_p511_addcarryx_u64(&x278, &x279, x277, x257, x254);
  fiat_p511_addcarryx_u64(&x280, &x281, x279, x255, x252);
  fiat_p511_addcarryx_u64(&x282, &x283, 0x0, x236, x266);
  fiat_p511_addcarryx_u64(&x284, &x285, x283, x238, x268);
  fiat_p511_addcarryx_u64(&x286, &x287, x285, x240, x270);
  fiat_p511_addcarryx_u64(&x288, &x289, x287, x242, x272);
  fiat_p511_addcarryx_u64(&x290, &x291, x289, x244, x274);
  fiat_p511_addcarryx_u64(&x292, &x293, x291, x246, x276);
  fiat_p511_addcarryx_u64(&x294, &x295, x293, x248, x278);
  fiat_p511_addcarryx_u64(&x296, &x297, x295, (x249 + (x235 + (x219 + x191))), x280);
  fiat_p511_addcarryx_u64(&x298, &x299, 0x0, x284, (arg1[5]));
  fiat_p511_addcarryx_u64(&x300, &x301, x299, x286, 0x0);
  fiat_p511_addcarryx_u64(&x302, &x303, x301, x288, 0x0);
  fiat_p511_addcarryx_u64(&x304, &x305, x303, x290, 0x0);
  fiat_p511_addcarryx_u64(&x306, &x307, x305, x292, 0x0);
  fiat_p511_addcarryx_u64(&x308, &x309, x307, x294, 0x0);
  fiat_p511_addcarryx_u64(&x310, &x311, x309, x296, 0x0);
  fiat_p511_mulx_u64(&x312, &x313, x298, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x314, &x315, x312, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x316, &x317, x312, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x318, &x319, x312, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x320, &x321, x312, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x322, &x323, x312, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x324, &x325, x312, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x326, &x327, x312, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x328, &x329, x312, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x330, &x331, 0x0, x329, x326);
  fiat_p511_addcarryx_u64(&x332, &x333, x331, x327, x324);
  fiat_p511_addcarryx_u64(&x334, &x335, x333, x325, x322);
  fiat_p511_addcarryx_u64(&x336, &x337, x335, x323, x320);
  fiat_p511_addcarryx_u64(&x338, &x339, x337, x321, x318);
  fiat_p511_addcarryx_u64(&x340, &x341, x339, x319, x316);
  fiat_p511_addcarryx_u64(&x342, &x343, x341, x317, x314);
  fiat_p511_addcarryx_u64(&x344, &x345, 0x0, x298, x328);
  fiat_p511_addcarryx_u64(&x346, &x347, x345, x300, x330);
  fiat_p511_addcarryx_u64(&x348, &x349, x347, x302, x332);
  fiat_p511_addcarryx_u64(&x350, &x351, x349, x304, x334);
  fiat_p511_addcarryx_u64(&x352, &x353, x351, x306, x336);
  fiat_p511_addcarryx_u64(&x354, &x355, x353, x308, x338);
  fiat_p511_addcarryx_u64(&x356, &x357, x355, x310, x340);
  fiat_p511_addcarryx_u64(&x358, &x359, x357, (x311 + (x297 + (x281 + x253))), x342);
  fiat_p511_addcarryx_u64(&x360, &x361, 0x0, x346, (arg1[6]));
  fiat_p511_addcarryx_u64(&x362, &x363, x361, x348, 0x0);
  fiat_p511_addcarryx_u64(&x364, &x365, x363, x350, 0x0);
  fiat_p511_addcarryx_u64(&x366, &x367, x365, x352, 0x0);
  fiat_p511_addcarryx_u64(&x368, &x369, x367, x354, 0x0);
  fiat_p511_addcarryx_u64(&x370, &x371, x369, x356, 0x0);
  fiat_p511_addcarryx_u64(&x372, &x373, x371, x358, 0x0);
  fiat_p511_mulx_u64(&x374, &x375, x360, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x376, &x377, x374, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x378, &x379, x374, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x380, &x381, x374, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x382, &x383, x374, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x384, &x385, x374, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x386, &x387, x374, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x388, &x389, x374, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x390, &x391, x374, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x392, &x393, 0x0, x391, x388);
  fiat_p511_addcarryx_u64(&x394, &x395, x393, x389, x386);
  fiat_p511_addcarryx_u64(&x396, &x397, x395, x387, x384);
  fiat_p511_addcarryx_u64(&x398, &x399, x397, x385, x382);
  fiat_p511_addcarryx_u64(&x400, &x401, x399, x383, x380);
  fiat_p511_addcarryx_u64(&x402, &x403, x401, x381, x378);
  fiat_p511_addcarryx_u64(&x404, &x405, x403, x379, x376);
  fiat_p511_addcarryx_u64(&x406, &x407, 0x0, x360, x390);
  fiat_p511_addcarryx_u64(&x408, &x409, x407, x362, x392);
  fiat_p511_addcarryx_u64(&x410, &x411, x409, x364, x394);
  fiat_p511_addcarryx_u64(&x412, &x413, x411, x366, x396);
  fiat_p511_addcarryx_u64(&x414, &x415, x413, x368, x398);
  fiat_p511_addcarryx_u64(&x416, &x417, x415, x370, x400);
  fiat_p511_addcarryx_u64(&x418, &x419, x417, x372, x402);
  fiat_p511_addcarryx_u64(&x420, &x421, x419, (x373 + (x359 + (x343 + x315))), x404);
  fiat_p511_addcarryx_u64(&x422, &x423, 0x0, x408, (arg1[7]));
  fiat_p511_addcarryx_u64(&x424, &x425, x423, x410, 0x0);
  fiat_p511_addcarryx_u64(&x426, &x427, x425, x412, 0x0);
  fiat_p511_addcarryx_u64(&x428, &x429, x427, x414, 0x0);
  fiat_p511_addcarryx_u64(&x430, &x431, x429, x416, 0x0);
  fiat_p511_addcarryx_u64(&x432, &x433, x431, x418, 0x0);
  fiat_p511_addcarryx_u64(&x434, &x435, x433, x420, 0x0);
  fiat_p511_mulx_u64(&x436, &x437, x422, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x438, &x439, x436, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x440, &x441, x436, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x442, &x443, x436, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x444, &x445, x436, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x446, &x447, x436, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x448, &x449, x436, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x450, &x451, x436, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x452, &x453, x436, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x454, &x455, 0x0, x453, x450);
  fiat_p511_addcarryx_u64(&x456, &x457, x455, x451, x448);
  fiat_p511_addcarryx_u64(&x458, &x459, x457, x449, x446);
  fiat_p511_addcarryx_u64(&x460, &x461, x459, x447, x444);
  fiat_p511_addcarryx_u64(&x462, &x463, x461, x445, x442);
  fiat_p511_addcarryx_u64(&x464, &x465, x463, x443, x440);
  fiat_p511_addcarryx_u64(&x466, &x467, x465, x441, x438);
  fiat_p511_addcarryx_u64(&x468, &x469, 0x0, x422, x452);
  fiat_p511_addcarryx_u64(&x470, &x471, x469, x424, x454);
  fiat_p511_addcarryx_u64(&x472, &x473, x471, x426, x456);
  fiat_p511_addcarryx_u64(&x474, &x475, x473, x428, x458);
  fiat_p511_addcarryx_u64(&x476, &x477, x475, x430, x460);
  fiat_p511_addcarryx_u64(&x478, &x479, x477, x432, x462);
  fiat_p511_addcarryx_u64(&x480, &x481, x479, x434, x464);
  fiat_p511_addcarryx_u64(&x482, &x483, x481, (x435 + (x421 + (x405 + x377))), x466);
  x484 = (x483 + (x467 + x439));
  fiat_p511_subborrowx_u64(&x485, &x486, 0x0, x470, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_subborrowx_u64(&x487, &x488, x486, x472, UINT64_C(0xc2721bf457aca835));
  fiat_p511_subborrowx_u64(&x489, &x490, x488, x474, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_subborrowx_u64(&x491, &x492, x490, x476, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_subborrowx_u64(&x493, &x494, x492, x478, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_subborrowx_u64(&x495, &x496, x494, x480, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_subborrowx_u64(&x497, &x498, x496, x482, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_subborrowx_u64(&x499, &x500, x498, x484, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_subborrowx_u64(&x501, &x502, x500, 0x0, 0x0);
  fiat_p511_cmovznz_u64(&x503, x502, x485, x470);
  fiat_p511_cmovznz_u64(&x504, x502, x487, x472);
  fiat_p511_cmovznz_u64(&x505, x502, x489, x474);
  fiat_p511_cmovznz_u64(&x506, x502, x491, x476);
  fiat_p511_cmovznz_u64(&x507, x502, x493, x478);
  fiat_p511_cmovznz_u64(&x508, x502, x495, x480);
  fiat_p511_cmovznz_u64(&x509, x502, x497, x482);
  fiat_p511_cmovznz_u64(&x510, x502, x499, x484);
  out1[0] = x503;
  out1[1] = x504;
  out1[2] = x505;
  out1[3] = x506;
  out1[4] = x507;
  out1[5] = x508;
  out1[6] = x509;
  out1[7] = x510;
}

/*
 * The function fiat_p511_to_montgomery translates a field element into the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = eval arg1 mod m
 *   0 ≤ eval out1 < m
 *
 */
void fiat_p511_to_montgomery(fiat_p511_montgomery_domain_field_element out1, const fiat_p511_non_montgomery_domain_field_element arg1) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  uint64_t x9;
  uint64_t x10;
  uint64_t x11;
  uint64_t x12;
  uint64_t x13;
  uint64_t x14;
  uint64_t x15;
  uint64_t x16;
  uint64_t x17;
  uint64_t x18;
  uint64_t x19;
  uint64_t x20;
  uint64_t x21;
  uint64_t x22;
  uint64_t x23;
  uint64_t x24;
  uint64_t x25;
  fiat_p511_uint1 x26;
  uint64_t x27;
  fiat_p511_uint1 x28;
  uint64_t x29;
  fiat_p511_uint1 x30;
  uint64_t x31;
  fiat_p511_uint1 x32;
  uint64_t x33;
  fiat_p511_uint1 x34;
  uint64_t x35;
  fiat_p511_uint1 x36;
  uint64_t x37;
  fiat_p511_uint1 x38;
  uint64_t x39;
  uint64_t x40;
  uint64_t x41;
  uint64_t x42;
  uint64_t x43;
  uint64_t x44;
  uint64_t x45;
  uint64_t x46;
  uint64_t x47;
  uint64_t x48;
  uint64_t x49;
  uint64_t x50;
  uint64_t x51;
  uint64_t x52;
  uint64_t x53;
  uint64_t x54;
  uint64_t x55;
  uint64_t x56;
  uint64_t x57;
  fiat_p511_uint1 x58;
  uint64_t x59;
  fiat_p511_uint1 x60;
  uint64_t x61;
  fiat_p511_uint1 x62;
  uint64_t x63;
  fiat_p511_uint1 x64;
  uint64_t x65;
  fiat_p511_uint1 x66;
  uint64_t x67;
  fiat_p511_uint1 x68;
  uint64_t x69;
  fiat_p511_uint1 x70;
  uint64_t x71;
  fiat_p511_uint1 x72;
  uint64_t x73;
  fiat_p511_uint1 x74;
  uint64_t x75;
  fiat_p511_uint1 x76;
  uint64_t x77;
  fiat_p511_uint1 x78;
  uint64_t x79;
  fiat_p511_uint1 x80;
  uint64_t x81;
  fiat_p511_uint1 x82;
  uint64_t x83;
  fiat_p511_uint1 x84;
  uint64_t x85;
  fiat_p511_uint1 x86;
  uint64_t x87;
  uint64_t x88;
  uint64_t x89;
  uint64_t x90;
  uint64_t x91;
  uint64_t x92;
  uint64_t x93;
  uint64_t x94;
  uint64_t x95;
  uint64_t x96;
  uint64_t x97;
  uint64_t x98;
  uint64_t x99;
  uint64_t x100;
  uint64_t x101;
  uint64_t x102;
  uint64_t x103;
  fiat_p511_uint1 x104;
  uint64_t x105;
  fiat_p511_uint1 x106;
  uint64_t x107;
  fiat_p511_uint1 x108;
  uint64_t x109;
  fiat_p511_uint1 x110;
  uint64_t x111;
  fiat_p511_uint1 x112;
  uint64_t x113;
  fiat_p511_uint1 x114;
  uint64_t x115;
  fiat_p511_uint1 x116;
  uint64_t x117;
  fiat_p511_uint1 x118;
  uint64_t x119;
  fiat_p511_uint1 x120;
  uint64_t x121;
  fiat_p511_uint1 x122;
  uint64_t x123;
  fiat_p511_uint1 x124;
  uint64_t x125;
  fiat_p511_uint1 x126;
  uint64_t x127;
  fiat_p511_uint1 x128;
  uint64_t x129;
  fiat_p511_uint1 x130;
  uint64_t x131;
  fiat_p511_uint1 x132;
  uint64_t x133;
  uint64_t x134;
  uint64_t x135;
  uint64_t x136;
  uint64_t x137;
  uint64_t x138;
  uint64_t x139;
  uint64_t x140;
  uint64_t x141;
  uint64_t x142;
  uint64_t x143;
  uint64_t x144;
  uint64_t x145;
  uint64_t x146;
  uint64_t x147;
  uint64_t x148;
  uint64_t x149;
  uint64_t x150;
  uint64_t x151;
  fiat_p511_uint1 x152;
  uint64_t x153;
  fiat_p511_uint1 x154;
  uint64_t x155;
  fiat_p511_uint1 x156;
  uint64_t x157;
  fiat_p511_uint1 x158;
  uint64_t x159;
  fiat_p511_uint1 x160;
  uint64_t x161;
  fiat_p511_uint1 x162;
  uint64_t x163;
  fiat_p511_uint1 x164;
  uint64_t x165;
  fiat_p511_uint1 x166;
  uint64_t x167;
  fiat_p511_uint1 x168;
  uint64_t x169;
  fiat_p511_uint1 x170;
  uint64_t x171;
  fiat_p511_uint1 x172;
  uint64_t x173;
  fiat_p511_uint1 x174;
  uint64_t x175;
  fiat_p511_uint1 x176;
  uint64_t x177;
  fiat_p511_uint1 x178;
  uint64_t x179;
  fiat_p511_uint1 x180;
  uint64_t x181;
  uint64_t x182;
  uint64_t x183;
  uint64_t x184;
  uint64_t x185;
  uint64_t x186;
  uint64_t x187;
  uint64_t x188;
  uint64_t x189;
  uint64_t x190;
  uint64_t x191;
  uint64_t x192;
  uint64_t x193;
  uint64_t x194;
  uint64_t x195;
  uint64_t x196;
  uint64_t x197;
  fiat_p511_uint1 x198;
  uint64_t x199;
  fiat_p511_uint1 x200;
  uint64_t x201;
  fiat_p511_uint1 x202;
  uint64_t x203;
  fiat_p511_uint1 x204;
  uint64_t x205;
  fiat_p511_uint1 x206;
  uint64_t x207;
  fiat_p511_uint1 x208;
  uint64_t x209;
  fiat_p511_uint1 x210;
  uint64_t x211;
  fiat_p511_uint1 x212;
  uint64_t x213;
  fiat_p511_uint1 x214;
  uint64_t x215;
  fiat_p511_uint1 x216;
  uint64_t x217;
  fiat_p511_uint1 x218;
  uint64_t x219;
  fiat_p511_uint1 x220;
  uint64_t x221;
  fiat_p511_uint1 x222;
  uint64_t x223;
  fiat_p511_uint1 x224;
  uint64_t x225;
  fiat_p511_uint1 x226;
  uint64_t x227;
  uint64_t x228;
  uint64_t x229;
  uint64_t x230;
  uint64_t x231;
  uint64_t x232;
  uint64_t x233;
  uint64_t x234;
  uint64_t x235;
  uint64_t x236;
  uint64_t x237;
  uint64_t x238;
  uint64_t x239;
  uint64_t x240;
  uint64_t x241;
  uint64_t x242;
  uint64_t x243;
  uint64_t x244;
  uint64_t x245;
  fiat_p511_uint1 x246;
  uint64_t x247;
  fiat_p511_uint1 x248;
  uint64_t x249;
  fiat_p511_uint1 x250;
  uint64_t x251;
  fiat_p511_uint1 x252;
  uint64_t x253;
  fiat_p511_uint1 x254;
  uint64_t x255;
  fiat_p511_uint1 x256;
  uint64_t x257;
  fiat_p511_uint1 x258;
  uint64_t x259;
  fiat_p511_uint1 x260;
  uint64_t x261;
  fiat_p511_uint1 x262;
  uint64_t x263;
  fiat_p511_uint1 x264;
  uint64_t x265;
  fiat_p511_uint1 x266;
  uint64_t x267;
  fiat_p511_uint1 x268;
  uint64_t x269;
  fiat_p511_uint1 x270;
  uint64_t x271;
  fiat_p511_uint1 x272;
  uint64_t x273;
  fiat_p511_uint1 x274;
  uint64_t x275;
  uint64_t x276;
  uint64_t x277;
  uint64_t x278;
  uint64_t x279;
  uint64_t x280;
  uint64_t x281;
  uint64_t x282;
  uint64_t x283;
  uint64_t x284;
  uint64_t x285;
  uint64_t x286;
  uint64_t x287;
  uint64_t x288;
  uint64_t x289;
  uint64_t x290;
  uint64_t x291;
  fiat_p511_uint1 x292;
  uint64_t x293;
  fiat_p511_uint1 x294;
  uint64_t x295;
  fiat_p511_uint1 x296;
  uint64_t x297;
  fiat_p511_uint1 x298;
  uint64_t x299;
  fiat_p511_uint1 x300;
  uint64_t x301;
  fiat_p511_uint1 x302;
  uint64_t x303;
  fiat_p511_uint1 x304;
  uint64_t x305;
  fiat_p511_uint1 x306;
  uint64_t x307;
  fiat_p511_uint1 x308;
  uint64_t x309;
  fiat_p511_uint1 x310;
  uint64_t x311;
  fiat_p511_uint1 x312;
  uint64_t x313;
  fiat_p511_uint1 x314;
  uint64_t x315;
  fiat_p511_uint1 x316;
  uint64_t x317;
  fiat_p511_uint1 x318;
  uint64_t x319;
  fiat_p511_uint1 x320;
  uint64_t x321;
  uint64_t x322;
  uint64_t x323;
  uint64_t x324;
  uint64_t x325;
  uint64_t x326;
  uint64_t x327;
  uint64_t x328;
  uint64_t x329;
  uint64_t x330;
  uint64_t x331;
  uint64_t x332;
  uint64_t x333;
  uint64_t x334;
  uint64_t x335;
  uint64_t x336;
  uint64_t x337;
  uint64_t x338;
  uint64_t x339;
  fiat_p511_uint1 x340;
  uint64_t x341;
  fiat_p511_uint1 x342;
  uint64_t x343;
  fiat_p511_uint1 x344;
  uint64_t x345;
  fiat_p511_uint1 x346;
  uint64_t x347;
  fiat_p511_uint1 x348;
  uint64_t x349;
  fiat_p511_uint1 x350;
  uint64_t x351;
  fiat_p511_uint1 x352;
  uint64_t x353;
  fiat_p511_uint1 x354;
  uint64_t x355;
  fiat_p511_uint1 x356;
  uint64_t x357;
  fiat_p511_uint1 x358;
  uint64_t x359;
  fiat_p511_uint1 x360;
  uint64_t x361;
  fiat_p511_uint1 x362;
  uint64_t x363;
  fiat_p511_uint1 x364;
  uint64_t x365;
  fiat_p511_uint1 x366;
  uint64_t x367;
  fiat_p511_uint1 x368;
  uint64_t x369;
  uint64_t x370;
  uint64_t x371;
  uint64_t x372;
  uint64_t x373;
  uint64_t x374;
  uint64_t x375;
  uint64_t x376;
  uint64_t x377;
  uint64_t x378;
  uint64_t x379;
  uint64_t x380;
  uint64_t x381;
  uint64_t x382;
  uint64_t x383;
  uint64_t x384;
  uint64_t x385;
  fiat_p511_uint1 x386;
  uint64_t x387;
  fiat_p511_uint1 x388;
  uint64_t x389;
  fiat_p511_uint1 x390;
  uint64_t x391;
  fiat_p511_uint1 x392;
  uint64_t x393;
  fiat_p511_uint1 x394;
  uint64_t x395;
  fiat_p511_uint1 x396;
  uint64_t x397;
  fiat_p511_uint1 x398;
  uint64_t x399;
  fiat_p511_uint1 x400;
  uint64_t x401;
  fiat_p511_uint1 x402;
  uint64_t x403;
  fiat_p511_uint1 x404;
  uint64_t x405;
  fiat_p511_uint1 x406;
  uint64_t x407;
  fiat_p511_uint1 x408;
  uint64_t x409;
  fiat_p511_uint1 x410;
  uint64_t x411;
  fiat_p511_uint1 x412;
  uint64_t x413;
  fiat_p511_uint1 x414;
  uint64_t x415;
  uint64_t x416;
  uint64_t x417;
  uint64_t x418;
  uint64_t x419;
  uint64_t x420;
  uint64_t x421;
  uint64_t x422;
  uint64_t x423;
  uint64_t x424;
  uint64_t x425;
  uint64_t x426;
  uint64_t x427;
  uint64_t x428;
  uint64_t x429;
  uint64_t x430;
  uint64_t x431;
  uint64_t x432;
  uint64_t x433;
  fiat_p511_uint1 x434;
  uint64_t x435;
  fiat_p511_uint1 x436;
  uint64_t x437;
  fiat_p511_uint1 x438;
  uint64_t x439;
  fiat_p511_uint1 x440;
  uint64_t x441;
  fiat_p511_uint1 x442;
  uint64_t x443;
  fiat_p511_uint1 x444;
  uint64_t x445;
  fiat_p511_uint1 x446;
  uint64_t x447;
  fiat_p511_uint1 x448;
  uint64_t x449;
  fiat_p511_uint1 x450;
  uint64_t x451;
  fiat_p511_uint1 x452;
  uint64_t x453;
  fiat_p511_uint1 x454;
  uint64_t x455;
  fiat_p511_uint1 x456;
  uint64_t x457;
  fiat_p511_uint1 x458;
  uint64_t x459;
  fiat_p511_uint1 x460;
  uint64_t x461;
  fiat_p511_uint1 x462;
  uint64_t x463;
  uint64_t x464;
  uint64_t x465;
  uint64_t x466;
  uint64_t x467;
  uint64_t x468;
  uint64_t x469;
  uint64_t x470;
  uint64_t x471;
  uint64_t x472;
  uint64_t x473;
  uint64_t x474;
  uint64_t x475;
  uint64_t x476;
  uint64_t x477;
  uint64_t x478;
  uint64_t x479;
  fiat_p511_uint1 x480;
  uint64_t x481;
  fiat_p511_uint1 x482;
  uint64_t x483;
  fiat_p511_uint1 x484;
  uint64_t x485;
  fiat_p511_uint1 x486;
  uint64_t x487;
  fiat_p511_uint1 x488;
  uint64_t x489;
  fiat_p511_uint1 x490;
  uint64_t x491;
  fiat_p511_uint1 x492;
  uint64_t x493;
  fiat_p511_uint1 x494;
  uint64_t x495;
  fiat_p511_uint1 x496;
  uint64_t x497;
  fiat_p511_uint1 x498;
  uint64_t x499;
  fiat_p511_uint1 x500;
  uint64_t x501;
  fiat_p511_uint1 x502;
  uint64_t x503;
  fiat_p511_uint1 x504;
  uint64_t x505;
  fiat_p511_uint1 x506;
  uint64_t x507;
  fiat_p511_uint1 x508;
  uint64_t x509;
  uint64_t x510;
  uint64_t x511;
  uint64_t x512;
  uint64_t x513;
  uint64_t x514;
  uint64_t x515;
  uint64_t x516;
  uint64_t x517;
  uint64_t x518;
  uint64_t x519;
  uint64_t x520;
  uint64_t x521;
  uint64_t x522;
  uint64_t x523;
  uint64_t x524;
  uint64_t x525;
  uint64_t x526;
  uint64_t x527;
  fiat_p511_uint1 x528;
  uint64_t x529;
  fiat_p511_uint1 x530;
  uint64_t x531;
  fiat_p511_uint1 x532;
  uint64_t x533;
  fiat_p511_uint1 x534;
  uint64_t x535;
  fiat_p511_uint1 x536;
  uint64_t x537;
  fiat_p511_uint1 x538;
  uint64_t x539;
  fiat_p511_uint1 x540;
  uint64_t x541;
  fiat_p511_uint1 x542;
  uint64_t x543;
  fiat_p511_uint1 x544;
  uint64_t x545;
  fiat_p511_uint1 x546;
  uint64_t x547;
  fiat_p511_uint1 x548;
  uint64_t x549;
  fiat_p511_uint1 x550;
  uint64_t x551;
  fiat_p511_uint1 x552;
  uint64_t x553;
  fiat_p511_uint1 x554;
  uint64_t x555;
  fiat_p511_uint1 x556;
  uint64_t x557;
  uint64_t x558;
  uint64_t x559;
  uint64_t x560;
  uint64_t x561;
  uint64_t x562;
  uint64_t x563;
  uint64_t x564;
  uint64_t x565;
  uint64_t x566;
  uint64_t x567;
  uint64_t x568;
  uint64_t x569;
  uint64_t x570;
  uint64_t x571;
  uint64_t x572;
  uint64_t x573;
  fiat_p511_uint1 x574;
  uint64_t x575;
  fiat_p511_uint1 x576;
  uint64_t x577;
  fiat_p511_uint1 x578;
  uint64_t x579;
  fiat_p511_uint1 x580;
  uint64_t x581;
  fiat_p511_uint1 x582;
  uint64_t x583;
  fiat_p511_uint1 x584;
  uint64_t x585;
  fiat_p511_uint1 x586;
  uint64_t x587;
  fiat_p511_uint1 x588;
  uint64_t x589;
  fiat_p511_uint1 x590;
  uint64_t x591;
  fiat_p511_uint1 x592;
  uint64_t x593;
  fiat_p511_uint1 x594;
  uint64_t x595;
  fiat_p511_uint1 x596;
  uint64_t x597;
  fiat_p511_uint1 x598;
  uint64_t x599;
  fiat_p511_uint1 x600;
  uint64_t x601;
  fiat_p511_uint1 x602;
  uint64_t x603;
  uint64_t x604;
  uint64_t x605;
  uint64_t x606;
  uint64_t x607;
  uint64_t x608;
  uint64_t x609;
  uint64_t x610;
  uint64_t x611;
  uint64_t x612;
  uint64_t x613;
  uint64_t x614;
  uint64_t x615;
  uint64_t x616;
  uint64_t x617;
  uint64_t x618;
  uint64_t x619;
  uint64_t x620;
  uint64_t x621;
  fiat_p511_uint1 x622;
  uint64_t x623;
  fiat_p511_uint1 x624;
  uint64_t x625;
  fiat_p511_uint1 x626;
  uint64_t x627;
  fiat_p511_uint1 x628;
  uint64_t x629;
  fiat_p511_uint1 x630;
  uint64_t x631;
  fiat_p511_uint1 x632;
  uint64_t x633;
  fiat_p511_uint1 x634;
  uint64_t x635;
  fiat_p511_uint1 x636;
  uint64_t x637;
  fiat_p511_uint1 x638;
  uint64_t x639;
  fiat_p511_uint1 x640;
  uint64_t x641;
  fiat_p511_uint1 x642;
  uint64_t x643;
  fiat_p511_uint1 x644;
  uint64_t x645;
  fiat_p511_uint1 x646;
  uint64_t x647;
  fiat_p511_uint1 x648;
  uint64_t x649;
  fiat_p511_uint1 x650;
  uint64_t x651;
  uint64_t x652;
  uint64_t x653;
  uint64_t x654;
  uint64_t x655;
  uint64_t x656;
  uint64_t x657;
  uint64_t x658;
  uint64_t x659;
  uint64_t x660;
  uint64_t x661;
  uint64_t x662;
  uint64_t x663;
  uint64_t x664;
  uint64_t x665;
  uint64_t x666;
  uint64_t x667;
  fiat_p511_uint1 x668;
  uint64_t x669;
  fiat_p511_uint1 x670;
  uint64_t x671;
  fiat_p511_uint1 x672;
  uint64_t x673;
  fiat_p511_uint1 x674;
  uint64_t x675;
  fiat_p511_uint1 x676;
  uint64_t x677;
  fiat_p511_uint1 x678;
  uint64_t x679;
  fiat_p511_uint1 x680;
  uint64_t x681;
  fiat_p511_uint1 x682;
  uint64_t x683;
  fiat_p511_uint1 x684;
  uint64_t x685;
  fiat_p511_uint1 x686;
  uint64_t x687;
  fiat_p511_uint1 x688;
  uint64_t x689;
  fiat_p511_uint1 x690;
  uint64_t x691;
  fiat_p511_uint1 x692;
  uint64_t x693;
  fiat_p511_uint1 x694;
  uint64_t x695;
  fiat_p511_uint1 x696;
  uint64_t x697;
  uint64_t x698;
  uint64_t x699;
  uint64_t x700;
  uint64_t x701;
  uint64_t x702;
  uint64_t x703;
  uint64_t x704;
  uint64_t x705;
  uint64_t x706;
  uint64_t x707;
  uint64_t x708;
  uint64_t x709;
  uint64_t x710;
  uint64_t x711;
  uint64_t x712;
  uint64_t x713;
  uint64_t x714;
  uint64_t x715;
  fiat_p511_uint1 x716;
  uint64_t x717;
  fiat_p511_uint1 x718;
  uint64_t x719;
  fiat_p511_uint1 x720;
  uint64_t x721;
  fiat_p511_uint1 x722;
  uint64_t x723;
  fiat_p511_uint1 x724;
  uint64_t x725;
  fiat_p511_uint1 x726;
  uint64_t x727;
  fiat_p511_uint1 x728;
  uint64_t x729;
  fiat_p511_uint1 x730;
  uint64_t x731;
  fiat_p511_uint1 x732;
  uint64_t x733;
  fiat_p511_uint1 x734;
  uint64_t x735;
  fiat_p511_uint1 x736;
  uint64_t x737;
  fiat_p511_uint1 x738;
  uint64_t x739;
  fiat_p511_uint1 x740;
  uint64_t x741;
  fiat_p511_uint1 x742;
  uint64_t x743;
  fiat_p511_uint1 x744;
  uint64_t x745;
  uint64_t x746;
  fiat_p511_uint1 x747;
  uint64_t x748;
  fiat_p511_uint1 x749;
  uint64_t x750;
  fiat_p511_uint1 x751;
  uint64_t x752;
  fiat_p511_uint1 x753;
  uint64_t x754;
  fiat_p511_uint1 x755;
  uint64_t x756;
  fiat_p511_uint1 x757;
  uint64_t x758;
  fiat_p511_uint1 x759;
  uint64_t x760;
  fiat_p511_uint1 x761;
  uint64_t x762;
  fiat_p511_uint1 x763;
  uint64_t x764;
  uint64_t x765;
  uint64_t x766;
  uint64_t x767;
  uint64_t x768;
  uint64_t x769;
  uint64_t x770;
  uint64_t x771;
  x1 = (arg1[1]);
  x2 = (arg1[2]);
  x3 = (arg1[3]);
  x4 = (arg1[4]);
  x5 = (arg1[5]);
  x6 = (arg1[6]);
  x7 = (arg1[7]);
  x8 = (arg1[0]);
  fiat_p511_mulx_u64(&x9, &x10, x8, UINT64_C(0x4ed759aea6f3917e));
  fiat_p511_mulx_u64(&x11, &x12, x8, UINT64_C(0xad5f166e20e4f52d));
  fiat_p511_mulx_u64(&x13, &x14, x8, UINT64_C(0x1e9248731776b371));
  fiat_p511_mulx_u64(&x15, &x16, x8, UINT64_C(0x5dae03ee2f5de3d0));
  fiat_p511_mulx_u64(&x17, &x18, x8, UINT64_C(0x192ea214bcc584b1));
  fiat_p511_mulx_u64(&x19, &x20, x8, UINT64_C(0x4faf3fbfd22370ca));
  fiat_p511_mulx_u64(&x21, &x22, x8, UINT64_C(0x67086f4525f1f27d));
  fiat_p511_mulx_u64(&x23, &x24, x8, UINT64_C(0x36905b572ffc1724));
  fiat_p511_addcarryx_u64(&x25, &x26, 0x0, x24, x21);
  fiat_p511_addcarryx_u64(&x27, &x28, x26, x22, x19);
  fiat_p511_addcarryx_u64(&x29, &x30, x28, x20, x17);
  fiat_p511_addcarryx_u64(&x31, &x32, x30, x18, x15);
  fiat_p511_addcarryx_u64(&x33, &x34, x32, x16, x13);
  fiat_p511_addcarryx_u64(&x35, &x36, x34, x14, x11);
  fiat_p511_addcarryx_u64(&x37, &x38, x36, x12, x9);
  fiat_p511_mulx_u64(&x39, &x40, x23, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x41, &x42, x39, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x43, &x44, x39, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x45, &x46, x39, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x47, &x48, x39, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x49, &x50, x39, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x51, &x52, x39, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x53, &x54, x39, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x55, &x56, x39, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x57, &x58, 0x0, x56, x53);
  fiat_p511_addcarryx_u64(&x59, &x60, x58, x54, x51);
  fiat_p511_addcarryx_u64(&x61, &x62, x60, x52, x49);
  fiat_p511_addcarryx_u64(&x63, &x64, x62, x50, x47);
  fiat_p511_addcarryx_u64(&x65, &x66, x64, x48, x45);
  fiat_p511_addcarryx_u64(&x67, &x68, x66, x46, x43);
  fiat_p511_addcarryx_u64(&x69, &x70, x68, x44, x41);
  fiat_p511_addcarryx_u64(&x71, &x72, 0x0, x23, x55);
  fiat_p511_addcarryx_u64(&x73, &x74, x72, x25, x57);
  fiat_p511_addcarryx_u64(&x75, &x76, x74, x27, x59);
  fiat_p511_addcarryx_u64(&x77, &x78, x76, x29, x61);
  fiat_p511_addcarryx_u64(&x79, &x80, x78, x31, x63);
  fiat_p511_addcarryx_u64(&x81, &x82, x80, x33, x65);
  fiat_p511_addcarryx_u64(&x83, &x84, x82, x35, x67);
  fiat_p511_addcarryx_u64(&x85, &x86, x84, x37, x69);
  fiat_p511_mulx_u64(&x87, &x88, x1, UINT64_C(0x4ed759aea6f3917e));
  fiat_p511_mulx_u64(&x89, &x90, x1, UINT64_C(0xad5f166e20e4f52d));
  fiat_p511_mulx_u64(&x91, &x92, x1, UINT64_C(0x1e9248731776b371));
  fiat_p511_mulx_u64(&x93, &x94, x1, UINT64_C(0x5dae03ee2f5de3d0));
  fiat_p511_mulx_u64(&x95, &x96, x1, UINT64_C(0x192ea214bcc584b1));
  fiat_p511_mulx_u64(&x97, &x98, x1, UINT64_C(0x4faf3fbfd22370ca));
  fiat_p511_mulx_u64(&x99, &x100, x1, UINT64_C(0x67086f4525f1f27d));
  fiat_p511_mulx_u64(&x101, &x102, x1, UINT64_C(0x36905b572ffc1724));
  fiat_p511_addcarryx_u64(&x103, &x104, 0x0, x102, x99);
  fiat_p511_addcarryx_u64(&x105, &x106, x104, x100, x97);
  fiat_p511_addcarryx_u64(&x107, &x108, x106, x98, x95);
  fiat_p511_addcarryx_u64(&x109, &x110, x108, x96, x93);
  fiat_p511_addcarryx_u64(&x111, &x112, x110, x94, x91);
  fiat_p511_addcarryx_u64(&x113, &x114, x112, x92, x89);
  fiat_p511_addcarryx_u64(&x115, &x116, x114, x90, x87);
  fiat_p511_addcarryx_u64(&x117, &x118, 0x0, x73, x101);
  fiat_p511_addcarryx_u64(&x119, &x120, x118, x75, x103);
  fiat_p511_addcarryx_u64(&x121, &x122, x120, x77, x105);
  fiat_p511_addcarryx_u64(&x123, &x124, x122, x79, x107);
  fiat_p511_addcarryx_u64(&x125, &x126, x124, x81, x109);
  fiat_p511_addcarryx_u64(&x127, &x128, x126, x83, x111);
  fiat_p511_addcarryx_u64(&x129, &x130, x128, x85, x113);
  fiat_p511_addcarryx_u64(&x131, &x132, x130, ((x86 + (x38 + x10)) + (x70 + x42)), x115);
  fiat_p511_mulx_u64(&x133, &x134, x117, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x135, &x136, x133, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x137, &x138, x133, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x139, &x140, x133, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x141, &x142, x133, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x143, &x144, x133, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x145, &x146, x133, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x147, &x148, x133, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x149, &x150, x133, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x151, &x152, 0x0, x150, x147);
  fiat_p511_addcarryx_u64(&x153, &x154, x152, x148, x145);
  fiat_p511_addcarryx_u64(&x155, &x156, x154, x146, x143);
  fiat_p511_addcarryx_u64(&x157, &x158, x156, x144, x141);
  fiat_p511_addcarryx_u64(&x159, &x160, x158, x142, x139);
  fiat_p511_addcarryx_u64(&x161, &x162, x160, x140, x137);
  fiat_p511_addcarryx_u64(&x163, &x164, x162, x138, x135);
  fiat_p511_addcarryx_u64(&x165, &x166, 0x0, x117, x149);
  fiat_p511_addcarryx_u64(&x167, &x168, x166, x119, x151);
  fiat_p511_addcarryx_u64(&x169, &x170, x168, x121, x153);
  fiat_p511_addcarryx_u64(&x171, &x172, x170, x123, x155);
  fiat_p511_addcarryx_u64(&x173, &x174, x172, x125, x157);
  fiat_p511_addcarryx_u64(&x175, &x176, x174, x127, x159);
  fiat_p511_addcarryx_u64(&x177, &x178, x176, x129, x161);
  fiat_p511_addcarryx_u64(&x179, &x180, x178, x131, x163);
  fiat_p511_mulx_u64(&x181, &x182, x2, UINT64_C(0x4ed759aea6f3917e));
  fiat_p511_mulx_u64(&x183, &x184, x2, UINT64_C(0xad5f166e20e4f52d));
  fiat_p511_mulx_u64(&x185, &x186, x2, UINT64_C(0x1e9248731776b371));
  fiat_p511_mulx_u64(&x187, &x188, x2, UINT64_C(0x5dae03ee2f5de3d0));
  fiat_p511_mulx_u64(&x189, &x190, x2, UINT64_C(0x192ea214bcc584b1));
  fiat_p511_mulx_u64(&x191, &x192, x2, UINT64_C(0x4faf3fbfd22370ca));
  fiat_p511_mulx_u64(&x193, &x194, x2, UINT64_C(0x67086f4525f1f27d));
  fiat_p511_mulx_u64(&x195, &x196, x2, UINT64_C(0x36905b572ffc1724));
  fiat_p511_addcarryx_u64(&x197, &x198, 0x0, x196, x193);
  fiat_p511_addcarryx_u64(&x199, &x200, x198, x194, x191);
  fiat_p511_addcarryx_u64(&x201, &x202, x200, x192, x189);
  fiat_p511_addcarryx_u64(&x203, &x204, x202, x190, x187);
  fiat_p511_addcarryx_u64(&x205, &x206, x204, x188, x185);
  fiat_p511_addcarryx_u64(&x207, &x208, x206, x186, x183);
  fiat_p511_addcarryx_u64(&x209, &x210, x208, x184, x181);
  fiat_p511_addcarryx_u64(&x211, &x212, 0x0, x167, x195);
  fiat_p511_addcarryx_u64(&x213, &x214, x212, x169, x197);
  fiat_p511_addcarryx_u64(&x215, &x216, x214, x171, x199);
  fiat_p511_addcarryx_u64(&x217, &x218, x216, x173, x201);
  fiat_p511_addcarryx_u64(&x219, &x220, x218, x175, x203);
  fiat_p511_addcarryx_u64(&x221, &x222, x220, x177, x205);
  fiat_p511_addcarryx_u64(&x223, &x224, x222, x179, x207);
  fiat_p511_addcarryx_u64(&x225, &x226, x224, ((x180 + (x132 + (x116 + x88))) + (x164 + x136)), x209);
  fiat_p511_mulx_u64(&x227, &x228, x211, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x229, &x230, x227, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x231, &x232, x227, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x233, &x234, x227, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x235, &x236, x227, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x237, &x238, x227, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x239, &x240, x227, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x241, &x242, x227, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x243, &x244, x227, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x245, &x246, 0x0, x244, x241);
  fiat_p511_addcarryx_u64(&x247, &x248, x246, x242, x239);
  fiat_p511_addcarryx_u64(&x249, &x250, x248, x240, x237);
  fiat_p511_addcarryx_u64(&x251, &x252, x250, x238, x235);
  fiat_p511_addcarryx_u64(&x253, &x254, x252, x236, x233);
  fiat_p511_addcarryx_u64(&x255, &x256, x254, x234, x231);
  fiat_p511_addcarryx_u64(&x257, &x258, x256, x232, x229);
  fiat_p511_addcarryx_u64(&x259, &x260, 0x0, x211, x243);
  fiat_p511_addcarryx_u64(&x261, &x262, x260, x213, x245);
  fiat_p511_addcarryx_u64(&x263, &x264, x262, x215, x247);
  fiat_p511_addcarryx_u64(&x265, &x266, x264, x217, x249);
  fiat_p511_addcarryx_u64(&x267, &x268, x266, x219, x251);
  fiat_p511_addcarryx_u64(&x269, &x270, x268, x221, x253);
  fiat_p511_addcarryx_u64(&x271, &x272, x270, x223, x255);
  fiat_p511_addcarryx_u64(&x273, &x274, x272, x225, x257);
  fiat_p511_mulx_u64(&x275, &x276, x3, UINT64_C(0x4ed759aea6f3917e));
  fiat_p511_mulx_u64(&x277, &x278, x3, UINT64_C(0xad5f166e20e4f52d));
  fiat_p511_mulx_u64(&x279, &x280, x3, UINT64_C(0x1e9248731776b371));
  fiat_p511_mulx_u64(&x281, &x282, x3, UINT64_C(0x5dae03ee2f5de3d0));
  fiat_p511_mulx_u64(&x283, &x284, x3, UINT64_C(0x192ea214bcc584b1));
  fiat_p511_mulx_u64(&x285, &x286, x3, UINT64_C(0x4faf3fbfd22370ca));
  fiat_p511_mulx_u64(&x287, &x288, x3, UINT64_C(0x67086f4525f1f27d));
  fiat_p511_mulx_u64(&x289, &x290, x3, UINT64_C(0x36905b572ffc1724));
  fiat_p511_addcarryx_u64(&x291, &x292, 0x0, x290, x287);
  fiat_p511_addcarryx_u64(&x293, &x294, x292, x288, x285);
  fiat_p511_addcarryx_u64(&x295, &x296, x294, x286, x283);
  fiat_p511_addcarryx_u64(&x297, &x298, x296, x284, x281);
  fiat_p511_addcarryx_u64(&x299, &x300, x298, x282, x279);
  fiat_p511_addcarryx_u64(&x301, &x302, x300, x280, x277);
  fiat_p511_addcarryx_u64(&x303, &x304, x302, x278, x275);
  fiat_p511_addcarryx_u64(&x305, &x306, 0x0, x261, x289);
  fiat_p511_addcarryx_u64(&x307, &x308, x306, x263, x291);
  fiat_p511_addcarryx_u64(&x309, &x310, x308, x265, x293);
  fiat_p511_addcarryx_u64(&x311, &x312, x310, x267, x295);
  fiat_p511_addcarryx_u64(&x313, &x314, x312, x269, x297);
  fiat_p511_addcarryx_u64(&x315, &x316, x314, x271, x299);
  fiat_p511_addcarryx_u64(&x317, &x318, x316, x273, x301);
  fiat_p511_addcarryx_u64(&x319, &x320, x318, ((x274 + (x226 + (x210 + x182))) + (x258 + x230)), x303);
  fiat_p511_mulx_u64(&x321, &x322, x305, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x323, &x324, x321, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x325, &x326, x321, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x327, &x328, x321, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x329, &x330, x321, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x331, &x332, x321, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x333, &x334, x321, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x335, &x336, x321, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x337, &x338, x321, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x339, &x340, 0x0, x338, x335);
  fiat_p511_addcarryx_u64(&x341, &x342, x340, x336, x333);
  fiat_p511_addcarryx_u64(&x343, &x344, x342, x334, x331);
  fiat_p511_addcarryx_u64(&x345, &x346, x344, x332, x329);
  fiat_p511_addcarryx_u64(&x347, &x348, x346, x330, x327);
  fiat_p511_addcarryx_u64(&x349, &x350, x348, x328, x325);
  fiat_p511_addcarryx_u64(&x351, &x352, x350, x326, x323);
  fiat_p511_addcarryx_u64(&x353, &x354, 0x0, x305, x337);
  fiat_p511_addcarryx_u64(&x355, &x356, x354, x307, x339);
  fiat_p511_addcarryx_u64(&x357, &x358, x356, x309, x341);
  fiat_p511_addcarryx_u64(&x359, &x360, x358, x311, x343);
  fiat_p511_addcarryx_u64(&x361, &x362, x360, x313, x345);
  fiat_p511_addcarryx_u64(&x363, &x364, x362, x315, x347);
  fiat_p511_addcarryx_u64(&x365, &x366, x364, x317, x349);
  fiat_p511_addcarryx_u64(&x367, &x368, x366, x319, x351);
  fiat_p511_mulx_u64(&x369, &x370, x4, UINT64_C(0x4ed759aea6f3917e));
  fiat_p511_mulx_u64(&x371, &x372, x4, UINT64_C(0xad5f166e20e4f52d));
  fiat_p511_mulx_u64(&x373, &x374, x4, UINT64_C(0x1e9248731776b371));
  fiat_p511_mulx_u64(&x375, &x376, x4, UINT64_C(0x5dae03ee2f5de3d0));
  fiat_p511_mulx_u64(&x377, &x378, x4, UINT64_C(0x192ea214bcc584b1));
  fiat_p511_mulx_u64(&x379, &x380, x4, UINT64_C(0x4faf3fbfd22370ca));
  fiat_p511_mulx_u64(&x381, &x382, x4, UINT64_C(0x67086f4525f1f27d));
  fiat_p511_mulx_u64(&x383, &x384, x4, UINT64_C(0x36905b572ffc1724));
  fiat_p511_addcarryx_u64(&x385, &x386, 0x0, x384, x381);
  fiat_p511_addcarryx_u64(&x387, &x388, x386, x382, x379);
  fiat_p511_addcarryx_u64(&x389, &x390, x388, x380, x377);
  fiat_p511_addcarryx_u64(&x391, &x392, x390, x378, x375);
  fiat_p511_addcarryx_u64(&x393, &x394, x392, x376, x373);
  fiat_p511_addcarryx_u64(&x395, &x396, x394, x374, x371);
  fiat_p511_addcarryx_u64(&x397, &x398, x396, x372, x369);
  fiat_p511_addcarryx_u64(&x399, &x400, 0x0, x355, x383);
  fiat_p511_addcarryx_u64(&x401, &x402, x400, x357, x385);
  fiat_p511_addcarryx_u64(&x403, &x404, x402, x359, x387);
  fiat_p511_addcarryx_u64(&x405, &x406, x404, x361, x389);
  fiat_p511_addcarryx_u64(&x407, &x408, x406, x363, x391);
  fiat_p511_addcarryx_u64(&x409, &x410, x408, x365, x393);
  fiat_p511_addcarryx_u64(&x411, &x412, x410, x367, x395);
  fiat_p511_addcarryx_u64(&x413, &x414, x412, ((x368 + (x320 + (x304 + x276))) + (x352 + x324)), x397);
  fiat_p511_mulx_u64(&x415, &x416, x399, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x417, &x418, x415, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x419, &x420, x415, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x421, &x422, x415, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x423, &x424, x415, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x425, &x426, x415, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x427, &x428, x415, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x429, &x430, x415, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x431, &x432, x415, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x433, &x434, 0x0, x432, x429);
  fiat_p511_addcarryx_u64(&x435, &x436, x434, x430, x427);
  fiat_p511_addcarryx_u64(&x437, &x438, x436, x428, x425);
  fiat_p511_addcarryx_u64(&x439, &x440, x438, x426, x423);
  fiat_p511_addcarryx_u64(&x441, &x442, x440, x424, x421);
  fiat_p511_addcarryx_u64(&x443, &x444, x442, x422, x419);
  fiat_p511_addcarryx_u64(&x445, &x446, x444, x420, x417);
  fiat_p511_addcarryx_u64(&x447, &x448, 0x0, x399, x431);
  fiat_p511_addcarryx_u64(&x449, &x450, x448, x401, x433);
  fiat_p511_addcarryx_u64(&x451, &x452, x450, x403, x435);
  fiat_p511_addcarryx_u64(&x453, &x454, x452, x405, x437);
  fiat_p511_addcarryx_u64(&x455, &x456, x454, x407, x439);
  fiat_p511_addcarryx_u64(&x457, &x458, x456, x409, x441);
  fiat_p511_addcarryx_u64(&x459, &x460, x458, x411, x443);
  fiat_p511_addcarryx_u64(&x461, &x462, x460, x413, x445);
  fiat_p511_mulx_u64(&x463, &x464, x5, UINT64_C(0x4ed759aea6f3917e));
  fiat_p511_mulx_u64(&x465, &x466, x5, UINT64_C(0xad5f166e20e4f52d));
  fiat_p511_mulx_u64(&x467, &x468, x5, UINT64_C(0x1e9248731776b371));
  fiat_p511_mulx_u64(&x469, &x470, x5, UINT64_C(0x5dae03ee2f5de3d0));
  fiat_p511_mulx_u64(&x471, &x472, x5, UINT64_C(0x192ea214bcc584b1));
  fiat_p511_mulx_u64(&x473, &x474, x5, UINT64_C(0x4faf3fbfd22370ca));
  fiat_p511_mulx_u64(&x475, &x476, x5, UINT64_C(0x67086f4525f1f27d));
  fiat_p511_mulx_u64(&x477, &x478, x5, UINT64_C(0x36905b572ffc1724));
  fiat_p511_addcarryx_u64(&x479, &x480, 0x0, x478, x475);
  fiat_p511_addcarryx_u64(&x481, &x482, x480, x476, x473);
  fiat_p511_addcarryx_u64(&x483, &x484, x482, x474, x471);
  fiat_p511_addcarryx_u64(&x485, &x486, x484, x472, x469);
  fiat_p511_addcarryx_u64(&x487, &x488, x486, x470, x467);
  fiat_p511_addcarryx_u64(&x489, &x490, x488, x468, x465);
  fiat_p511_addcarryx_u64(&x491, &x492, x490, x466, x463);
  fiat_p511_addcarryx_u64(&x493, &x494, 0x0, x449, x477);
  fiat_p511_addcarryx_u64(&x495, &x496, x494, x451, x479);
  fiat_p511_addcarryx_u64(&x497, &x498, x496, x453, x481);
  fiat_p511_addcarryx_u64(&x499, &x500, x498, x455, x483);
  fiat_p511_addcarryx_u64(&x501, &x502, x500, x457, x485);
  fiat_p511_addcarryx_u64(&x503, &x504, x502, x459, x487);
  fiat_p511_addcarryx_u64(&x505, &x506, x504, x461, x489);
  fiat_p511_addcarryx_u64(&x507, &x508, x506, ((x462 + (x414 + (x398 + x370))) + (x446 + x418)), x491);
  fiat_p511_mulx_u64(&x509, &x510, x493, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x511, &x512, x509, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x513, &x514, x509, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x515, &x516, x509, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x517, &x518, x509, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x519, &x520, x509, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x521, &x522, x509, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x523, &x524, x509, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x525, &x526, x509, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x527, &x528, 0x0, x526, x523);
  fiat_p511_addcarryx_u64(&x529, &x530, x528, x524, x521);
  fiat_p511_addcarryx_u64(&x531, &x532, x530, x522, x519);
  fiat_p511_addcarryx_u64(&x533, &x534, x532, x520, x517);
  fiat_p511_addcarryx_u64(&x535, &x536, x534, x518, x515);
  fiat_p511_addcarryx_u64(&x537, &x538, x536, x516, x513);
  fiat_p511_addcarryx_u64(&x539, &x540, x538, x514, x511);
  fiat_p511_addcarryx_u64(&x541, &x542, 0x0, x493, x525);
  fiat_p511_addcarryx_u64(&x543, &x544, x542, x495, x527);
  fiat_p511_addcarryx_u64(&x545, &x546, x544, x497, x529);
  fiat_p511_addcarryx_u64(&x547, &x548, x546, x499, x531);
  fiat_p511_addcarryx_u64(&x549, &x550, x548, x501, x533);
  fiat_p511_addcarryx_u64(&x551, &x552, x550, x503, x535);
  fiat_p511_addcarryx_u64(&x553, &x554, x552, x505, x537);
  fiat_p511_addcarryx_u64(&x555, &x556, x554, x507, x539);
  fiat_p511_mulx_u64(&x557, &x558, x6, UINT64_C(0x4ed759aea6f3917e));
  fiat_p511_mulx_u64(&x559, &x560, x6, UINT64_C(0xad5f166e20e4f52d));
  fiat_p511_mulx_u64(&x561, &x562, x6, UINT64_C(0x1e9248731776b371));
  fiat_p511_mulx_u64(&x563, &x564, x6, UINT64_C(0x5dae03ee2f5de3d0));
  fiat_p511_mulx_u64(&x565, &x566, x6, UINT64_C(0x192ea214bcc584b1));
  fiat_p511_mulx_u64(&x567, &x568, x6, UINT64_C(0x4faf3fbfd22370ca));
  fiat_p511_mulx_u64(&x569, &x570, x6, UINT64_C(0x67086f4525f1f27d));
  fiat_p511_mulx_u64(&x571, &x572, x6, UINT64_C(0x36905b572ffc1724));
  fiat_p511_addcarryx_u64(&x573, &x574, 0x0, x572, x569);
  fiat_p511_addcarryx_u64(&x575, &x576, x574, x570, x567);
  fiat_p511_addcarryx_u64(&x577, &x578, x576, x568, x565);
  fiat_p511_addcarryx_u64(&x579, &x580, x578, x566, x563);
  fiat_p511_addcarryx_u64(&x581, &x582, x580, x564, x561);
  fiat_p511_addcarryx_u64(&x583, &x584, x582, x562, x559);
  fiat_p511_addcarryx_u64(&x585, &x586, x584, x560, x557);
  fiat_p511_addcarryx_u64(&x587, &x588, 0x0, x543, x571);
  fiat_p511_addcarryx_u64(&x589, &x590, x588, x545, x573);
  fiat_p511_addcarryx_u64(&x591, &x592, x590, x547, x575);
  fiat_p511_addcarryx_u64(&x593, &x594, x592, x549, x577);
  fiat_p511_addcarryx_u64(&x595, &x596, x594, x551, x579);
  fiat_p511_addcarryx_u64(&x597, &x598, x596, x553, x581);
  fiat_p511_addcarryx_u64(&x599, &x600, x598, x555, x583);
  fiat_p511_addcarryx_u64(&x601, &x602, x600, ((x556 + (x508 + (x492 + x464))) + (x540 + x512)), x585);
  fiat_p511_mulx_u64(&x603, &x604, x587, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x605, &x606, x603, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x607, &x608, x603, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x609, &x610, x603, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x611, &x612, x603, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x613, &x614, x603, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x615, &x616, x603, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x617, &x618, x603, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x619, &x620, x603, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x621, &x622, 0x0, x620, x617);
  fiat_p511_addcarryx_u64(&x623, &x624, x622, x618, x615);
  fiat_p511_addcarryx_u64(&x625, &x626, x624, x616, x613);
  fiat_p511_addcarryx_u64(&x627, &x628, x626, x614, x611);
  fiat_p511_addcarryx_u64(&x629, &x630, x628, x612, x609);
  fiat_p511_addcarryx_u64(&x631, &x632, x630, x610, x607);
  fiat_p511_addcarryx_u64(&x633, &x634, x632, x608, x605);
  fiat_p511_addcarryx_u64(&x635, &x636, 0x0, x587, x619);
  fiat_p511_addcarryx_u64(&x637, &x638, x636, x589, x621);
  fiat_p511_addcarryx_u64(&x639, &x640, x638, x591, x623);
  fiat_p511_addcarryx_u64(&x641, &x642, x640, x593, x625);
  fiat_p511_addcarryx_u64(&x643, &x644, x642, x595, x627);
  fiat_p511_addcarryx_u64(&x645, &x646, x644, x597, x629);
  fiat_p511_addcarryx_u64(&x647, &x648, x646, x599, x631);
  fiat_p511_addcarryx_u64(&x649, &x650, x648, x601, x633);
  fiat_p511_mulx_u64(&x651, &x652, x7, UINT64_C(0x4ed759aea6f3917e));
  fiat_p511_mulx_u64(&x653, &x654, x7, UINT64_C(0xad5f166e20e4f52d));
  fiat_p511_mulx_u64(&x655, &x656, x7, UINT64_C(0x1e9248731776b371));
  fiat_p511_mulx_u64(&x657, &x658, x7, UINT64_C(0x5dae03ee2f5de3d0));
  fiat_p511_mulx_u64(&x659, &x660, x7, UINT64_C(0x192ea214bcc584b1));
  fiat_p511_mulx_u64(&x661, &x662, x7, UINT64_C(0x4faf3fbfd22370ca));
  fiat_p511_mulx_u64(&x663, &x664, x7, UINT64_C(0x67086f4525f1f27d));
  fiat_p511_mulx_u64(&x665, &x666, x7, UINT64_C(0x36905b572ffc1724));
  fiat_p511_addcarryx_u64(&x667, &x668, 0x0, x666, x663);
  fiat_p511_addcarryx_u64(&x669, &x670, x668, x664, x661);
  fiat_p511_addcarryx_u64(&x671, &x672, x670, x662, x659);
  fiat_p511_addcarryx_u64(&x673, &x674, x672, x660, x657);
  fiat_p511_addcarryx_u64(&x675, &x676, x674, x658, x655);
  fiat_p511_addcarryx_u64(&x677, &x678, x676, x656, x653);
  fiat_p511_addcarryx_u64(&x679, &x680, x678, x654, x651);
  fiat_p511_addcarryx_u64(&x681, &x682, 0x0, x637, x665);
  fiat_p511_addcarryx_u64(&x683, &x684, x682, x639, x667);
  fiat_p511_addcarryx_u64(&x685, &x686, x684, x641, x669);
  fiat_p511_addcarryx_u64(&x687, &x688, x686, x643, x671);
  fiat_p511_addcarryx_u64(&x689, &x690, x688, x645, x673);
  fiat_p511_addcarryx_u64(&x691, &x692, x690, x647, x675);
  fiat_p511_addcarryx_u64(&x693, &x694, x692, x649, x677);
  fiat_p511_addcarryx_u64(&x695, &x696, x694, ((x650 + (x602 + (x586 + x558))) + (x634 + x606)), x679);
  fiat_p511_mulx_u64(&x697, &x698, x681, UINT64_C(0x66c1301f632e294d));
  fiat_p511_mulx_u64(&x699, &x700, x697, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_mulx_u64(&x701, &x702, x697, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_mulx_u64(&x703, &x704, x697, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_mulx_u64(&x705, &x706, x697, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_mulx_u64(&x707, &x708, x697, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_mulx_u64(&x709, &x710, x697, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_mulx_u64(&x711, &x712, x697, UINT64_C(0xc2721bf457aca835));
  fiat_p511_mulx_u64(&x713, &x714, x697, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_addcarryx_u64(&x715, &x716, 0x0, x714, x711);
  fiat_p511_addcarryx_u64(&x717, &x718, x716, x712, x709);
  fiat_p511_addcarryx_u64(&x719, &x720, x718, x710, x707);
  fiat_p511_addcarryx_u64(&x721, &x722, x720, x708, x705);
  fiat_p511_addcarryx_u64(&x723, &x724, x722, x706, x703);
  fiat_p511_addcarryx_u64(&x725, &x726, x724, x704, x701);
  fiat_p511_addcarryx_u64(&x727, &x728, x726, x702, x699);
  fiat_p511_addcarryx_u64(&x729, &x730, 0x0, x681, x713);
  fiat_p511_addcarryx_u64(&x731, &x732, x730, x683, x715);
  fiat_p511_addcarryx_u64(&x733, &x734, x732, x685, x717);
  fiat_p511_addcarryx_u64(&x735, &x736, x734, x687, x719);
  fiat_p511_addcarryx_u64(&x737, &x738, x736, x689, x721);
  fiat_p511_addcarryx_u64(&x739, &x740, x738, x691, x723);
  fiat_p511_addcarryx_u64(&x741, &x742, x740, x693, x725);
  fiat_p511_addcarryx_u64(&x743, &x744, x742, x695, x727);
  x745 = ((x744 + (x696 + (x680 + x652))) + (x728 + x700));
  fiat_p511_subborrowx_u64(&x746, &x747, 0x0, x731, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_subborrowx_u64(&x748, &x749, x747, x733, UINT64_C(0xc2721bf457aca835));
  fiat_p511_subborrowx_u64(&x750, &x751, x749, x735, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_subborrowx_u64(&x752, &x753, x751, x737, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_subborrowx_u64(&x754, &x755, x753, x739, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_subborrowx_u64(&x756, &x757, x755, x741, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_subborrowx_u64(&x758, &x759, x757, x743, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_subborrowx_u64(&x760, &x761, x759, x745, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_subborrowx_u64(&x762, &x763, x761, 0x0, 0x0);
  fiat_p511_cmovznz_u64(&x764, x763, x746, x731);
  fiat_p511_cmovznz_u64(&x765, x763, x748, x733);
  fiat_p511_cmovznz_u64(&x766, x763, x750, x735);
  fiat_p511_cmovznz_u64(&x767, x763, x752, x737);
  fiat_p511_cmovznz_u64(&x768, x763, x754, x739);
  fiat_p511_cmovznz_u64(&x769, x763, x756, x741);
  fiat_p511_cmovznz_u64(&x770, x763, x758, x743);
  fiat_p511_cmovznz_u64(&x771, x763, x760, x745);
  out1[0] = x764;
  out1[1] = x765;
  out1[2] = x766;
  out1[3] = x767;
  out1[4] = x768;
  out1[5] = x769;
  out1[6] = x770;
  out1[7] = x771;
}

/*
 * The function fiat_p511_nonzero outputs a single non-zero word if the input is non-zero and zero otherwise.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   out1 = 0 ↔ eval (from_montgomery arg1) mod m = 0
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 */
void fiat_p511_nonzero(uint64_t* out1, const uint64_t arg1[8]) {
  uint64_t x1;
  x1 = ((arg1[0]) | ((arg1[1]) | ((arg1[2]) | ((arg1[3]) | ((arg1[4]) | ((arg1[5]) | ((arg1[6]) | (arg1[7]))))))));
  *out1 = x1;
}

/*
 * The function fiat_p511_selectznz is a multi-limb conditional select.
 *
 * Postconditions:
 *   out1 = (if arg1 = 0 then arg2 else arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */

/*
 * The function fiat_p511_to_bytes serializes a field element NOT in the Montgomery domain to bytes in little-endian order.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   out1 = map (λ x, ⌊((eval arg1 mod m) mod 2^(8 * (x + 1))) / 2^(8 * x)⌋) [0..63]
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0x7fffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0x7f]]
 */
void fiat_p511_to_bytes(uint8_t out1[64], const uint64_t arg1[8]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  uint8_t x9;
  uint64_t x10;
  uint8_t x11;
  uint64_t x12;
  uint8_t x13;
  uint64_t x14;
  uint8_t x15;
  uint64_t x16;
  uint8_t x17;
  uint64_t x18;
  uint8_t x19;
  uint64_t x20;
  uint8_t x21;
  uint8_t x22;
  uint8_t x23;
  uint64_t x24;
  uint8_t x25;
  uint64_t x26;
  uint8_t x27;
  uint64_t x28;
  uint8_t x29;
  uint64_t x30;
  uint8_t x31;
  uint64_t x32;
  uint8_t x33;
  uint64_t x34;
  uint8_t x35;
  uint8_t x36;
  uint8_t x37;
  uint64_t x38;
  uint8_t x39;
  uint64_t x40;
  uint8_t x41;
  uint64_t x42;
  uint8_t x43;
  uint64_t x44;
  uint8_t x45;
  uint64_t x46;
  uint8_t x47;
  uint64_t x48;
  uint8_t x49;
  uint8_t x50;
  uint8_t x51;
  uint64_t x52;
  uint8_t x53;
  uint64_t x54;
  uint8_t x55;
  uint64_t x56;
  uint8_t x57;
  uint64_t x58;
  uint8_t x59;
  uint64_t x60;
  uint8_t x61;
  uint64_t x62;
  uint8_t x63;
  uint8_t x64;
  uint8_t x65;
  uint64_t x66;
  uint8_t x67;
  uint64_t x68;
  uint8_t x69;
  uint64_t x70;
  uint8_t x71;
  uint64_t x72;
  uint8_t x73;
  uint64_t x74;
  uint8_t x75;
  uint64_t x76;
  uint8_t x77;
  uint8_t x78;
  uint8_t x79;
  uint64_t x80;
  uint8_t x81;
  uint64_t x82;
  uint8_t x83;
  uint64_t x84;
  uint8_t x85;
  uint64_t x86;
  uint8_t x87;
  uint64_t x88;
  uint8_t x89;
  uint64_t x90;
  uint8_t x91;
  uint8_t x92;
  uint8_t x93;
  uint64_t x94;
  uint8_t x95;
  uint64_t x96;
  uint8_t x97;
  uint64_t x98;
  uint8_t x99;
  uint64_t x100;
  uint8_t x101;
  uint64_t x102;
  uint8_t x103;
  uint64_t x104;
  uint8_t x105;
  uint8_t x106;
  uint8_t x107;
  uint64_t x108;
  uint8_t x109;
  uint64_t x110;
  uint8_t x111;
  uint64_t x112;
  uint8_t x113;
  uint64_t x114;
  uint8_t x115;
  uint64_t x116;
  uint8_t x117;
  uint64_t x118;
  uint8_t x119;
  uint8_t x120;
  x1 = (arg1[7]);
  x2 = (arg1[6]);
  x3 = (arg1[5]);
  x4 = (arg1[4]);
  x5 = (arg1[3]);
  x6 = (arg1[2]);
  x7 = (arg1[1]);
  x8 = (arg1[0]);
  x9 = (uint8_t)(x8 & UINT8_C(0xff));
  x10 = (x8 >> 8);
  x11 = (uint8_t)(x10 & UINT8_C(0xff));
  x12 = (x10 >> 8);
  x13 = (uint8_t)(x12 & UINT8_C(0xff));
  x14 = (x12 >> 8);
  x15 = (uint8_t)(x14 & UINT8_C(0xff));
  x16 = (x14 >> 8);
  x17 = (uint8_t)(x16 & UINT8_C(0xff));
  x18 = (x16 >> 8);
  x19 = (uint8_t)(x18 & UINT8_C(0xff));
  x20 = (x18 >> 8);
  x21 = (uint8_t)(x20 & UINT8_C(0xff));
  x22 = (uint8_t)(x20 >> 8);
  x23 = (uint8_t)(x7 & UINT8_C(0xff));
  x24 = (x7 >> 8);
  x25 = (uint8_t)(x24 & UINT8_C(0xff));
  x26 = (x24 >> 8);
  x27 = (uint8_t)(x26 & UINT8_C(0xff));
  x28 = (x26 >> 8);
  x29 = (uint8_t)(x28 & UINT8_C(0xff));
  x30 = (x28 >> 8);
  x31 = (uint8_t)(x30 & UINT8_C(0xff));
  x32 = (x30 >> 8);
  x33 = (uint8_t)(x32 & UINT8_C(0xff));
  x34 = (x32 >> 8);
  x35 = (uint8_t)(x34 & UINT8_C(0xff));
  x36 = (uint8_t)(x34 >> 8);
  x37 = (uint8_t)(x6 & UINT8_C(0xff));
  x38 = (x6 >> 8);
  x39 = (uint8_t)(x38 & UINT8_C(0xff));
  x40 = (x38 >> 8);
  x41 = (uint8_t)(x40 & UINT8_C(0xff));
  x42 = (x40 >> 8);
  x43 = (uint8_t)(x42 & UINT8_C(0xff));
  x44 = (x42 >> 8);
  x45 = (uint8_t)(x44 & UINT8_C(0xff));
  x46 = (x44 >> 8);
  x47 = (uint8_t)(x46 & UINT8_C(0xff));
  x48 = (x46 >> 8);
  x49 = (uint8_t)(x48 & UINT8_C(0xff));
  x50 = (uint8_t)(x48 >> 8);
  x51 = (uint8_t)(x5 & UINT8_C(0xff));
  x52 = (x5 >> 8);
  x53 = (uint8_t)(x52 & UINT8_C(0xff));
  x54 = (x52 >> 8);
  x55 = (uint8_t)(x54 & UINT8_C(0xff));
  x56 = (x54 >> 8);
  x57 = (uint8_t)(x56 & UINT8_C(0xff));
  x58 = (x56 >> 8);
  x59 = (uint8_t)(x58 & UINT8_C(0xff));
  x60 = (x58 >> 8);
  x61 = (uint8_t)(x60 & UINT8_C(0xff));
  x62 = (x60 >> 8);
  x63 = (uint8_t)(x62 & UINT8_C(0xff));
  x64 = (uint8_t)(x62 >> 8);
  x65 = (uint8_t)(x4 & UINT8_C(0xff));
  x66 = (x4 >> 8);
  x67 = (uint8_t)(x66 & UINT8_C(0xff));
  x68 = (x66 >> 8);
  x69 = (uint8_t)(x68 & UINT8_C(0xff));
  x70 = (x68 >> 8);
  x71 = (uint8_t)(x70 & UINT8_C(0xff));
  x72 = (x70 >> 8);
  x73 = (uint8_t)(x72 & UINT8_C(0xff));
  x74 = (x72 >> 8);
  x75 = (uint8_t)(x74 & UINT8_C(0xff));
  x76 = (x74 >> 8);
  x77 = (uint8_t)(x76 & UINT8_C(0xff));
  x78 = (uint8_t)(x76 >> 8);
  x79 = (uint8_t)(x3 & UINT8_C(0xff));
  x80 = (x3 >> 8);
  x81 = (uint8_t)(x80 & UINT8_C(0xff));
  x82 = (x80 >> 8);
  x83 = (uint8_t)(x82 & UINT8_C(0xff));
  x84 = (x82 >> 8);
  x85 = (uint8_t)(x84 & UINT8_C(0xff));
  x86 = (x84 >> 8);
  x87 = (uint8_t)(x86 & UINT8_C(0xff));
  x88 = (x86 >> 8);
  x89 = (uint8_t)(x88 & UINT8_C(0xff));
  x90 = (x88 >> 8);
  x91 = (uint8_t)(x90 & UINT8_C(0xff));
  x92 = (uint8_t)(x90 >> 8);
  x93 = (uint8_t)(x2 & UINT8_C(0xff));
  x94 = (x2 >> 8);
  x95 = (uint8_t)(x94 & UINT8_C(0xff));
  x96 = (x94 >> 8);
  x97 = (uint8_t)(x96 & UINT8_C(0xff));
  x98 = (x96 >> 8);
  x99 = (uint8_t)(x98 & UINT8_C(0xff));
  x100 = (x98 >> 8);
  x101 = (uint8_t)(x100 & UINT8_C(0xff));
  x102 = (x100 >> 8);
  x103 = (uint8_t)(x102 & UINT8_C(0xff));
  x104 = (x102 >> 8);
  x105 = (uint8_t)(x104 & UINT8_C(0xff));
  x106 = (uint8_t)(x104 >> 8);
  x107 = (uint8_t)(x1 & UINT8_C(0xff));
  x108 = (x1 >> 8);
  x109 = (uint8_t)(x108 & UINT8_C(0xff));
  x110 = (x108 >> 8);
  x111 = (uint8_t)(x110 & UINT8_C(0xff));
  x112 = (x110 >> 8);
  x113 = (uint8_t)(x112 & UINT8_C(0xff));
  x114 = (x112 >> 8);
  x115 = (uint8_t)(x114 & UINT8_C(0xff));
  x116 = (x114 >> 8);
  x117 = (uint8_t)(x116 & UINT8_C(0xff));
  x118 = (x116 >> 8);
  x119 = (uint8_t)(x118 & UINT8_C(0xff));
  x120 = (uint8_t)(x118 >> 8);
  out1[0] = x9;
  out1[1] = x11;
  out1[2] = x13;
  out1[3] = x15;
  out1[4] = x17;
  out1[5] = x19;
  out1[6] = x21;
  out1[7] = x22;
  out1[8] = x23;
  out1[9] = x25;
  out1[10] = x27;
  out1[11] = x29;
  out1[12] = x31;
  out1[13] = x33;
  out1[14] = x35;
  out1[15] = x36;
  out1[16] = x37;
  out1[17] = x39;
  out1[18] = x41;
  out1[19] = x43;
  out1[20] = x45;
  out1[21] = x47;
  out1[22] = x49;
  out1[23] = x50;
  out1[24] = x51;
  out1[25] = x53;
  out1[26] = x55;
  out1[27] = x57;
  out1[28] = x59;
  out1[29] = x61;
  out1[30] = x63;
  out1[31] = x64;
  out1[32] = x65;
  out1[33] = x67;
  out1[34] = x69;
  out1[35] = x71;
  out1[36] = x73;
  out1[37] = x75;
  out1[38] = x77;
  out1[39] = x78;
  out1[40] = x79;
  out1[41] = x81;
  out1[42] = x83;
  out1[43] = x85;
  out1[44] = x87;
  out1[45] = x89;
  out1[46] = x91;
  out1[47] = x92;
  out1[48] = x93;
  out1[49] = x95;
  out1[50] = x97;
  out1[51] = x99;
  out1[52] = x101;
  out1[53] = x103;
  out1[54] = x105;
  out1[55] = x106;
  out1[56] = x107;
  out1[57] = x109;
  out1[58] = x111;
  out1[59] = x113;
  out1[60] = x115;
  out1[61] = x117;
  out1[62] = x119;
  out1[63] = x120;
}

/*
 * The function fiat_p511_from_bytes deserializes a field element NOT in the Montgomery domain from bytes in little-endian order.
 *
 * Preconditions:
 *   0 ≤ bytes_eval arg1 < m
 * Postconditions:
 *   eval out1 mod m = bytes_eval arg1 mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0x7f]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0x7fffffffffffffff]]
 */
void fiat_p511_from_bytes(uint64_t out1[8], const uint8_t arg1[64]) {
  uint64_t x1;
  uint64_t x2;
  uint64_t x3;
  uint64_t x4;
  uint64_t x5;
  uint64_t x6;
  uint64_t x7;
  uint8_t x8;
  uint64_t x9;
  uint64_t x10;
  uint64_t x11;
  uint64_t x12;
  uint64_t x13;
  uint64_t x14;
  uint64_t x15;
  uint8_t x16;
  uint64_t x17;
  uint64_t x18;
  uint64_t x19;
  uint64_t x20;
  uint64_t x21;
  uint64_t x22;
  uint64_t x23;
  uint8_t x24;
  uint64_t x25;
  uint64_t x26;
  uint64_t x27;
  uint64_t x28;
  uint64_t x29;
  uint64_t x30;
  uint64_t x31;
  uint8_t x32;
  uint64_t x33;
  uint64_t x34;
  uint64_t x35;
  uint64_t x36;
  uint64_t x37;
  uint64_t x38;
  uint64_t x39;
  uint8_t x40;
  uint64_t x41;
  uint64_t x42;
  uint64_t x43;
  uint64_t x44;
  uint64_t x45;
  uint64_t x46;
  uint64_t x47;
  uint8_t x48;
  uint64_t x49;
  uint64_t x50;
  uint64_t x51;
  uint64_t x52;
  uint64_t x53;
  uint64_t x54;
  uint64_t x55;
  uint8_t x56;
  uint64_t x57;
  uint64_t x58;
  uint64_t x59;
  uint64_t x60;
  uint64_t x61;
  uint64_t x62;
  uint64_t x63;
  uint8_t x64;
  uint64_t x65;
  uint64_t x66;
  uint64_t x67;
  uint64_t x68;
  uint64_t x69;
  uint64_t x70;
  uint64_t x71;
  uint64_t x72;
  uint64_t x73;
  uint64_t x74;
  uint64_t x75;
  uint64_t x76;
  uint64_t x77;
  uint64_t x78;
  uint64_t x79;
  uint64_t x80;
  uint64_t x81;
  uint64_t x82;
  uint64_t x83;
  uint64_t x84;
  uint64_t x85;
  uint64_t x86;
  uint64_t x87;
  uint64_t x88;
  uint64_t x89;
  uint64_t x90;
  uint64_t x91;
  uint64_t x92;
  uint64_t x93;
  uint64_t x94;
  uint64_t x95;
  uint64_t x96;
  uint64_t x97;
  uint64_t x98;
  uint64_t x99;
  uint64_t x100;
  uint64_t x101;
  uint64_t x102;
  uint64_t x103;
  uint64_t x104;
  uint64_t x105;
  uint64_t x106;
  uint64_t x107;
  uint64_t x108;
  uint64_t x109;
  uint64_t x110;
  uint64_t x111;
  uint64_t x112;
  uint64_t x113;
  uint64_t x114;
  uint64_t x115;
  uint64_t x116;
  uint64_t x117;
  uint64_t x118;
  uint64_t x119;
  uint64_t x120;
  x1 = ((uint64_t)(arg1[63]) << 56);
  x2 = ((uint64_t)(arg1[62]) << 48);
  x3 = ((uint64_t)(arg1[61]) << 40);
  x4 = ((uint64_t)(arg1[60]) << 32);
  x5 = ((uint64_t)(arg1[59]) << 24);
  x6 = ((uint64_t)(arg1[58]) << 16);
  x7 = ((uint64_t)(arg1[57]) << 8);
  x8 = (arg1[56]);
  x9 = ((uint64_t)(arg1[55]) << 56);
  x10 = ((uint64_t)(arg1[54]) << 48);
  x11 = ((uint64_t)(arg1[53]) << 40);
  x12 = ((uint64_t)(arg1[52]) << 32);
  x13 = ((uint64_t)(arg1[51]) << 24);
  x14 = ((uint64_t)(arg1[50]) << 16);
  x15 = ((uint64_t)(arg1[49]) << 8);
  x16 = (arg1[48]);
  x17 = ((uint64_t)(arg1[47]) << 56);
  x18 = ((uint64_t)(arg1[46]) << 48);
  x19 = ((uint64_t)(arg1[45]) << 40);
  x20 = ((uint64_t)(arg1[44]) << 32);
  x21 = ((uint64_t)(arg1[43]) << 24);
  x22 = ((uint64_t)(arg1[42]) << 16);
  x23 = ((uint64_t)(arg1[41]) << 8);
  x24 = (arg1[40]);
  x25 = ((uint64_t)(arg1[39]) << 56);
  x26 = ((uint64_t)(arg1[38]) << 48);
  x27 = ((uint64_t)(arg1[37]) << 40);
  x28 = ((uint64_t)(arg1[36]) << 32);
  x29 = ((uint64_t)(arg1[35]) << 24);
  x30 = ((uint64_t)(arg1[34]) << 16);
  x31 = ((uint64_t)(arg1[33]) << 8);
  x32 = (arg1[32]);
  x33 = ((uint64_t)(arg1[31]) << 56);
  x34 = ((uint64_t)(arg1[30]) << 48);
  x35 = ((uint64_t)(arg1[29]) << 40);
  x36 = ((uint64_t)(arg1[28]) << 32);
  x37 = ((uint64_t)(arg1[27]) << 24);
  x38 = ((uint64_t)(arg1[26]) << 16);
  x39 = ((uint64_t)(arg1[25]) << 8);
  x40 = (arg1[24]);
  x41 = ((uint64_t)(arg1[23]) << 56);
  x42 = ((uint64_t)(arg1[22]) << 48);
  x43 = ((uint64_t)(arg1[21]) << 40);
  x44 = ((uint64_t)(arg1[20]) << 32);
  x45 = ((uint64_t)(arg1[19]) << 24);
  x46 = ((uint64_t)(arg1[18]) << 16);
  x47 = ((uint64_t)(arg1[17]) << 8);
  x48 = (arg1[16]);
  x49 = ((uint64_t)(arg1[15]) << 56);
  x50 = ((uint64_t)(arg1[14]) << 48);
  x51 = ((uint64_t)(arg1[13]) << 40);
  x52 = ((uint64_t)(arg1[12]) << 32);
  x53 = ((uint64_t)(arg1[11]) << 24);
  x54 = ((uint64_t)(arg1[10]) << 16);
  x55 = ((uint64_t)(arg1[9]) << 8);
  x56 = (arg1[8]);
  x57 = ((uint64_t)(arg1[7]) << 56);
  x58 = ((uint64_t)(arg1[6]) << 48);
  x59 = ((uint64_t)(arg1[5]) << 40);
  x60 = ((uint64_t)(arg1[4]) << 32);
  x61 = ((uint64_t)(arg1[3]) << 24);
  x62 = ((uint64_t)(arg1[2]) << 16);
  x63 = ((uint64_t)(arg1[1]) << 8);
  x64 = (arg1[0]);
  x65 = (x63 + (uint64_t)x64);
  x66 = (x62 + x65);
  x67 = (x61 + x66);
  x68 = (x60 + x67);
  x69 = (x59 + x68);
  x70 = (x58 + x69);
  x71 = (x57 + x70);
  x72 = (x55 + (uint64_t)x56);
  x73 = (x54 + x72);
  x74 = (x53 + x73);
  x75 = (x52 + x74);
  x76 = (x51 + x75);
  x77 = (x50 + x76);
  x78 = (x49 + x77);
  x79 = (x47 + (uint64_t)x48);
  x80 = (x46 + x79);
  x81 = (x45 + x80);
  x82 = (x44 + x81);
  x83 = (x43 + x82);
  x84 = (x42 + x83);
  x85 = (x41 + x84);
  x86 = (x39 + (uint64_t)x40);
  x87 = (x38 + x86);
  x88 = (x37 + x87);
  x89 = (x36 + x88);
  x90 = (x35 + x89);
  x91 = (x34 + x90);
  x92 = (x33 + x91);
  x93 = (x31 + (uint64_t)x32);
  x94 = (x30 + x93);
  x95 = (x29 + x94);
  x96 = (x28 + x95);
  x97 = (x27 + x96);
  x98 = (x26 + x97);
  x99 = (x25 + x98);
  x100 = (x23 + (uint64_t)x24);
  x101 = (x22 + x100);
  x102 = (x21 + x101);
  x103 = (x20 + x102);
  x104 = (x19 + x103);
  x105 = (x18 + x104);
  x106 = (x17 + x105);
  x107 = (x15 + (uint64_t)x16);
  x108 = (x14 + x107);
  x109 = (x13 + x108);
  x110 = (x12 + x109);
  x111 = (x11 + x110);
  x112 = (x10 + x111);
  x113 = (x9 + x112);
  x114 = (x7 + (uint64_t)x8);
  x115 = (x6 + x114);
  x116 = (x5 + x115);
  x117 = (x4 + x116);
  x118 = (x3 + x117);
  x119 = (x2 + x118);
  x120 = (x1 + x119);
  out1[0] = x71;
  out1[1] = x78;
  out1[2] = x85;
  out1[3] = x92;
  out1[4] = x99;
  out1[5] = x106;
  out1[6] = x113;
  out1[7] = x120;
}

/*
 * The function fiat_p511_set_one returns the field element one in the Montgomery domain.
 *
 * Postconditions:
 *   eval (from_montgomery out1) mod m = 1 mod m
 *   0 ≤ eval out1 < m
 *
 */
void fiat_p511_set_one(fiat_p511_montgomery_domain_field_element out1) {
  out1[0] = UINT64_C(0xc8fc8df598726f0a);
  out1[1] = UINT64_C(0x7b1bc81750a6af95);
  out1[2] = UINT64_C(0x5d319e67c1e961b4);
  out1[3] = UINT64_C(0xb0aa7275301955f1);
  out1[4] = UINT64_C(0x4a080672d9ba6c64);
  out1[5] = UINT64_C(0x97a5ef8a246ee77b);
  out1[6] = UINT64_C(0x6ea9e5d4383676a);
  out1[7] = UINT64_C(0x3496e2e117e0ec80);
}

/*
 * The function fiat_p511_msat returns the saturated representation of the prime modulus.
 *
 * Postconditions:
 *   twos_complement_eval out1 = m
 *   0 ≤ eval out1 < m
 *
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
void fiat_p511_msat(uint64_t out1[9]) {
  out1[0] = UINT64_C(0x1b81b90533c6c87b);
  out1[1] = UINT64_C(0xc2721bf457aca835);
  out1[2] = UINT64_C(0x516730cc1f0b4f25);
  out1[3] = UINT64_C(0xa7aac6c567f35507);
  out1[4] = UINT64_C(0x5afbfcc69322c9cd);
  out1[5] = UINT64_C(0xb42d083aedc88c42);
  out1[6] = UINT64_C(0xfc8ab0d15e3e4c4a);
  out1[7] = UINT64_C(0x65b48e8f740f89bf);
  out1[8] = 0x0;
}

/*
 * The function fiat_p511_divstep_precomp returns the precomputed value for Bernstein-Yang-inversion (in montgomery form).
 *
 * Postconditions:
 *   eval (from_montgomery out1) = ⌊(m - 1) / 2⌋^(if ⌊log2 m⌋ + 1 < 46 then ⌊(49 * (⌊log2 m⌋ + 1) + 80) / 17⌋ else ⌊(49 * (⌊log2 m⌋ + 1) + 57) / 17⌋)
 *   0 ≤ eval out1 < m
 *
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
void fiat_p511_divstep_precomp(uint64_t out1[8]) {
  out1[0] = UINT64_C(0x7a6bf74eaf918674);
  out1[1] = UINT64_C(0x23e0e653a8dce814);
  out1[2] = UINT64_C(0xa3c82c9792a4a8b4);
  out1[3] = UINT64_C(0xf2e01cc780f4af23);
  out1[4] = UINT64_C(0xdcdb1e2ca8b505c5);
  out1[5] = UINT64_C(0x759ed37101a3ef17);
  out1[6] = UINT64_C(0xf742d4159d41e5a);
  out1[7] = UINT64_C(0x24ee1d225795cce5);
}

/*
 * The function fiat_p511_divstep computes a divstep.
 *
 * Preconditions:
 *   0 ≤ eval arg4 < m
 *   0 ≤ eval arg5 < m
 * Postconditions:
 *   out1 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then 1 - arg1 else 1 + arg1)
 *   twos_complement_eval out2 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then twos_complement_eval arg3 else twos_complement_eval arg2)
 *   twos_complement_eval out3 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then ⌊(twos_complement_eval arg3 - twos_complement_eval arg2) / 2⌋ else ⌊(twos_complement_eval arg3 + (twos_complement_eval arg3 mod 2) * twos_complement_eval arg2) / 2⌋)
 *   eval (from_montgomery out4) mod m = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then (2 * eval (from_montgomery arg5)) mod m else (2 * eval (from_montgomery arg4)) mod m)
 *   eval (from_montgomery out5) mod m = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then (eval (from_montgomery arg4) - eval (from_montgomery arg4)) mod m else (eval (from_montgomery arg5) + (twos_complement_eval arg3 mod 2) * eval (from_montgomery arg4)) mod m)
 *   0 ≤ eval out5 < m
 *   0 ≤ eval out5 < m
 *   0 ≤ eval out2 < m
 *   0 ≤ eval out3 < m
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0xffffffffffffffff]
 *   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   arg4: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   arg5: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 *   out2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   out3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   out4: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   out5: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
void fiat_p511_divstep(uint64_t* out1, uint64_t out2[9], uint64_t out3[9], uint64_t out4[8], uint64_t out5[8], uint64_t arg1, const uint64_t arg2[9], const uint64_t arg3[9], const uint64_t arg4[8], const uint64_t arg5[8]) {
  uint64_t x1;
  fiat_p511_uint1 x2;
  fiat_p511_uint1 x3;
  uint64_t x4;
  fiat_p511_uint1 x5;
  uint64_t x6;
  uint64_t x7;
  uint64_t x8;
  uint64_t x9;
  uint64_t x10;
  uint64_t x11;
  uint64_t x12;
  uint64_t x13;
  uint64_t x14;
  uint64_t x15;
  uint64_t x16;
  fiat_p511_uint1 x17;
  uint64_t x18;
  fiat_p511_uint1 x19;
  uint64_t x20;
  fiat_p511_uint1 x21;
  uint64_t x22;
  fiat_p511_uint1 x23;
  uint64_t x24;
  fiat_p511_uint1 x25;
  uint64_t x26;
  fiat_p511_uint1 x27;
  uint64_t x28;
  fiat_p511_uint1 x29;
  uint64_t x30;
  fiat_p511_uint1 x31;
  uint64_t x32;
  fiat_p511_uint1 x33;
  uint64_t x34;
  uint64_t x35;
  uint64_t x36;
  uint64_t x37;
  uint64_t x38;
  uint64_t x39;
  uint64_t x40;
  uint64_t x41;
  uint64_t x42;
  uint64_t x43;
  uint64_t x44;
  uint64_t x45;
  uint64_t x46;
  uint64_t x47;
  uint64_t x48;
  uint64_t x49;
  uint64_t x50;
  uint64_t x51;
  fiat_p511_uint1 x52;
  uint64_t x53;
  fiat_p511_uint1 x54;
  uint64_t x55;
  fiat_p511_uint1 x56;
  uint64_t x57;
  fiat_p511_uint1 x58;
  uint64_t x59;
  fiat_p511_uint1 x60;
  uint64_t x61;
  fiat_p511_uint1 x62;
  uint64_t x63;
  fiat_p511_uint1 x64;
  uint64_t x65;
  fiat_p511_uint1 x66;
  uint64_t x67;
  fiat_p511_uint1 x68;
  uint64_t x69;
  fiat_p511_uint1 x70;
  uint64_t x71;
  fiat_p511_uint1 x72;
  uint64_t x73;
  fiat_p511_uint1 x74;
  uint64_t x75;
  fiat_p511_uint1 x76;
  uint64_t x77;
  fiat_p511_uint1 x78;
  uint64_t x79;
  fiat_p511_uint1 x80;
  uint64_t x81;
  fiat_p511_uint1 x82;
  uint64_t x83;
  fiat_p511_uint1 x84;
  uint64_t x85;
  uint64_t x86;
  uint64_t x87;
  uint64_t x88;
  uint64_t x89;
  uint64_t x90;
  uint64_t x91;
  uint64_t x92;
  uint64_t x93;
  fiat_p511_uint1 x94;
  uint64_t x95;
  fiat_p511_uint1 x96;
  uint64_t x97;
  fiat_p511_uint1 x98;
  uint64_t x99;
  fiat_p511_uint1 x100;
  uint64_t x101;
  fiat_p511_uint1 x102;
  uint64_t x103;
  fiat_p511_uint1 x104;
  uint64_t x105;
  fiat_p511_uint1 x106;
  uint64_t x107;
  fiat_p511_uint1 x108;
  uint64_t x109;
  uint64_t x110;
  fiat_p511_uint1 x111;
  uint64_t x112;
  fiat_p511_uint1 x113;
  uint64_t x114;
  fiat_p511_uint1 x115;
  uint64_t x116;
  fiat_p511_uint1 x117;
  uint64_t x118;
  fiat_p511_uint1 x119;
  uint64_t x120;
  fiat_p511_uint1 x121;
  uint64_t x122;
  fiat_p511_uint1 x123;
  uint64_t x124;
  fiat_p511_uint1 x125;
  uint64_t x126;
  uint64_t x127;
  uint64_t x128;
  uint64_t x129;
  uint64_t x130;
  uint64_t x131;
  uint64_t x132;
  uint64_t x133;
  fiat_p511_uint1 x134;
  uint64_t x135;
  uint64_t x136;
  uint64_t x137;
  uint64_t x138;
  uint64_t x139;
  uint64_t x140;
  uint64_t x141;
  uint64_t x142;
  uint64_t x143;
  uint64_t x144;
  fiat_p511_uint1 x145;
  uint64_t x146;
  fiat_p511_uint1 x147;
  uint64_t x148;
  fiat_p511_uint1 x149;
  uint64_t x150;
  fiat_p511_uint1 x151;
  uint64_t x152;
  fiat_p511_uint1 x153;
  uint64_t x154;
  fiat_p511_uint1 x155;
  uint64_t x156;
  fiat_p511_uint1 x157;
  uint64_t x158;
  fiat_p511_uint1 x159;
  uint64_t x160;
  fiat_p511_uint1 x161;
  uint64_t x162;
  uint64_t x163;
  uint64_t x164;
  uint64_t x165;
  uint64_t x166;
  uint64_t x167;
  uint64_t x168;
  uint64_t x169;
  uint64_t x170;
  fiat_p511_uint1 x171;
  uint64_t x172;
  fiat_p511_uint1 x173;
  uint64_t x174;
  fiat_p511_uint1 x175;
  uint64_t x176;
  fiat_p511_uint1 x177;
  uint64_t x178;
  fiat_p511_uint1 x179;
  uint64_t x180;
  fiat_p511_uint1 x181;
  uint64_t x182;
  fiat_p511_uint1 x183;
  uint64_t x184;
  fiat_p511_uint1 x185;
  uint64_t x186;
  fiat_p511_uint1 x187;
  uint64_t x188;
  fiat_p511_uint1 x189;
  uint64_t x190;
  fiat_p511_uint1 x191;
  uint64_t x192;
  fiat_p511_uint1 x193;
  uint64_t x194;
  fiat_p511_uint1 x195;
  uint64_t x196;
  fiat_p511_uint1 x197;
  uint64_t x198;
  fiat_p511_uint1 x199;
  uint64_t x200;
  fiat_p511_uint1 x201;
  uint64_t x202;
  fiat_p511_uint1 x203;
  uint64_t x204;
  fiat_p511_uint1 x205;
  uint64_t x206;
  uint64_t x207;
  uint64_t x208;
  uint64_t x209;
  uint64_t x210;
  uint64_t x211;
  uint64_t x212;
  uint64_t x213;
  uint64_t x214;
  uint64_t x215;
  uint64_t x216;
  uint64_t x217;
  uint64_t x218;
  uint64_t x219;
  uint64_t x220;
  uint64_t x221;
  uint64_t x222;
  uint64_t x223;
  uint64_t x224;
  uint64_t x225;
  uint64_t x226;
  uint64_t x227;
  uint64_t x228;
  uint64_t x229;
  uint64_t x230;
  fiat_p511_addcarryx_u64(&x1, &x2, 0x0, (~arg1), 0x1);
  x3 = (fiat_p511_uint1)((fiat_p511_uint1)(x1 >> 63) & (fiat_p511_uint1)((arg3[0]) & 0x1));
  fiat_p511_addcarryx_u64(&x4, &x5, 0x0, (~arg1), 0x1);
  fiat_p511_cmovznz_u64(&x6, x3, arg1, x4);
  fiat_p511_cmovznz_u64(&x7, x3, (arg2[0]), (arg3[0]));
  fiat_p511_cmovznz_u64(&x8, x3, (arg2[1]), (arg3[1]));
  fiat_p511_cmovznz_u64(&x9, x3, (arg2[2]), (arg3[2]));
  fiat_p511_cmovznz_u64(&x10, x3, (arg2[3]), (arg3[3]));
  fiat_p511_cmovznz_u64(&x11, x3, (arg2[4]), (arg3[4]));
  fiat_p511_cmovznz_u64(&x12, x3, (arg2[5]), (arg3[5]));
  fiat_p511_cmovznz_u64(&x13, x3, (arg2[6]), (arg3[6]));
  fiat_p511_cmovznz_u64(&x14, x3, (arg2[7]), (arg3[7]));
  fiat_p511_cmovznz_u64(&x15, x3, (arg2[8]), (arg3[8]));
  fiat_p511_addcarryx_u64(&x16, &x17, 0x0, 0x1, (~(arg2[0])));
  fiat_p511_addcarryx_u64(&x18, &x19, x17, 0x0, (~(arg2[1])));
  fiat_p511_addcarryx_u64(&x20, &x21, x19, 0x0, (~(arg2[2])));
  fiat_p511_addcarryx_u64(&x22, &x23, x21, 0x0, (~(arg2[3])));
  fiat_p511_addcarryx_u64(&x24, &x25, x23, 0x0, (~(arg2[4])));
  fiat_p511_addcarryx_u64(&x26, &x27, x25, 0x0, (~(arg2[5])));
  fiat_p511_addcarryx_u64(&x28, &x29, x27, 0x0, (~(arg2[6])));
  fiat_p511_addcarryx_u64(&x30, &x31, x29, 0x0, (~(arg2[7])));
  fiat_p511_addcarryx_u64(&x32, &x33, x31, 0x0, (~(arg2[8])));
  fiat_p511_cmovznz_u64(&x34, x3, (arg3[0]), x16);
  fiat_p511_cmovznz_u64(&x35, x3, (arg3[1]), x18);
  fiat_p511_cmovznz_u64(&x36, x3, (arg3[2]), x20);
  fiat_p511_cmovznz_u64(&x37, x3, (arg3[3]), x22);
  fiat_p511_cmovznz_u64(&x38, x3, (arg3[4]), x24);
  fiat_p511_cmovznz_u64(&x39, x3, (arg3[5]), x26);
  fiat_p511_cmovznz_u64(&x40, x3, (arg3[6]), x28);
  fiat_p511_cmovznz_u64(&x41, x3, (arg3[7]), x30);
  fiat_p511_cmovznz_u64(&x42, x3, (arg3[8]), x32);
  fiat_p511_cmovznz_u64(&x43, x3, (arg4[0]), (arg5[0]));
  fiat_p511_cmovznz_u64(&x44, x3, (arg4[1]), (arg5[1]));
  fiat_p511_cmovznz_u64(&x45, x3, (arg4[2]), (arg5[2]));
  fiat_p511_cmovznz_u64(&x46, x3, (arg4[3]), (arg5[3]));
  fiat_p511_cmovznz_u64(&x47, x3, (arg4[4]), (arg5[4]));
  fiat_p511_cmovznz_u64(&x48, x3, (arg4[5]), (arg5[5]));
  fiat_p511_cmovznz_u64(&x49, x3, (arg4[6]), (arg5[6]));
  fiat_p511_cmovznz_u64(&x50, x3, (arg4[7]), (arg5[7]));
  fiat_p511_addcarryx_u64(&x51, &x52, 0x0, x43, x43);
  fiat_p511_addcarryx_u64(&x53, &x54, x52, x44, x44);
  fiat_p511_addcarryx_u64(&x55, &x56, x54, x45, x45);
  fiat_p511_addcarryx_u64(&x57, &x58, x56, x46, x46);
  fiat_p511_addcarryx_u64(&x59, &x60, x58, x47, x47);
  fiat_p511_addcarryx_u64(&x61, &x62, x60, x48, x48);
  fiat_p511_addcarryx_u64(&x63, &x64, x62, x49, x49);
  fiat_p511_addcarryx_u64(&x65, &x66, x64, x50, x50);
  fiat_p511_subborrowx_u64(&x67, &x68, 0x0, x51, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_subborrowx_u64(&x69, &x70, x68, x53, UINT64_C(0xc2721bf457aca835));
  fiat_p511_subborrowx_u64(&x71, &x72, x70, x55, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_subborrowx_u64(&x73, &x74, x72, x57, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_subborrowx_u64(&x75, &x76, x74, x59, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_subborrowx_u64(&x77, &x78, x76, x61, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_subborrowx_u64(&x79, &x80, x78, x63, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_subborrowx_u64(&x81, &x82, x80, x65, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_subborrowx_u64(&x83, &x84, x82, x66, 0x0);
  x85 = (arg4[7]);
  x86 = (arg4[6]);
  x87 = (arg4[5]);
  x88 = (arg4[4]);
  x89 = (arg4[3]);
  x90 = (arg4[2]);
  x91 = (arg4[1]);
  x92 = (arg4[0]);
  fiat_p511_subborrowx_u64(&x93, &x94, 0x0, 0x0, x92);
  fiat_p511_subborrowx_u64(&x95, &x96, x94, 0x0, x91);
  fiat_p511_subborrowx_u64(&x97, &x98, x96, 0x0, x90);
  fiat_p511_subborrowx_u64(&x99, &x100, x98, 0x0, x89);
  fiat_p511_subborrowx_u64(&x101, &x102, x100, 0x0, x88);
  fiat_p511_subborrowx_u64(&x103, &x104, x102, 0x0, x87);
  fiat_p511_subborrowx_u64(&x105, &x106, x104, 0x0, x86);
  fiat_p511_subborrowx_u64(&x107, &x108, x106, 0x0, x85);
  fiat_p511_cmovznz_u64(&x109, x108, 0x0, UINT64_C(0xffffffffffffffff));
  fiat_p511_addcarryx_u64(&x110, &x111, 0x0, x93, (x109 & UINT64_C(0x1b81b90533c6c87b)));
  fiat_p511_addcarryx_u64(&x112, &x113, x111, x95, (x109 & UINT64_C(0xc2721bf457aca835)));
  fiat_p511_addcarryx_u64(&x114, &x115, x113, x97, (x109 & UINT64_C(0x516730cc1f0b4f25)));
  fiat_p511_addcarryx_u64(&x116, &x117, x115, x99, (x109 & UINT64_C(0xa7aac6c567f35507)));
  fiat_p511_addcarryx_u64(&x118, &x119, x117, x101, (x109 & UINT64_C(0x5afbfcc69322c9cd)));
  fiat_p511_addcarryx_u64(&x120, &x121, x119, x103, (x109 & UINT64_C(0xb42d083aedc88c42)));
  fiat_p511_addcarryx_u64(&x122, &x123, x121, x105, (x109 & UINT64_C(0xfc8ab0d15e3e4c4a)));
  fiat_p511_addcarryx_u64(&x124, &x125, x123, x107, (x109 & UINT64_C(0x65b48e8f740f89bf)));
  fiat_p511_cmovznz_u64(&x126, x3, (arg5[0]), x110);
  fiat_p511_cmovznz_u64(&x127, x3, (arg5[1]), x112);
  fiat_p511_cmovznz_u64(&x128, x3, (arg5[2]), x114);
  fiat_p511_cmovznz_u64(&x129, x3, (arg5[3]), x116);
  fiat_p511_cmovznz_u64(&x130, x3, (arg5[4]), x118);
  fiat_p511_cmovznz_u64(&x131, x3, (arg5[5]), x120);
  fiat_p511_cmovznz_u64(&x132, x3, (arg5[6]), x122);
  fiat_p511_cmovznz_u64(&x133, x3, (arg5[7]), x124);
  x134 = (fiat_p511_uint1)(x34 & 0x1);
  fiat_p511_cmovznz_u64(&x135, x134, 0x0, x7);
  fiat_p511_cmovznz_u64(&x136, x134, 0x0, x8);
  fiat_p511_cmovznz_u64(&x137, x134, 0x0, x9);
  fiat_p511_cmovznz_u64(&x138, x134, 0x0, x10);
  fiat_p511_cmovznz_u64(&x139, x134, 0x0, x11);
  fiat_p511_cmovznz_u64(&x140, x134, 0x0, x12);
  fiat_p511_cmovznz_u64(&x141, x134, 0x0, x13);
  fiat_p511_cmovznz_u64(&x142, x134, 0x0, x14);
  fiat_p511_cmovznz_u64(&x143, x134, 0x0, x15);
  fiat_p511_addcarryx_u64(&x144, &x145, 0x0, x34, x135);
  fiat_p511_addcarryx_u64(&x146, &x147, x145, x35, x136);
  fiat_p511_addcarryx_u64(&x148, &x149, x147, x36, x137);
  fiat_p511_addcarryx_u64(&x150, &x151, x149, x37, x138);
  fiat_p511_addcarryx_u64(&x152, &x153, x151, x38, x139);
  fiat_p511_addcarryx_u64(&x154, &x155, x153, x39, x140);
  fiat_p511_addcarryx_u64(&x156, &x157, x155, x40, x141);
  fiat_p511_addcarryx_u64(&x158, &x159, x157, x41, x142);
  fiat_p511_addcarryx_u64(&x160, &x161, x159, x42, x143);
  fiat_p511_cmovznz_u64(&x162, x134, 0x0, x43);
  fiat_p511_cmovznz_u64(&x163, x134, 0x0, x44);
  fiat_p511_cmovznz_u64(&x164, x134, 0x0, x45);
  fiat_p511_cmovznz_u64(&x165, x134, 0x0, x46);
  fiat_p511_cmovznz_u64(&x166, x134, 0x0, x47);
  fiat_p511_cmovznz_u64(&x167, x134, 0x0, x48);
  fiat_p511_cmovznz_u64(&x168, x134, 0x0, x49);
  fiat_p511_cmovznz_u64(&x169, x134, 0x0, x50);
  fiat_p511_addcarryx_u64(&x170, &x171, 0x0, x126, x162);
  fiat_p511_addcarryx_u64(&x172, &x173, x171, x127, x163);
  fiat_p511_addcarryx_u64(&x174, &x175, x173, x128, x164);
  fiat_p511_addcarryx_u64(&x176, &x177, x175, x129, x165);
  fiat_p511_addcarryx_u64(&x178, &x179, x177, x130, x166);
  fiat_p511_addcarryx_u64(&x180, &x181, x179, x131, x167);
  fiat_p511_addcarryx_u64(&x182, &x183, x181, x132, x168);
  fiat_p511_addcarryx_u64(&x184, &x185, x183, x133, x169);
  fiat_p511_subborrowx_u64(&x186, &x187, 0x0, x170, UINT64_C(0x1b81b90533c6c87b));
  fiat_p511_subborrowx_u64(&x188, &x189, x187, x172, UINT64_C(0xc2721bf457aca835));
  fiat_p511_subborrowx_u64(&x190, &x191, x189, x174, UINT64_C(0x516730cc1f0b4f25));
  fiat_p511_subborrowx_u64(&x192, &x193, x191, x176, UINT64_C(0xa7aac6c567f35507));
  fiat_p511_subborrowx_u64(&x194, &x195, x193, x178, UINT64_C(0x5afbfcc69322c9cd));
  fiat_p511_subborrowx_u64(&x196, &x197, x195, x180, UINT64_C(0xb42d083aedc88c42));
  fiat_p511_subborrowx_u64(&x198, &x199, x197, x182, UINT64_C(0xfc8ab0d15e3e4c4a));
  fiat_p511_subborrowx_u64(&x200, &x201, x199, x184, UINT64_C(0x65b48e8f740f89bf));
  fiat_p511_subborrowx_u64(&x202, &x203, x201, x185, 0x0);
  fiat_p511_addcarryx_u64(&x204, &x205, 0x0, x6, 0x1);
  x206 = ((x144 >> 1) | ((x146 << 63) & UINT64_C(0xffffffffffffffff)));
  x207 = ((x146 >> 1) | ((x148 << 63) & UINT64_C(0xffffffffffffffff)));
  x208 = ((x148 >> 1) | ((x150 << 63) & UINT64_C(0xffffffffffffffff)));
  x209 = ((x150 >> 1) | ((x152 << 63) & UINT64_C(0xffffffffffffffff)));
  x210 = ((x152 >> 1) | ((x154 << 63) & UINT64_C(0xffffffffffffffff)));
  x211 = ((x154 >> 1) | ((x156 << 63) & UINT64_C(0xffffffffffffffff)));
  x212 = ((x156 >> 1) | ((x158 << 63) & UINT64_C(0xffffffffffffffff)));
  x213 = ((x158 >> 1) | ((x160 << 63) & UINT64_C(0xffffffffffffffff)));
  x214 = ((x160 & UINT64_C(0x8000000000000000)) | (x160 >> 1));
  fiat_p511_cmovznz_u64(&x215, x84, x67, x51);
  fiat_p511_cmovznz_u64(&x216, x84, x69, x53);
  fiat_p511_cmovznz_u64(&x217, x84, x71, x55);
  fiat_p511_cmovznz_u64(&x218, x84, x73, x57);
  fiat_p511_cmovznz_u64(&x219, x84, x75, x59);
  fiat_p511_cmovznz_u64(&x220, x84, x77, x61);
  fiat_p511_cmovznz_u64(&x221, x84, x79, x63);
  fiat_p511_cmovznz_u64(&x222, x84, x81, x65);
  fiat_p511_cmovznz_u64(&x223, x203, x186, x170);
  fiat_p511_cmovznz_u64(&x224, x203, x188, x172);
  fiat_p511_cmovznz_u64(&x225, x203, x190, x174);
  fiat_p511_cmovznz_u64(&x226, x203, x192, x176);
  fiat_p511_cmovznz_u64(&x227, x203, x194, x178);
  fiat_p511_cmovznz_u64(&x228, x203, x196, x180);
  fiat_p511_cmovznz_u64(&x229, x203, x198, x182);
  fiat_p511_cmovznz_u64(&x230, x203, x200, x184);
  *out1 = x204;
  out2[0] = x7;
  out2[1] = x8;
  out2[2] = x9;
  out2[3] = x10;
  out2[4] = x11;
  out2[5] = x12;
  out2[6] = x13;
  out2[7] = x14;
  out2[8] = x15;
  out3[0] = x206;
  out3[1] = x207;
  out3[2] = x208;
  out3[3] = x209;
  out3[4] = x210;
  out3[5] = x211;
  out3[6] = x212;
  out3[7] = x213;
  out3[8] = x214;
  out4[0] = x215;
  out4[1] = x216;
  out4[2] = x217;
  out4[3] = x218;
  out4[4] = x219;
  out4[5] = x220;
  out4[6] = x221;
  out4[7] = x222;
  out5[0] = x223;
  out5[1] = x224;
  out5[2] = x225;
  out5[3] = x226;
  out5[4] = x227;
  out5[5] = x228;
  out5[6] = x229;
  out5[7] = x230;
}
#else
typedef int no_empty_translation_units_asm_511; // -> "warning: ISO C forbids an empty translation unit"
#endif
